2004-12-30  Adam Fedor  <fedor@gnu.org>

	* Headers/Foundation/NSGeometry.h (NSContainsRect): Change behavior
	to match Cocoa (sides of rects CAN touch).

2004-12-26  Adam Fedor  <fedor@gnu.org>

	* Add support for systems that support unichar file paths (e.g.
	Windows).
	* Headers/Foundation/NSFileManager.h (-localFromOpenStepPath:,
	_openStepPathFromLocal:): New methods.
	(NSDirectoryEnumerator): Updated ivars.
	* Source/NSFileManager.m: Idem.
	(-changeCurrentDirectoryPath, changeFileAttributes:, 
	currentDirectoryPath, etc): Update for Windows unichar paths.
	* Headers/Foundation/NSString.h: (-unicharString,
	-localFromOpenStepPath:, _openStepPathFromLocal:): New methods.
	* Source/NSString.m: Idem.
	* Source/GSFileHandle.m (-initForReadingAtPath:, 
	-initForWritingAtPath, -initForUpdatingAtPath:): Update for Windows
	unichar paths.
	* Source/NSData.m (readContentsOfFile, -writeToFile:,
	initWithContentsOfMappedFile:): Idem.
	* Source/NSTask.m (NSConcreteWindowsTask): Update for Windows
	unichar paths.
	(Patch from Roland Schwingle <roland.schwingel@onevision.de>)
	
2004-12-28 Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/gdnc.m: Change name of dummy class to avoid Darwin linker
	problems.
	* Testing/nsundomanager.m: Trivial test added

2004-12-21  Adam Fedor  <fedor@gnu.org>

	* Source/NSTimeZone (NSInternalAbbrevDict): Remove class
	(+abbreviationDictionary): Implement from new one-to-one plist.
	* NStimeZones/NSTimeZone.tar: Added abbreviations.plist. Regenerated.
	* Testing/nstimezone.m: New tests.

	* Source/Additions/GNUmakefile: Remove duplicate Unicode.m.

2004-12-21  David Wetzel <dave@turbocat.de>

	* Source/Additions/GNUmakefile:
	Added Additions_OBJC_FILES += Unicode.m on apple

2004-12-18  David Wetzel <dave@turbocat.de>

        * Source/Additions/GSCategories.m ([NSMutableString
        -replaceString:withString:]): Rewrite to work again.
        [tmp replaceString:@"&" withString:@"&amp;"]; Did NOT work.

2004-12-12  Adam Fedor  <fedor@gnu.org>

	* Changes so additions compiles on older Mac OS X 10.1.5
	* Source/Additions/GCArray.m (-copyWithZone:): Use more standard
	array initialization method.
	(mutableCopyWithZone:,	[GCMutableArray -copyWithZone:], 
	[GCMutableArray -mutableCopyWithZone:]): Idem.
	
	* Source/Additions/GSCategories.m ([NSData -hexadecimalRepresentation]):
	Use identically functioning, but older, standard data initialization.
	* Source/Additions/GSCategories.m ([NSMutableString 
	-replaceString:withString:]): Rewrite to use older, standard 
	methods.

	* Tools/AGSHtml.m ([AGSHtml -outputNode:to:]): Use GNUstep addition
	method to replace string.
	* Tools/autogsdoc.m (main): Idem.
	(Patch from Markus Hitter).

2004-12-12  Adam Fedor  <fedor@gnu.org>

	* configure.ac: Avoid improper use of -fXXX-runtime. Add -x objective-c
	when testing Objective-C programs (Followup for bug #11188).

2004-12-09  Matt Rice  <ratmice@yahoo.com>

	* Source/NSUndoManager.m 
	([-forwardInvocation,-registerUndoWithTarget:selector:object:): Don't
	clear the redo stack if redoing.
	
2004-12-07  Adam Fedor  <fedor@gnu.org>

	* configure.ac: Test for objc forwarding by compiling a program.
	* config/config.forward.m: New file.
	(Fixes bug #11188).

	* Source/GSFormat.m (GSFormat): Assign wchar via var args from an
	int (Fixes bug #10950).

	* Testing/string.m: Tests for standardizing path.
	
2004-12-01 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSCalendarDate.m: Fix off-by-one bug resulting in printout
	for december being numeric with '%b' format.
	Reported by Ludovic

2004-11-30  Adam Fedor  <fedor@gnu.org>

	* Source/GSFileHandle.m (-setNonBlocking:): Set the isNonBlocking
	ivar on MingW. Fixes bug #10742.

2004-11-30  Matt Rice  <ratmice@yahoo.com>
	
	* Source/NSBundle.m (-principalClass): If the class specified in
	NSPrincipalClass key is not found return the first class found.
	* Headers/Foundation/NSBundle.h (-principalClass): Document the above.

2004-11-29  Adam Fedor  <fedor@gnu.org>

	* configure.ac: Check for libffi or callback/avcall libs
	(Patch from Matt Rice). Fixes bug #11134.

2004-11-25 Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/gdomap.c: make respond to --help as to -H
	* Source/NSConnection.m: ([_threadWillExit:]) change to be a class
	method rather then instance method.  Implement removeal of runloop
	of exiting thread unconditionally from all threads...
	the code in [removeRunLoop:] is safely lock protected.
	Use GSRunLoopForThread() for performance throughout.

2004-11-24 15:08  Patrick McFarland  <unknown@panax.com>

	* configure.ac: Change "doesn't" to "does not" in an error message to
	avoid autoconf/m4 quoting issues.
	* configure: Regenerate.

2004-11-23 David Wetzel <dave@turbocat.de>

        * Headers/Additions/GNUstepBase/Unicode.h: added missing 
        #include "GSObjCRuntime.h"

2004-11-23 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSProcessInfo.m:
	* Source/NSUserDefaults.m:
	Improve documentation of --GNU-Debug=...

2004-11-22 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSPropertyList.m: Initialise harmless uninitialised variable
	to avoid compiler warning in
	([propertyListFromData:mutabilityOption:format:errorDescription:])
	fixing bug report #11093
	* Source/NSMessagePort.m: ifndef toi fix harmless compiler warning
	reported as bug #11092
	* NSNotificationCenter.[hm]: Remove non-functional setImmutableInPost
	method to fix bug report #11080

2004-11-20 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSBundle.m: Fix to ensure that a main bundle exists.
	Fix to get -executablePath for the main bundle to return the
	path to the executable.
	* Tools/gdnc.m: In order to avoid problems on BSD when using the pth
	library to do threading, we need to fork, close descriptors, and
	then exec the program again, since closing descriptors messes up
	the threading library.

2004-11-19 Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/pl.m: Make code conform to gnu coding standards.
	* Source/NSRunLoop.m: ([runMode:beforeDate:]) add autorelease pool
	to retain old behavior where anything inside a runloop is
	automatically in the scope of an autorelease pool, and will not
	be leaked by autoreleasing.  Fixes obscure problems with the last
	limitDateForMode changes.

2004-11-18 Gregory John Casamento <greg_casamento@yahoo.com>

	* Tools/pl.m: Added a tool I wrote a while back which is an 
	implementation of the pl command (as it is on Mac OS X and 
	OPENSTEP).
	
2004-11-11  Adam Fedor  <fedor@gnu.org>

	* Headers/Foundation/NSBundle.h (builtInPlugInsPath): New method.
	* Source/NSBundle (builtInPlugInsPath): Imeplement (based on patch 
	#3483).

2004-11-10 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSThread.m: Retain the notification center we use.
	* Source/NSNotificationCenter.m: Raise exception if anything
	tries to destroy the default center.

2004-11-04  Adrian Robert  <arobert@cogsci.ucsd.edu>
	* Source/NSRunLoop.m (limitDateForMode:) Correction to housekeeper
	timer logic so event polling times out within reasonable time.
	Patch by Alexander Malmberg <alexander@malmberg.org>.

2004-11-04  Georg Fleischmann
	* Headers/Foundation/NSTimeZone.h, Source/NSTimeZone.m
	(+knownTimeZoneNames:): New method.

2004-11-03 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSThread.m: Revert change from september to fix memory
	leak ... Enrico says it broke some of his GSWorkspace code.
	Will have to find a better fix ... ensure we don't leak autorelease
	pools by repeatedly initalising thread autorelease variables.

2004-11-01 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSFormat.h: Moved around includes somewhat so that the
	order matches those in the autoconf test for HANDLE_LONG_LONG_MAX
	and we should therefore get LONG_LONG_MAX defined consistently.

2004-10-31 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUserDefaults.m: ([setObject:forKey:]) when given a nil
	value to set, remove any existing object for the key.  Fix for
	MacOS-X compatibility (bug #10743).
	* Source/Additions/GSXML.m: Tweaks for 64-bit processors where
	sizeof int is not sizeof void*
	Minor optimisaion ... improve hash values.

2004-10-29  Matt Rice  <ratmice@yahoo.com>

	* Source/Additions/GSObjCRuntime.m (GSObjCAllSubclassesOfClass,
	GSObjCDirectSubclassesOfClass): skip meta classes.

2004-10-28  Adam Fedor  <fedor@gnu.org>

	* Version 1.10.1

	* Source/Makefile.postamble (Info-gnustep.plist): Add some 
	compatibility keys.

2004-10-26  Adam Fedor  <fedor@gnu.org>

	* configure.ac: Standardize order of flags and libs
	Check for proper defs in tzfile.h. Add sub-configure options
	so they are listed in help. Add generic include/lib flags option.
	* config.mak.in: Add load flags variable
	* base.make.in: Idem.
	* SSL/configure.ac: Add generic include/lib flags option.

	* Version: Add numeric value for runtime versioning.
	* Souce/GNUmakeifle: Add resource set install
	* Source/Makefile.postamble (Info-gnustep.plist): New target.
	* Testing/nsbundle.m: Additional tests.

	* Source/NSTimeZone.m: Check for proper tzfile defs (Fixes #10724).

2004-10-24 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSDistributedNotificationCenter.m: Changed to explicitly
	use a socket port name server for network wide notifications.
	* Source/Additions/GSXML.m: Added ([-abortParser])
	* Source/NSXMLParser.m: Use new abort method.

2004-10-21  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSPropertyList.m (GSBinaryPLParser objectAtIndex:):
	Changed integer handling to unsigned long long to support bigger numbers.

2004-10-20 Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/Foundation.h: include NSXMLParser
	* Headers/Foundation/NSXMLParser.h: MacOS compatibility class
	* Source/DocMakefile: Add NSXMLParser
	* Source/GNUmakefile: Add NSXMLParser
	* Source/NSXMLParser.m: Wrap some GSXML functionality for compatibility.
	* Testing/GNUmakefile: Add nsxmlparser
	* Testing/nsxmlparser.m: Trivial/basic test for parser
	Committed the work I did back in May as there have been several
	expressions of interest.  I haven't had time to do work on this
	and consider the code pre-alpha.  Reaching full MacOS-X compatibility
	may require minor extension to GSXML.

2004-10-17  Matt Rice <ratmice@yahoo.com

	* Source/objc-load.m (objc_load_module): resolve class links under GNU
	runtime
	* Headers/Additions/GNUstepBase/GSObjCRuntime.h 
	* Source/Additions/GSObjCRuntime.m	
	(GSObjCAllSubclassesOfClass,GSObjCDirectSubclassesOfClass): 
	New functions.

2004-10-05  Georg Fleischmann

	* Source/NSCalendarDate.m [-initWithString:] Revert to previous
	  code, and try to load time zone abbreviation from name first.

2004-10-15 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSHTTPURLHandle.m: Don't expect a body where status is 204
	or 304

2004-10-13  Adam Fedor  <fedor@gnu.org>

	* Source/NSBundle.m (_bundle_name_first_match): Remove path
	extension when comparing name (fixes #10611)

2004-10-13 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSXML.m: Fix bug escaping XML special chartacters.

2004-10-11 Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/defaults.m: fix for domains and default names contaning
	spaces.

2004-10-10  Adam Fedor  <fedor@gnu.org>

	* configure.ac:  Check for tzfile.h
	* Source/NSTimeZone.m: Include system tzfile.h if found.
	(abbreviationMap): Add abbreviation from systemTimeZone if not
	already there.
	(systemTimeZone): Update the search list to look for time zone in TZ,
	then system location, then tznam.
	(getTimeZoneFile:): Look for file in system directory first.
	* Source/nstzfile.h: Renamed from tzfile.h

2004-10-09  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSPropertyList.m: 
	Corrected implementation of class GSBinaryPLParser to support more
	features of binary property lists. Based on information by
	Gerriet M. Denkmann <gerriet@mdenkmann.de>.
	* Source/NSAttributedString.m (-initWithCoder:):
	* Source/NSNumberFormatter.m (-initWithCoder:): Implemented keyed decoding.
	
2004-10-05  Adam Fedor  <fedor@gnu.org>

	* Source/Makefile.postamble (libgnustep-base.def): Search for both
	T and R symbols to work with multiple mingw/cygwin flavors.

2004-10-05 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSGategories.m: make whitespace test safe for
	unicode characters.

2004-10-04 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSHTTPURLHandle.m: Fix premature end of read where no
	content length is specified.

2004-10-03 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSXML.m: Add methods for converting XML escape
	sequences in NSStrings.
	* NSTimeZones/NSTimeZones.tar: updated

2004-10-02 Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Additions/GNUstepBase/unicode/gsm0338.h:
	Add mapping for lossy conversion of right-single0quotation-mark
	to apostrophe.

2004-10-01  Adam Fedor  <fedor@gnu.org>

	* Documentation/HtmlNav/docs-web.html,
	Documentation/HtmlNav/index.html: Update pointers.
	* Source/DocMakefile (before-clean, after-clean): Move obj out of the
	way so it isn't removed when cleaning docs.
	* Tools/DocMakefile: Idem.

2004-09-29 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSNotificationCenter.m: ([_postAndRelease:]) lock table
	while emptying array of observers to prevent another thread from
	changing things at the same time.

2004-09-27 23:26  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSDistantObject.m: Make proxyLocation an enum tag, not a
	variable.
	* Source/NSFileManager.m (custom_strdup, append_file_to_path): Make
	static.
	* Source/NSString.m (-isEqual:): Clarify documentation.
	* Source/NSUnarchiver.m (mapClassObject, mapClassName): Make static.
	* Source/Additions/Unicode.m (GetDefEncoding): Add missing void in
	the prototype.
	* Tools/make_strings/make_strings.m (ParseFile): Remove spurious
	static on the nested function add_arg_ch.

2004-09-27 15:51  Alexander Malmberg <alexander@malmberg.org>

	* configure.ac:	Change SO_REUSADDR to SO_REUSEADDR in the checking
	message. Reported by Alex Perez.
	* configure: Regenerate.

2004-09-27 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSDebug.m: Remove checks for existence of lock ... it always
	exists, so the checks are useless.
	* Source/NSThread.m: Refrain from creating thread dictionary in an
	inactive thread ... we don't want to create new objects in a thread
	which is in the process of exiting.  Also, improve documentation.

2004-09-24 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSArray.m: Make perform methods enumerate forwards.
	* Source/Additions/GSXML.m: ([nodeAtIndex:]) fix memory leak.
	* Source/GSHTTPURLHandle.m: Re-instate change to try to provide
	better support for connections kept alive.

2004-09-22 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSHost.m: Use isEqualToString rather than == to test for
	the special local host name.  Fix check for nil hostname in
	([_initWithHostEntry:key:])

2004-09-21 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSConnection.m: ([_getReplyRmc:]) improve timeout code.

2004-09-20 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSProxy.m: minor hash optimisation

2004-09-19  Adrian Robert  <arobert@cogsci.ucsd.edu>

	* Headers/Foundation/NSCoder.h
	* Headers/Foundation/NSFileHandle.h
	* Headers/Foundation/NSKeyValueCoding.h
	* Headers/Foundation/NSObject.h
	* Headers/Foundation/NSSet.h
	* Source/NSKeyValueCoding.m
	* Source/NSSet.m: Comment cleanups to improve documentation output
	and cross-referencing.
	* Documentation/manual/GSDoc.texi: Add more complete description of
	cross-referencing.

2004-09-19  Adrian Robert  <arobert@cogsci.ucsd.edu>

	* Headers/Foundation/NSBundle.h
	* Headers/Foundation/NSConnection.h
	* Headers/Foundation/NSDistributedNotificationCenter.h
	* Headers/Foundation/NSPort.h
	* Headers/Foundation/NSTask.h
	* Headers/Foundation/NSThread.h
	* Headers/Foundation/NSURL.h
	* Headers/Foundation/NSUndoManager.h
	* Source/NSDistributedNotificationCenter.m
	* Source/NSTask.m
	* Source/NSURL.m
	* Source/NSUndoManager.m
	* Source/externs.m: Declare constant strings as constant, and move
	values from source files into externs.m .

2004-09-19  Adrian Robert  <arobert@cogsci.ucsd.edu>

	* Tools/AGSOutput.h
	(informalProtocols): New array to accumulate informal protocols
	discovered during processing.
	* Tools/AGSOutput.h
	(outputUnit:to:): Accumulate informal protocols found here.
	* Tools/AGSIndex.h
	(addInformalProtocols:): New method to copy informal protocol refs.
	* Tools/AGSIndex.m
	(addInformalProtocols:): New method.
	(unitRef:type:unit:): Return unit including category for category
	methods.
	* Tools/AGSHtml.h: Add declaration of existing outputIndex.. method.
	* Tools/AGSHtml.m
	(makeLink:ofType:inUnit:isRef:)
	(outputIndex:scope:title:style:target:to:): Make proper references for
	informal protocols.
	* Tools/autogsdoc.m: Send informal protocols found by AGSOutput to
	AGSIndex.

2004-09-16 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSArray.m:
	Make objects perform selector in same order as MacOS-X

2004-09-16  David Ayers  <d.ayers@inode.at>

	* Headers/Additions/GNUstepBase/GSObjCRuntime.h: Define encoding
	macros for the NeXT runtime.

	* Source/Additions/GSObjCRuntime.m
	(GSAppendMethodToList): Copy type information.
	(GSRemoveMethodFromList): Add comment about potential minor leak.
	
2004-09-14 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSDateFormatter.m:
	* Source/NSNumberFormatter.m:
	Tolerate being given null pointers to return values in.
	* Tools/gdomap.c: Try both short and long forms of local host name.
	Report host name used when gethostbyname() fails.

2004-09-13  Adrian Robert  <arobert@cogsci.ucsd.edu>

	* Tools/gsdoc-1_0_1.rnc: Added usage information.
	* Tools/GNUMakefile: Install it.
	* Tools/gdomap.8: Refer user to HTML documentation for more info.
	* Tools/autogsdoc.m: Be willing to parse .c files.
	* Tools/autogsdoc.1: Document that.
	* Tools/gdomap.c: Add comment to main so autogsdoc picks up as tool.
	* Tools/gdomap/gsdoc: New file - docs for gsdoc are actually here,
	taken from gdomap.h (not readily usable there by gsdoc).
	* Tools/DocMakefile: Include gdomap in docbuild.
	* Tools/BaseTools.gsdoc: Add gdomap to main TOC.

2004-09-10  David Ayers  <d.ayers@inode.at>

	* Source/NSArray.m: Consistently terminate macros with semicolons.
	(arrayByAddingObjectsFromArray)
	(removeObjectsFromIndices:numIndices:): Insure all declarations
	precede statements.
	* Source/NSDictionary.m: Consistently terminate macros with
	semicolons.
	* Source/NSSet.m (initWithCoder:): Insure all declarations precede
	statements.
	
2004-09-09 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSString.m: Implement init for GSPlaceHolderString
	to return an empty inline unicode string.

2004-09-07  Adam Fedor  <fedor@gnu.org>

	* Documentation/HtmlNav/docs-web.html: Update to work with current
	web structure.

2004-09-07 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSSet.m: Fix possible stack overflows.
	* Source/GSSet.m: ([allObjects]) Fix stack overflow for large sets.
	* Source/NSTask.m: Fix error testing for task which has been lost.
	* Source/NSArray.m: Fix possible stack overflows
	* Source/NSTimer.m: Log uncaught exceptions when timer fires.
	Thanks to Andre Levey for reporting these.

2004-09-07 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSArray.m:
	* Source/NSDictionary.m:
	* Source/NSSet.m:
	* Source/NSString.m:
	Changes to designated initiailiser stuff for MacOS-X compatibility.
	Call -init to maintain the chain from subclasses to superclasses,
	but document the 'designated initialisers' as being the richer methods
	which may be used in GNUstep to make all the other initialisers work.

2004-09-04  Adam Fedor  <fedor@gnu.org>

	* Version 1.10.0

	* Source/GNUmakefile: Define INTERFACE_VERSON explicitly.

2004-09-02  David Ayers  <d.ayers@inode.at>

	* Headers/Additions/GNUstepBase/GSObjCRuntime.h
	(GS_ATTRIB_DEPRECATED): New macro to use for deprecation attribute
	which can be deactivated for older compilers.
	
2004-09-03 19:08  Alexander Malmberg <alexander@malmberg.org>

	* Tools/gdnc.m
	(-addObserver:selector:name:object:suspensionBehavior:for:): Fix
	string reuse.
	(-postNotificationName:object:userInfo:deliverImmediately:for:):
	Make sure queued notifications are always released. Don't release
	obs.

2004-09-02  David Ayers  <d.ayers@inode.at>

	* Source/GSFFCallInvocation.m
	* Source/GSFFIInvocation.m (gs_protocol_selector): Skip '-' for
	negative offsets to avoid issues with pre gcc 3.4 generated
	signatures.
	
2004-08-26  Adam Fedor  <fedor@gnu.org>

	* Source/NSProcessInfo.m ([NSProcessInfo +load]): Get environment
	variables via environ even #ifdef HAVE_KVM (fix/based on #10113).

2004-08-26 Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSURLHandle.h:
	* Source/GSHTTPURLHandle.m:
	* Source/NSURLHandle.m: Fix property key names
	* Source/NSString.m: copy and autorelease potentially mutable strings
	before returning them.
	* Headers/Foundation/NSString.h: Document policy and warnings about
	lifetime and mutablity of strings returned from methods.

2004-08-25  Adrian Robert  <arobert@cogsci.ucsd.edu>

	* Documentation/HtmlNav/index.html:
	* Documentation/HtmlNav/style.css:
	* Documentation/HtmlNav/gnustep-header.png:
	* Documentation/HtmlNav/gnustep-header14.jpg:
	* Documentation/HtmlNav/masthead-bg.jpg: Changed local HTML docs
	overview page  to use same graphics as web site and a subset of its
	stylesheet.
	* Documentation/Makefile.postamble: Changed install accordingly.
	* Documentation/HtmlNav/docs-web.html: Added this file to be used as
	overview page for HTML docs when presented on gnustep.org web site.
	* Headers/Foundation/NSMethodSignature.h: Fixed unclosed tag typo in
	comment that was stopping docs from being generated.

2004-08-25 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSMime.m: Accept iso-10646-ucs-2

2004-08-25 Fred Kiefer <FredKiefer@gmx.de>

	* Tools/make_strings/GNUmakefile: Include config.mak to be
	consistent with the other base makefiles. Without this cross
	compliation failed for this subproject.

2004-08-24  David Ayers  <d.ayers@inode.at>

	* Source/NSScanner.m: Define _GNU_SOURCE before including other
	headers.

2004-08-24 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSPropertyList.m: Always write date using GMT timezone for
	consistency.  Make XML representation MacOS-X compatible.
	* Source/NSIndexSet.m: ([getIndexes:maxCount:inIndexRange:]) accept
	null pointer for index range.  Consistent with undocumented MacOS-X
	feature (but we document it).
	* Headers/Additions/GNUstepBase/DistributedObjects.h:
	* Source/NSConnection.m:
	* Source/NSMessagePort.m:
	* Source/NSSocketPort.m: Use new ([-conversation:]) method to
	obtain handle for specific network link in use by a connection,
	and invalidate it when the connection is iunvaliodated.
	Fixes bug #9798
	* Headers/Foundation/NSURLHandle.h:
	* Source/GSHTTPURLHandle.m:
	* Source/NSURLHandle.m: Add new property keys for setting certificate
	information for https. Stopgap until we can clone newer MacOS-X
	features.  Add support for persistent connections for better
	performance when posting repeatedly to the same server.

2004-08-23 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSMime.m: Add content location methods.

2004-08-22 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSString.m: Various minor optimisations ... uppercaseString
	and lowercaseString no longer create a new object if no change is
	needed.  Avoid unnecessary calls by using method variants with
	range arguments if we already know the length of the string.

2004-08-20 Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/AGSParser.m: Destory comments after skipping units ...
	we don't want them included as part of the documentation of the
	next thing after the unit.
	Recognize __attribute__((deprecated)) and add a comment.
	Fix scope of instance variables ... protected by default.

2004-08-20  David Ayers  <d.ayers@inode.at>

	* Headers/Foundation/NSMethodSignature.h: 
	(NSArgumentInfo): Document limitations of NSArgumentInfo's offset
	and registier information.  Match size for NO_GNUSTEP.
	(NSMethodSignature): Match ivar name with runtime information.
	
	* Source/GSFFCallInvocation.m
	* Source/GSFFIInvocation.m
	* Source/NSInvocation.m
	(gs_method_for_receiver_and_selector)
	([-invokeWithTarget:]): Use GSGetMethod instead of deprecated
	GSGetInstanceMethod and GSGetClassMethod.
	* Source/NSConnection.m ([-_service_typeForSelector]): Ditto.
	* Source/NSDistantObject.m ([+respondsToSelector]): Ditto.
	* Source/NSObject.m ([+instanceMethodSignatureForSelector:])
	([-methodSignatureForSelector:])
	([+descriptionForInstanceMethod], [-descriptionForMethod]): Ditto.
	* Source/NSProtocolChecker.m ([-methodSignatureForSelector]): Ditto.
	* Source/NSProxy.m ([+methodSignatureForSelector])
	([-methodSignatureForSelector]): Ditto.
	
	* Headers/Additions/GNUstepBase/GSObjCRuntime.h
	(GSFindInstanceVariable, GSGetVariable, GSSetVariable)
	(GSGetValue, GSSetValue, GSObjCName, GSObjCSelectorName)
	(GSObjCSelectorTypes, GSGetInstanceMethod, GSGetClassMethod)
	(GSGetInstanceMethodNotInherited, GSGetClassMethodNotInherited):
	Add deprecation markers.
	
	* Source/Additions/GSObjCRuntime.m (GSSelectorTypesMatch):
	Ignore structure names.
	* Testing/nsmethodsignature.m: Added test for nested structures.
	Reactivated test for signatures from older gcc versions.
	
2004-08-19  David Ayers  <d.ayers@inode.at>

	* Headers/Additions/GNUstepBase/GSObjCRuntime.h
	* Source/Additions/GSObjCRuntime.m (GSSelectorTypesMatch):
	New Function.
	(gs_skip_type_qualifier_and_layout_info): Ditto.

	* Source/callframe.m (callframe_do_call): Use GSSelectorTypesMatch
	instead of sel_types_match.
	* Source/cifframe.m (cifframe_do_call): Ditto.
	* Source/mframe.m (mframe_do_call): Ditto.

	* Source/GSFFCallInvocation.m (GSInvocationCallback): Use
	NSDebugFLog to NSWarnFLog.
	* Source/GSFFIInvocation.m (GSFFIInvocationCallback): Ditto.

	* Testing/nsmethodsignature.m: Use GSSelectorTypesMatch instead of
	sel_types_match.  Test it.
	
2004-08-18  David Ayers  <d.ayers@inode.at>

	* Testing/nsmethodsignature.m: Add more testing utilities.
	
2004-08-18 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSFileHandle.m: Add methods to get local socket info
	matching mthe existing methods which return remote address/port.
	* Source/GSFileHandle.m: ditto.

2004-08-17  David Ayers  <d.ayers@inode.at>

	* Testing/GNUmakefile: Reactivate nsinvocation test.
	* Testing/nsmethodsignature.m
	(large/smallStruct_id:uchar:ushort:uint...): Correct name.
	(void_float:double:): New test.
	(void_double:float:): New test.

2004-08-17 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSPort.m, Source/NSPortNameServer.m: Fix port type
	selection for windows.

2004-08-11 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSPropertyList.m: don't escape single quotes unnecessarily.
	* Source/NSObject.m: (hash) tweak performance a little.

2004-08-07 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSPort.m (+initialize), Source/NSPortNameServer.m
	(systemDefaultPortNameServer): We should be using message ports
	when we are supposed to be MacOS-X compatible anyway, so check the
	runtime compatibility setting.  Maybe we should be thinking about
	changing away from the OpenStep behavior as default, and put a
	warning into the next release?

2004-08-07 02:26  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSPort.m (+initialize), Source/NSPortNameServer.m
	(systemDefaultPortNameServer): Check the NSPortIsMessagePort to
	get the default port class.
	* Tools/gdnc.m (-init): Comment on some dead code.

2004-05-30 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSMime.m: When using non-ascii default characterset
	ensure that the content type header has the appropriate
	charset parameter added during parsing, so unparsing will
	work correctly.

2004-08-05 01:59  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSDistantObject.m (DO_FORWARD_INVOCATION): Warning if we
	can't do the forwarding.
	(-methodSignatureForSelector:): If a protocol has been set but
	doesn't contain info about the selector, forward the request to
	the other end of the connection.

2004-08-04  David Ayers  <d.ayers@inode.at>

	* Testing/nsmethodsignature.m: New test.
	* Testing/GNUmakefile: Add new test.
	
2004-08-02  Adrian Robert  <arobert@cogsci.ucsd.edu>

	* Headers/Foundation/*.h: Some fixes and cleanups to 2004-07-20
	documentation changes recommended by Alexander Malmberg.
	* Tools/AGSHtml.m: Change default doc font to 'serif': it's simple and
	provides end viewers greater latitude for using their own preferred
	font.

2004-07-30 23:33  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSPropertyList.m (parseQuotedString): Handle utf8 data
	properly.
	(GSPropertyListFromStringsFormat): Convert the string to utf8 data,
	not ascii. Set length from the data.
	(+propertyListFromData:mutabilityOption:format:errorDescription:): Fix
	a typo in an error message. Set format for normal plist with
	extensions to NSPropertyListGNUstepFormat.
	* Source/NSString.m (-propertyList): Convert the string to utf8 data,
	not ascii.

2004-07-20  Adrian Robert  <arobert@cogsci.ucsd.edu>

	* Headers/Foundation/*.h: Completed documentation of functions, types,
	constants, and variables.
	* Source/*.m: Same.
	* Tools/gsdoc-1_0_1.rnc: New file.  Relax-NG version of the GSdoc
	DTD.  This can be used in conjunction with Emacs nxml-mode to edit
	GSdoc XML source with realtime validation and schema-guided completion.

2004-07-29  Matt Rice  <ratmice@yahoo.com>
	    David Ayers  <d.ayers@inode.at>

	* Headers/Additions/GNUstepBase/GSObjCRuntime.h
	* Source/Additions/GSObjCRuntime.m: Make ObjC++ safe.
	(GSObjCSuper, GSObjCIsKindOf, GSNameFromClass)
	(GSTypesFromSelector, GSGetMethod, GSFlushMethodCacheForClass)
	(GSCGetInstanceVariableDefinition)
	(GSObjCGetInstanceVariableDefinition)
	(GSMethodListForSelector, GSAddMethodList, GSRemoveMethodList)
	(GSObjCVersion, GSObjCName, GSObjCSelectorName)
	(GSObjCSelectorTypes, GSGetInstanceMethod, GSGetClassMethod)
	(GSGetInstanceMethodNotInherited, GSGetClassMethodNotInherited)
	(search_for_method_in_class, GSObjCAddMethods): Replace class and
	this with cls or sel.

2004-07-29 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSAutoreleasePool.m: ([emptyPool]) reset _released ivar
	suggested by Cristobal Castillo

2004-07-28  Willem Rein Oudshoorn  <Wim.Oudshoorn@agilisys.com>

	* Source/GSFileHandle.m ([GSFileHandle -gcFinalize]): if __MINGW__ also
	close ordinary file descriptor, not only the socket.
	([GSFileHandle -closeFile]): in __MINGW__ defined block:
	changed test of !isStandardFile to isSocket, and make sure that the
	ordinary file descriptor is also closed.
	
2004-07-22 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSPropertyList.m: don't escape tab,cr,lf in output of old
	style property lists.

2004-07-21  David Ayers  <d.ayers@inode.at>

	* Source/Additions/GSObjCRuntime.m
	(gs_revert_selector_names_in_list): New function.
	(GSRemoveMethodList): Also revert selectors for first list.
	
2004-07-20  Adrian Robert  <arobert@cogsci.ucsd.edu>

	* Tools/autogsdoc.m: Add 'Protocols' index to upper left index panel
	in HTML frames docs.

2004-07-15 Mateu Batle <mateu.batle@tragnarion.com>

	* Source/GSLocale.m: Patch to use locale when no langinfo available

2004-07-15 Richard Frith-Macdonald <rfm@gnu.org>

	* NSTimeZones/NSTimeZones.tar: regenerated

2004-07-14  Adam Fedor  <fedor@gnu.org>

	* configure.ac: Use generic -with-ffi-{include,library} for finding
	ffi libraries.

2004-07-13  Andrew Ruder <aeruder@ksu.edu>

	* Source/NSMessagePort.m, Source/NSSocketPort.m: Use memmove instead
	of memcpy for potentially overlapping moves.

2004-07-10 Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/cvtenc.m: Use uppercase 'U' rather than 'u' in unicode
	escape sequences.

2004-07-09  Adam Fedor  <fedor@gnu.org>

	* Source/NSFileManager.m ([GSAttrDictionary
	-fileGroupOwnerAccountName]): Remove Solaris warning - no longer
	necessary.

2004-07-06 Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/AGSHtml.h: Fix printf missing argument bug.

2004-07-05 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/Unicode.m: GSToUnicode() be strict about
	converting ASCII to unicode.
	(GetDefEncoding): Don't override default (latin1) encoding to be
	ascii if we only have the return value of nl_langinfo() to go on.

2004-07-04 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSString.m: Added two new methods from MacOS-X
	([stringByAddingPercentEscapesUsingEncoding:]) and
	([stringByReplacingPercentEscapesUsingEncoding:])

2004-07-03 Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/plmerge.m: Portability ... was attempting to set values in a
	dictionary which may not be mutable.
	* Source/NSString.m: ([propertyList]) make decoded containers mutable
	for compatibility with current MacOS-X
	* Source/NSPropertlyList.m: Fix error generating unicode escapes.

2004-07-02 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSHost.m: Use UTF8String rather than cString throughout
	as cString is deprecated.
	* Source/NSPropertyList.m: Output property list unicode escapes
	as \U rather than \u for MacOS-X compatibility. Fix a few bugs
	in old style plists.
	* Source/GSCompatibility.m: Remove plist stuff which duplicated code
	in NSPropertyList.m, so we only have one version to worry about.
	* Source/NSString.m ditto.

2004-07-02  David Ayers  <d.ayers@inode.at>

	* Headers/Foundation/NSMethodSignature.h
	* Source/NSMethodSignature.m
	* Source/GSFFCallInvocation.m
	* Source/GSFFIInvocation.m: Revert last mframe patch.
	
2004-07-02 Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSTimeZone.m: Define structure ttinfo as packed to get it
	aligned correctly on ARM. Patch from bug report #9452.

2004-07-01  David Ayers  <d.ayers@inode.at>

	* Headers/Foundation/NSMethodSignature.h
	(_internalMethodTypes): New instance variable.
	* Source/NSMethodSignature.m: ([+signatureWithObjCTypes]): Store
	the runtime signature separately from the mframe signature.
	Document.
	([-dealloc]): Free new instance variable.
	([-methodInfo]): Use _internalMethodTypes to build argument
	information.

	* Source/GSFFCallInvocation.m (GSInvocationCallback)
	* Source/GSFFIInvocation.m (GSInvocationCallback): Use the
	selector registered in the runtime for the receiver instead of the
	constructed selector from the stack to avoid mismatches in the
	runtime.

2004-06-29 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUserDefaults.m: Added MacOS-X compatibility methods ..
	([addSuiteNamed:]) and ([removeSuiteNamed:])

2004-06-27 Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/plparse.m: Check for and report illegal (non-ascii) characters
	in property list.  A property list should use \UXXXX escape sequences
	for non-ascii data.

2004-06-26 17:12  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSUserDefaults.m (read_only): Remove.

2004-06-25 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSIndexSet.m: Rewrite range removal to fix bug reported
	by Fred Kiefer. Add optional sanity check for debugging
	* Testing/nsindexset.m: Add test for deletion of range which has
	partial overlap with two others.

2004-06-24 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSIndexSet.m: Remove some redundant code for clarity.
	([containsIndexes:]) implemented.
	* Source/NSUser.m: NSSearchPathForDirectoriesInDomains() fix for user
	domain developer directory.
	* Source/Additions/GSXML.m: SAX2 fixes ... get element attributes
	from libxml2 properly. Make SAX2 element start/end methods call old
	methods for compatibility. Tidy somewhat, re-enable SAX2 support.

2004-06-22  Adrian Robert  <arobert@cogsci.ucsd.edu>

	* Tools/AGSHtml.m: Change default font for HTML main content to
	"palatino linotype,times,serif" (now provides backups).
	* Tools/AGSOutput.m: Improve GSdoc comments.
	* Tools/AGSParser.m: Add GSdoc comments.
	* Tools/autogsdoc.m: Change instanceVarsAtEnd option to default to
	YES as stated in the documentation.
	* Tools/gsdoc.gsdoc: Small wording changes.
	* Tools/gdnc.m: Fix typo in GSdoc comments.

2004-06-22  Adrian Robert  <arobert@cogsci.ucsd.edu>

	* Headers/Additions/GNUstepBase/GSObjCRuntime.h: Fix typos in GSdoc
	that were causing errors when autogsdoc is run.
	* Headers/Foundation/*.h
	* Source/*.m
	* Source/Additions/GSCategories.m
	* Source/Additions/Unicode.m: Add GSdoc comments to many files.  When
	a class had no documentation at all, or existing documentation was in
	the header file, comments were added in the header file.  When a class
	had all or most of its documentation in the source file, comments were
	added there.  (Maybe a policy should be decided for this at some
	point?)
	* Source/DocMakefile: Add "NSIndexSet.h" to list to generate GSdoc for.

2004-06-22  Adrian Robert  <arobert@cogsci.ucsd.edu>

	* Documentation/HtmlNav: Add top-level documentation HTML page, that
	goes in System/Library/Documentation.
	* Documentation/Makefile.postamble: Install this.
	* Documentation/Base.gsdoc
	* Documentation/BaseAdditions.gsdoc
	* Documentation/General/OpenStepCompliance.gsdoc
	* Documentation/General/Debugging.gsdoc: Use 1.0.1 DTD; also, minor
	updates/improvements.
	* Documentation/manual/*.texi: Major manual update to fill in missing
	portions.  Still more to do, but the basics are complete now.  In
	near term, need a class cluster example (maybe in appendix), and need
	to write the Java-Guile appendix (maybe this needs to cover StepTalk).
	* Documentation/manual/GNUmakefile: Update for above (some texi files
	added/removed).

2004-06-21 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSCalendarDate.m: ([descriptionWithCalendarFormat:locale:])
	Rewritten to support unicode and also to support some extra format
	specifiers like '%r' which might be used in native O/S locale strings
	but which are not part of OpenStep/Cocoa.

2004-06-21 Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSIndexSet.m: (-indexGreaterThanOrEqualToIndex,
	-indexGreaterThanIndex:) removed incorrect special case handling.

2004-06-20 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUserDefaults.m: ([initForUser:]) carry on and initialise
	an instance even if the users defaults directory doesn't exist and
	can't be created.  Created instance is read only and a warning is
	issued.

2004-06-18  Adam Fedor  <fedor@gnu.org>

	* Tools/gdomap.c (xgethostname): Add missing colon (patch
	from Tom Koelman).

	* Tools/Makefile.postamble: Fix missing space.
	* Souce/Makefile.postamble (before-uninstall): Change from 
	after-uninstall.

2004-06-18  Manuel Guesdon <mguesdon@orange-concept.com>

	* Source/NSKeyValueCoding.m: fix exception userInfo
	
2004-06-16  Willem Rein Oudshoorn  <Wim.Oudshoorn@agilisys.com>

	* Tools/gdomap.c (map_add): Fix off by one bug that causes
	random crashes in gdomap.

2004-06-14  Adam Fedor  <fedor@gnu.org>

	* configure.ac: Fix kvm test. Define HAVE_KVM_ENV
	* Headers/Additions/GNUstepBase/config.h.in, configure: Regenerate
	* Source/NSProcessInfo: Use it.

	* Makefile.postamble (after-uninstall): Remove base.make
	* Source/CompatibilityHeaders.make (before-uninstall): Remove headers
	* Tools/Makefile.postamble (before-uninstall): Remove dtds, man files.

2004-06-14 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSDictionary.m: MacOS-X compatibility fix for keyed encoding
	of empty dictionary.

2004-06-10  Adam Fedor  <fedor@gnu.org>

	* Version 1.9.2

	* Documentation/ReleaseNotes.gsdoc: New file
	* Documentation/GNUmakefile: Make and install it.

	* Source/NSRunLoop.m: If _POLL_EMUL_H is defined, use select
	instead of poll (e.g. Mac OS X).

2004-06-08  David Ayers  <d.ayers@inode.at>

	* Headers/Additions/GNUstepBase/GSObjCRuntime.h
	* Source/Additions/GSObjCRuntime.m
	(GSGetInstanceMethod, GSGetClassMethod)
	(GSGetInstanceMethodNotInherited, GSGetClassMethodNotInherited):
	Deprecate.
	(GSGetMethod): New function.

2004-06-06  David Ayers  <d.ayers@inode.at>

	* Source/Additions/GSObjCRuntime.m
	(GSObjCMethodNames): Unify implementation for both runtimes.
	(GSGetClassMethodNotInherited): Fix typo.
	(GSObjCAddClassBehavior): Add call to GSFlushMethodCacheForClass
	after adding behavior.
	(BDBGPrintf): Add space before last comma in macro older
	compilers.

2004-06-05  David Ayers  <d.ayers@inode.at>

	* Headers/Additions/GNUstepBase/GSObjCRuntime.h
	* Source/Additions/GSObjCRuntime.m
	(GSMethodList): Define new type.
	(GSAllocMethodList, GSAppendMethodToList, GSRemoveMethodFromList)
	(GSMethodListForSelector, GSMethodFromList)
	(GSAddMethodList, GSRemoveMethodList): New functions.
	(GSObjCMethodNames, search_for_method_in_class, GSObjCAddMethods)
	(search_for_method_in_class, GSObjCAddClassBehavior): Use GSMethod
	and GSMethodList types instead of pointers to runtime structures.
	* Testing/GNUmakefile
	* Testing/gsbehavior.m: New tests.
 
2004-06-05 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSDictionary.m: Make exceptions a little more informative.
	* Source/NSString.m: initWithFormat... externalise result of GSFormat
	so it works when the default character encoding is not the same as
	the internal 8-bit encoding.
	* Source/GSString.m: New function to externalize a string.
	implementations of init with format for concrete classes.

2004-06-04  David Ayers  <d.ayers@inode.at>

	* Source/Additions/GSObjCRuntime.m (BDBGPrintf) New macro.
	(GSObjCAddClassBehavior, GSObjCAddMethods): Use new macro.
	(OBJC_VERSION): Move define to where it is needed.
	(Runtime documenation references): Update links.
	
	* Source/GSSet.m (-[GSMutableSet unionSet:]): Remove redundant
	test.
	
2004-06-03  Adam Fedor  <fedor@gnu.org>

	* Source/cifframe.h: Move ffi.h include to fix compile problem on
	MinGW (Fixes #8267).

2004-06-03 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSZone.m: Fixed error in malloc of non-freeable zones
	(bug #9199) was failing to update top of block after allocation.

2004-06-02 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUnarchiver.m: Decode class names directly so we can
	substitute one class name for another.  Letting NSData decode
	classes only supported substitution if both the old and new classes
	existed in the executable, which is not what was intended.
	Thanks to Ludovic Marcotte for spotting this bug.
	* Source/GSHTTPURLHandle.m: Improve debug logging and add support
	for controlling http version in outgoing request.

2004-05-30 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSMime.m: Add support for setting default characterset for
	text elements ... needed for parsing multipart/form-data where the
	charset is not set in individual parts of the form.
	* Source/GSXML.h: tempoorarily disable sax2 support ... seem it
	doesn't work reliably.

2004-05-28  Adam Fedor  <fedor@gnu.org>

	* configure.ac: Check for kvm access and use it if available.
	* config/config.kvmopen.c: New file.

	* Documentation/Base.gsdoc: Fix broken link.
	* Documentation/coding-standards.texi: Add section.
	* Documentation/General/GNUmakefile: Include config.mak
	* Documentation/Tools/GNUmakefile: Idem.
	* Source/DocMakefile: Make documentation with frames.

2004-05-26 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSMime.m: When extraneous data is encountered in the input,
	ignore it (and log a warning) rather than adding it to the message
	body.  Not sure this is right ... perhaps should raise an exception
	or extend the api toi return the extra data.  Anyway, it's better
	than the previous behavior of adding the bad data to the parsed body.
	* configure.ac: Set some variables for presnece of stdint.h
	* Headers/Foundation/NSCoder.h: Remove defines of types in stdint.h
	* Headers/Additions/GNUstepBase/GSConfig.h.in: either include stdint.h
	or define alternatives for types used in new MacOS-X coding methods.

2004-05-25 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSIndexSet.m: ([addIndexesInRange:]) fix bug finding insertion
	point for new range. ([description]) check for uninitialised instance.

2004-05-24 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSDate.m: Implement -hash for abstract class and for the
	concrete subclasses as suggested by Marcus Muller.
	* Headers/Foundation/NSDebug.h: Add GSOnceFLog() and GSOnceMLog()
	to log messages the first time the code is executed ... typical
	usage is to log warnings about deprecated features.

2004-05-21  Adam Fedor  <fedor@gnu.org>

	* Tools/gdomap.c (xgethostnames): New function
	(nameServer, donames): Use it. (based on a patch from Matt Rice
	<ratmice@yahoo.com>).

2004-05-21 Roland Schwingel <roland.schwingel@onevision.de>

	* Source/NSTimeZone.m: Fix errors in handling of windows registry.

2004-05-18 Richard Frith-Macdonald <rfm@gnu.org>

	* configure.ac: Check for SAX2
	* Headers/Additions/GNUstepBase/GSXML.h: Add SAX2 methods
	* Headers/Additions/GNUstepBase/config.h.in: Add SAX2 header
	* Source/Additions/GSXML.m: Add SAX2 methods and remove
	use of deprecated functionality if recent (SAX2) API is
	available to use instead.

2004-05-17 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSMessagePort.m:
	* Source/NSMessagePortNameServer.m: Fix based on emailed patch
	by Roland Schwingel ... ensure we have a thread registered in
	atexit functions.

2004-05-17 Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/Foundation.h: Add NSError.h
	* Headers/Foundation/NSError.h: New MacOS-X compatibility header
	* Source/DocMakefile: Add NSError
	* Source/GNUmakefile: Add NSError
	* Source/NSError.m: new MacOS-X compatibility class.

2004-05-16 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSXML.m: Corrected value for cdata in sax-like
	interface to be an NSData rather than an NSString.
        * Headers/Additions/GNUstepBase/GSXML.h: ditto

2004-05-14 Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/autogsdoc.m: Create output directories if necessary.
	* Headers/Foundation/NSAutoreleasePool.h: Rationalised a little
	Moved documentation from source code.
	* Source/NSAutoreleasePool.m: Rationalised a little
	Moved documentation to headers.

2004-05-14 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSFormat.h:
	* Source/GSFormat.m:
	* Source/GSPrivate.h:
	* Source/GSString.m:
	* Source/GSeq.h:
	* Source/NSString.m:
	Updates to allow GSFormat to write directly into an existing string
	in either 16bit or 8bit format.  Also tidyups and modifications to
	use temporary buffers on stack rather than malloc/free as long as
	the buffers are reasonably sized.
	* Testing/benchmark.m: Trivial string format benchmarks ...
	Performance improvement of 10% for initWithFormat and 90% for
	appendFormat operations.

2004-05-13 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSCalendarDate.m: ([initWithString:calendarFormat:locale:])
	Corrected to return nil when description does not match format.
	Also change NSLog to NSDebugMLog for reporting problems, and added
	a couple of logs.
	Also changed to accept nil/empty string values for format and
	description as MacOS-X does.
	Also changed default year to be current year for compatibility.

2004-05-12 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSURL.m: ([-loadResourceDataNotifyingClient:usingCache:])
	used cached information if requested.  Always load using a cached
	handle so that results will be available to later calls.
	Addresses bug #8901

2004-05-09  David Ayers  <d.ayers@inode.at>

	* Headers/Additions/GNUstepBase/GSObjCRuntime.h
	* Source/Additions//GSObjCRuntime.m
	(GSProtocolFromName): New function.
	(GSRegisterProtocol): Ditto.
	(gs_string_hash): New internal function.
	(gs_find_protocol_named_in_protocol_list): Ditto.
	(gs_find_protocol_named): Ditto.
	(gs_init_protocol_lock): Ditto.
	
2004-05-07 23:48  Alexander Malmberg <alexander@malmberg.org>

	* Resources/Languages/Hungarian: Add a missing ".

2004-05-06  David Ayers  <d.ayers@inode.at>

	* Headers/Additions/GNUstepBase/GSObjCRuntime.h:
	* Source/Additions//GSObjCRuntime.m
	(GSClassList): New function.
	
2004-05-07 Richard Frith-Macdonald <rfm@gnu.org>

	* configure.ac: don't attempt to find xslt support if xml support
	was disabled or not found.

2004-05-06  David Ayers  <d.ayers@inode.at>

	* Headers/Additions/GNUstepBase/GSObjCRuntime.h
	* Source/Additions//GSObjCRuntime.m
	(GSAllocateMutexAt): New function.
	(_GSObjCRuntimeInitializer): Define local support class.

	* Headers/Additions/GNUstepBase/objc-gnu2next.h: Fixed minor
	whitespace issues.
	(objc_mutex_t, objc_mutex_allocate, objc_mutex_deallocate)
	(objc_mutex_lock, objc_mutex_unlock, objc_mutex_trylock): Declare
	for the NeXT runtime.
	* Source/Additions/GSNextRuntime.m 
	(objc_mutex_allocate, objc_mutex_deallocate)
	(objc_mutex_lock, objc_mutex_unlock, objc_mutex_trylock):
	Implement for NeXT runtime.
	
2004-05-06 Mateu Batle

	* Tools/gdomap.c: mingw fixes.
	* Headers/Foundation/NSPort.h: ditto
	* Source/NSSocketPort.m: ditto

2004-05-03 22:12  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSString.m (-hash),
	Source/GSString.m ([NSConstantString -hash]): Fix guard against
	returning a zero hash.

2004-04-29 23:00  Alexander Malmberg <alexander@malmberg.org>

	* configure.ac: Test for iconv support by compiling a program that
	includes the iconv header.
	* configure: Regenerate.

2004-04-27  Georg Fleischmann
	
	* Source/NSCalendarDate.m:
	(-initWithString:calendarFormat:locale:): avoid exception with
 	time zone abbreviations.

	* Testing/nsdate.m: Add test for this. (<fedor@gnu.org>).

2004-04-27  Adam Fedor  <fedor@gnu.org>

	* Source/GSHTTPURLHandle.m: Get debugFile path using
 	NSTemporaryDirectory() (based on fix from Sheldon Gill).

2004-04-27 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/Unicode.m: Tidy indentation and line lengths.
	* Documentation/Base.gsdoc: Improve documentation on default charset.

2004-04-26 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSHashTable.m: End enumerations 'properly' ... no effect
	in current implementationm, but could be important in future.

2004-04-26  Willem Rein Oudshoorn  <Wim.Oudshoorn@agilisys.com>

	* Source/libgnustep-base-entry.m (gnustep_base_socket_init):
	Added braces for if statement
	(DllMain): Removed old initialization code
	(gnustep_base_socket_handler): Removd this method plus declaration.

	* Source/GSFFCallInvocation.m (GSInvocationCallback): Try to find
	type information if not available, also changes wording of exception
	when no type information is found.
	(Fixes #8654)

	* Source/GSFFIInvocation.m (GSFFIInvocationCallback): Idem

2004-04-25 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSProtocolChecker.m: Major rewrite ... appeared almost totally
	non-functional.
	* Testing/nsconnectiion_server.m: Use NSProtocolChecker as a test.
	* Source/NSDistantObject.m: ([methodForSelector:]) moved to NSProxy.m
	* Source/NSProxy.m: ([methodForSelector:]) implemented.

2004-04-23  David Ayers  <d.ayers@inode.at>

	* Source/Additions/GSLock.m ([GSLazyLock -init])
	([GSLazyRecursiveLock -init]): Always invoke supers init
	so dealloc does not fail on Cocoa.
	
2004-04-19 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSDistantObject.m: ([-conformsToProtocol:]) rewritten with
	various hacks to check locally set protocol (if present) or forward
	a request to the remote system to check a protocol by name.
	Works round the fact that the gnu runtime protocol code accesses the
	ivars of the other protocol directly and so can't work via a proxy.

2004-04-17 01:17  Alexander Malmberg <alexander@malmberg.org>

	* Headers/Foundation/NSObject.h, Source/NSObject.m,
	Source/NSMethodSignature.m: Rename 'GNU' categories to 'GNUstep'.
	Patch from Matt Rice.

	'GNU' is a standard define on Hurd, so it can't be used as a name.

2004-04-15 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUserDefaults.m: Restore use of flag to prevent infinite
	recursion logging errors in createing standard defaults ... was
	lost in last modification.

2004-04-15 15:10  Alexander Malmberg <alexander@malmberg.org>

	* Tools/Makefile.postamble: Remove attempt to create
	$(doctemplatesdir).

2004-04-15 14:39  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSString.m (-stringByResolvingSymlinksInPath): Use
	-fileSystemRepresentation and -stringWithFileSystemRepresentation:
	instead of cstring methods.

	(-getCString:maxLength:range:remainingRange:): Document.
	(-getCString:, -getCString:maxLength:): Documentation fixes.

2004-04-14 18:20  Alexander Malmberg <alexander@malmberg.org>

	* Source/Additions/Unicode.m (GSToUnicode): In an utf8 sequence,
	check the the continuation bytes are valid continuation bytes.

2004-04-13 Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/GNUmakefile:
	* Tools/Makefile.postamble:
	Stop attempts to install templates removed in Adrian Robert's tidyup.

2004-04-12 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUserDefaults.m: Invalidate  userLanguages cache with every
	update to standard defaults, so setting it should work.
	Use lazy locking for improved performance when single threaded.
	Reorganise interaction between +standardUserDefaults and
	+userLanguages for improved startup performance and simplification
	(only load the database once on startup).
	Add large comments about the (still messy) interaction between the
	two methods.

2004-04-11 Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSArchiver.h: New ivar in unarchiver.
	* Source/NSUnarchiver.m: Simpler scheme to ensure that objects
	persist until the end of unarchiving ... just store them in an
	array.
	* Source/NSNumber.m: Don't deallocate self in initialisers when
	replacing with cached object ... use release instead in case
	something else has retained us.

2004-04-09 Gregory John Casamento <greg_casamento@yahoo.com>

	* Source/NSUnarchiver.m: Temporary rollback of previous fix.

2004-04-09 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUnarchiver.m: Retain objects while they are being
	decoded. Fixes problem reported by Willem Rein Oudshoorn where
	an object used by more than one object being decoded could be
	released by one object before being used by the other.
	Fix -init to call the primary initialiser.

2004-04-09  Willem Rein Oudshoorn  <Wim.Oudshoorn@agilisys.com>

	* Source/NSTask.m ([NSConcreteWindowsTask -launch]): Set
	stdin/stdout/stderr file to values provided by the user (Fix #8417)

2004-04-08  Adam Fedor  <fedor@gnu.org>

	* Tools/autogsdoc.m (main): Move var decl to begginning of block
	to avoid gcc < 3.0 compiler errors (Fix #8418).

2004-04-06 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUserDefaults.m: Modified to operate on a read-only
	filesystem where the defaults database is missing.  Application
	defaults and command line settings should still work.
	* Source/GSDictionary.m: fix for keyed archioving reported by
	Marc Ordinas i Llopis
	* Source/Additions/GSXML.m: Improve error logging ... add line number
	and column number to message, also avoid possible buffer overflow.

2004-04-02 Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/AGSParser.m: Fix error parsing sequence of protocol names
	separated by commas.

2004-03-31 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSKeyedArchiver.m: Encode archive version as a number rather
	than a string.
	* Source/NSString.m: ([-hash]) include full string length in the hash.
	* Source/GSString.m: ditto
	Disambiguates long strings with a common prefix.
	* Headers/Additions/GNUstepBase/GSIArray.h: add support for an array
	with statically allocated memory, which grows by using the heap.
	* Source/NSNotificationCenter.m: Rewrite posting so that we don't hold
	a lock on the center while actually posting ... should prevent
	possible deadlock in multithreaded programs.
	* Source/NSFileManager.m: ([-fileExistsAtPath:isDirectory:]) set
	the flag to NO if the path does not exist. (Fixes bug #7532)
	([copyPath:toPath:handler:]) Don't copy to existing destination.
	([movePath:toPath:handler:]) Don't move to existing destination.
	(Fixes bug #7525)

2004-03-30  Willem Rein Oudshoorn  <Wim.Oudshoorn@agilisys.com>

	* Source/NSNotificationCenter.m ([-removeObserver:]): Do not raise an exception
	when removing nil observer, jusr return.  This is WO4.5 and MacOSX behaviour.

2004-03-29 Adam Fedor <fedor@gnu.org>

	* Headers/Foundation/NSCoder.h (uint8_t, int32_t, int64_t): Define
	only ifndef (sugg. from Peter Cooper <comrade-gs@obverse.com.au>)

Mon Mar 29 17:19:40 BST 2004 Nicola Pero <n.pero@mi.flashnet.it>

	* Tools/autogsdoc.m: Use @"..." @"..." for concatenated string
	constants, not @"..." "...".

2004-03-29 Richard Frith-Macdonald <rfm@gnu.org>

	* Documentation/Base.gsdoc:
	* Documentation/BaseAdditions.gsdoc:
	* Documentation/Functions.gsdoc:
	* Documentation/TypesAndConstants.gsdoc:
	Update to latest gsdoc document version.
	* Documentation/Makefile.postamble:
	Build Tools documentation.
	contigure.ac:
	Add --enable-xslt option to require stylesheet support (in case we want
	to start uisng it to generate documentation)
	* Headers/Foundation/NSURLHandle.h:
	* Source/GSFileHandle.m:
	* Source/GSHTTPURLHandle.m:
	* Source/NSFileHandle.m:
	* Source/NSURLHandle.m:
	Support binding to specific local ip address for outgoing connections
	in gnustep extensions.
	* Source/GSMime.m: ([-setContent:]), ([-addContent:]) Check that
	content of a multipart document consists of GSMimeDocument objects.

2004-03-29 Adrian Robert <arobert@cogsci.ucsd.edu>

	* Tools/AGSHtml.h:
	* Tools/AGSHtml.m:
	* Tools/AGSIndex.m:
	* Tools/AGSOutput.m:
	* Tools/AGSParser.h:
	* Tools/AGSParser.m:
	* Tools/gsdoc.gsdoc:
	* Tools/autogsdoc.m:
	* Tools/GNUmakefile:
	Added support for building frames structured project documentation
	along with various other tidyups.

	* Tools/cvtenc.m:
	* Tools/defaults.m:
	* Tools/gdnc.1:
	* Tools/gdnc.m:
	* Tools/gdomap.h:
	* Tools/pldes.m:
	* Tools/plmerge.m:
	* Tools/plparse.m:
	* Tools/plser.m:
	* Tools/sfparse.m:
	* Tools/xmlparse.m:
	Added/improved documentaition.

2004-03-27 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSMessagePort.m:
	* Source/NSMessagePortNameServer.m: Use base library methods for file
	management rather than unix syscalls.
	* Headers/Foundation/NSRunLoop.h:
	* Source/NSRunLoop.m:
	* Source/NSString.m:
	* Source/NSTimeZone.m:
	Various minor documentation tweaks.

2004-03-27 Alexander Malmberg <alexander@malmberg.org>

	* NSUser.m: Plug some security loopholes in temporary directory

2004-03-27 Mark Allison <mark@brainstorm.co.uk>

	* Headers/Additions/GNUstepBase/GSXML.h:
	* Source/Additions/GSXML.m: Add support for stylesheet processing using
	libxslt if it is available.
	* configure.ac: Check for presence of libxslt

2004-03-26 Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSIndexSet.m: Check before each usage of _other if it is
	actually set.

2004-03-24  Adam Fedor  <fedor@gnu.org>

	* Resources/GNUmakefile: Add Languages/Hungarian.
	* Languages/Hungarian: New file (from Reuss Andras <reuss@chello.hu>).
	
	* configure.ac: Check for null ac_cv_lib_dl_dladdr.

	* Documentation/announce.texi: Update bug reporting URL.

2004-03-19  Adam Fedor  <fedor@gnu.org>

	* Source/NSFileManager.m (-createDirectoryAtPath:attributes:):
	Return NO if path is nil.
	(-createFileAtPath:contents:attributes:): Idem.

	* Source/NSUser.m (NSUserName): Set initial olduid to an invalid
	uid.

2004-03-16 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSDictionary.m: Don't use stack as temporary storage for
	large numbers of objects ... reduce chances of stack overflow.
	* Source/NSIndexSet.m: Added a few range checks, implemented many
	methods of mutable class.

2004-03-16  Willem Rein Oudshoorn  <Wim.Oudshoorn@agilisys.com>

	* Source/NSNotificationCenter.m ([NSNotificationCenter -removeObserver:name:object:]): 
	Just return if all arguments are nil instead of throwing exception.
	The new behaviour is compatible with MacOSX.

2004-03-15 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSCompatibility.m:
	* Source/GSDictionary.m:
	* Source/NSPropertyList.m: Check for proxies in a few places and
	avoid pointer code which won't work for them.  Also avoid caching
	imps as a temporary workaround for a problem (not yet understood)
	with ffi forwarding using a cached imp.

2004-03-12 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSCategories.m:
	* Source/Additions/GSMime.m: New uuencode/uudecode moved from
	GSMime to a category of NSData and renamed.
	* Source/NSThread.m: Set flag to saay we are multithreaded before
	we send out the notifications.  Fixes bug in lazy locking and is
	more compatible with macos-x

Fri Mar 12 13:35:25 2004  Nicola Pero  <n.pero@mi.flashnet.it>

	* SSL/GNUmakefile: Set GNUSTEP_LOCAL_ADDITIONAL_MAKEFILES before
	including common.make so that the local base.make is read
	correctly.

2004-03-07  Adam Fedor  <fedor@gnu.org>

	* configure.ac: Add HAVE_DLADDR define
	* Source/simple-load.h (__objc_dynamic_get_symbol_path): Readd
	ifdefs for dladdr.

	* Tools/defaults.m: Exit with non-zero status when command is not
	successful.
	
Sat Mar  6 13:54:28 2004  Nicola Pero  <n.pero@mi.flashnet.it>

	* SSL/GNUmakefile: Include common.make before everything else so
	that the SSL bundle is built again.

2004-03-05  Wim Oudshoorn  <Wim.Oudshoorn@agilisys.com>

	* Source/NSCalendarDate.m ([NSCalendarDate -descriptionWithCalendarFormat:locale:]): 
	Fixed problem with repeated %b %B %b %B and the like. 
	Fixed problem with missing characters after unrecognixed modifiers.
	Added support for %c %X and %x.

2004-03-02  Adam Fedor  <fedor@gnu.org>

	* Source/NSCalendarDate.m (dayOfCommonEra): Make non-static.

2004-03-01  Wim Oudshoorn  <woudshoo@agilisys.com>

	* Headers/Additions/GNUstepBase/GSIMap.h: Added increment ivar to GSIMapTable
	struct for allocation size
	(GSIMapNewNode): When above a certain size only allocate "increment" number 
	of nodes
	(GSIMapResize): Avoid hash table sizes that are odd
	(GSIMapInitWithZoneAndCapacity): Put default increment size to 300000

	* Source/NSThread.m ([GSPerformHolder +initialize]): #ifdef'ed out 
	code that does not work on MinGW.

2003-02-29 Sheldon Gill <sheldon@iinet.net.au>

	* Source/NSTimeZone.m: Added capability on Win32. NSTimeZone now
	has GSWindowsTimeZone concrete sub-class which uses data from the
	registry.  Based on changes from Jeremy Bettis:

2003-02-29 Sheldon Gill <sheldon@iinet.net.au>

	* Source/NSTimeZone.m:  Added documentation and clean up.
	[NSTimeZone initTimeZoneWithName:data:] now uses data.

2004-02-28  Adam Fedor  <fedor@gnu.org>

	* Version 1.9.1
	* Documentation/install.texi, news.texi: Update

	* configure.ac: Define _GNU_SOURCE for LONG_LONG check
	* Source/GSFormat.m: Idem.
	* Source/NSScanner.m: Idem.

	* Source/simple-load.h: Define RTLD_DEFAULT if not defined.

2004-02-28 17:52  Alexander Malmberg <alexander@malmberg.org>

	* configure.ac, configure: Define GS_UINT64 properly if there is
	no 64-bit integer type.

	* Source/NSIndexSet.m: Don't use casts as lvalues.

2004-02-27  Wim Oudshoorn  <woudshoo@agilisys.com>

	* Tools/gdomap.c: when using MinGW do not try to chdir to /tmp
	because it does not always exist.

	* Source/NSBundle.m ([NSBundle +mainBundle]): on WIN32 strip .exe 
	extension from executable name when constructing mainBundle path.

2004-02-26  David Ayers  <d.ayers@inode.at>

	* Headers/Additions/GNUstepBase/GSCategories.h
	([NSLock gcFinalize]): Declare.
	([NSRecursiveLock gcFinalize]): Ditto.
	
2004-02-25  David Ayers  <d.ayers@inode.at>

	* Headers/Additions/GNUstepBase/GSCategories.h:
	* Source/Additions/GSCompatibility.m (GSCurrentThread) Implement 
	and declare for non *-gnu-*.

2004-02-24 Fred Kiefer <FredKiefer@gmx.de>

	* Headers/Foundation/NSDictionary.h: 
	* Source/NSDictionary.m: (-setValue:forKey:)
	Added MacOSX method with same implementation as takeValue:forKey:

2004-02-24 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSFormat.m: Fix buffer overrun by strlen() when printing
	c-strings without nul terminators using '%*.*s' format.
	* Source/Additions/GSMime.m: Fix cases of possible access beyond buffer
	and rare overflow writing decoded base64 data.
	* Headers/Foundation/NSKeyedArchiver.h: Remove stuff saying this is
	not implemented ... it is now.
	* Source/NSIndexSet.m: Partial implementation untested ... at least
	it's a skeleton for people to work on ... committed now because I'm
	away for a few weeks on holiday.
	* Headers/Foundation/NSIndexSet.h: Partial documentation.

2004-02-23  Adam Fedor  <fedor@gnu.org>

	* Source/NSUser.m (NSHomeDirectoryForUser): Allow whitespace
	in user directory (on Windows).

2004-02-21 Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSPropertyList.m: (GSBinaryPLParser
	-initWithData:mutability:, -offsetForIndex:, -readObjectIndexAt:)
	Added support for binary pls with size == 3.

2004-02-19 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSMime.m: added a couple of uuencoding methods.
	Integrated (crudely) uuencoding/uudecoding support based on x-uuencode

2004-02-18  David Ayers  <d.ayers@inode.at>

	* Source/Additions/Unicode.m (GetDefEncoding): Replace
	NSKoreanEUCEncoding with NSKoreanEUCStringEncoding.

2004-02-17  Bruno Haible  <bruno@clisp.org>

	* Source/Additions/Unicode.m (GetDefEncoding): Use the result of
	nl_langinfo(CODESET) before falling back on ISO-8859-1.
	* config/codeset.m4: New file, taken from GNU gettext.
	* configure.ac: Include it, and invoke AM_LANGINFO_CODESET.

2004-02-17  David Ayers  <d.ayers@inode.at>

	* Headers/Foundation/NSLock.h: Make types of _mutex and _condition
	opaque to avoid including private thr-mach.h header.
	* Headers/Foundation/NSThread.h: Do not include private thr-mach.h
	header.
	* Source/thr-mach.h: Moved here from
	Headers/Additions/GNUstepBase/thr-mach.h.
	* Source/NSLock.m: Include private thr-mach.h header for
	apple-gnu-gnu.  Added defines for typing opaic instance
	variables and use them in various methods. 
	* Source/NSThread.m: Include private thr-mach.h header for
	apple-gnu-gnu.
	* Source/thr-mach.m: Include private thr-mach.h header from new
	location.
	* Source/thr-pthread.m: Ditto.
	* Source/GNUmakefile: Do not install private thr-mach.h header.

2004-02-11 17:47  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSCountedSet.m (-initWithCoder:): Release objects outside
	the -addObject: loop to keep the retain count correct.

2004-02-11 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSHTTPURLHandle.m: Expect to read content data after headers
	if content-length is non-zero
	or if content-transfer-encoding is chunked
	or if server http version is less than 1

2004-02-09  Adam Fedor  <fedor@gnu.org>

	* configure.ac: Add ffcall dir to INCLUDE_FLAGS.

2004-02-08  Adam Fedor  <fedor@gnu.org>

	* Source/simple-load.h (__USE_GNU): Define for dlfcn.

2004-02-08 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSConection.m: Simplify code by using GSLazyLock and
	GSRecursiveLazylock.  Removed unused include of float.h
	* Source/GSAttributedString.m:
	* Source/GSTcpPort.m:
	* Source/NSCharacterSet.m:
	* Source/NSCountedSet.m:
	* Source/NSDebug.m:
	* Source/NSMessagePort.m:
	* Source/NSSocketPort.m:
	* Source/NSTimeZone.m:
	Simplify by using lazy locking.

2004-02-07  Adam Fedor  <fedor@gnu.org>

	* Source/simple-load.h (__objc_dynamic_get_symbol_path): Remove
	ifdefs since dladdr is assured to be present. Set handle to default
	if not specified.

2004-02-04 Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSPropertyList.m: (GSBinaryPLParser -objectAtIndex:)
	Corrected two small errors for the new binary parser.

2004-02-07 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSKeyedUnarchiver.m: Changes to fix memory leaks.
	Fix bug handling nil/NSnull reported by Fred.

2004-02-06 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSHTTPURLHandle.m: If there is no path in the URL, assume '/'

2004-02-04 Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSPropertyList.m: Rewrote the object reference handling
	for new binary parser.

2004-02-02 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSPropertyList.m: Integrate new parser to
	NSPropertyListSerialisation.  Assume 8bit strings are utf8.

2004-02-04 01:10  Alexander Malmberg <alexander@malmberg.org>

	* Headers/Foundation/NSObject.h (ASSIGNCOPY),
	Source/GSDictionary.m (GSI_MAP_RETAIN_KEY),
	Source/NSNotificationCenter.m (-init),
	Source/NSProtocolChecker.m (-forwardInvocation:),
	Source/Additions/GSXML.m (-initWithDocument:): Remove uses of the
	now deprecated "casts as lvalues" gcc extension.

2004-02-02 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSPropertyList.m: Added class by Fred Kiefer to decode
	MacOS-X binary property lists ... heavily modified to try to handle
	object references and dates (guessed) and to support mutability
	options.  Current code does not get called by the deserialisation
	method as I need to figure out how to tell which format the property
	list is in, and for that I need to loook at example archives, which
	I haven't had time to do yet.  Code comitted mainly so it's saved
	somewhere and so that Fred can have a look and see if I've messed
	stuff up.

2004-02-02 Roland Schwingel <roland.schwingel@onevision.de>

	* Source/NSString.m: ([stringByAbbreviatingWithTildeInPath]) fix bug
	appending last path component.
	([localizedNameOfStringEncoding:]) fix load of locliisation bundle.

2004-02-02 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Headers/Foundation/NSPropertyList.h:
	Use GNUstep rather than GNUStep in property list format names as
	it seems to be the more common capitalisation.
	* Source/NSPropertyList.m: Add new methods exposed to java by jigs
	to avoid java errors with conflicting implementations of the
	NSPropertyListSerialisation class.

2004-02-01 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSMime.h: improve consistency of naming of
	methods with add/set methods for new headers.
	* Source/GSHTTPURLHandle.m: ([bgdRead:]) if the headers are complete
	and there is no content-length, don't expect to read body content.

2004-01-31  Manuel Guesdon <mguesdon@orange-concept.com>
	* Source/NSNumber.m: Modified numberWithXX: methods
	to test against abstractClass. If class is not the abstract 
	class, we alloc object of class instead of allocating 
	NSXXNumber objects (cf [NSDecimalNumber numberWithDouble:x]
	thread)
			
2004-01-30 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSString.m: Added two new MacOS-X initialisers.
	* Headers/Foundation/NSString.h: ditto
	* Source/NSData.m: ([replaceBytesInRange:withBytes:length:) rewrite
	to fix crash when new data is smaller than orignal.
	* Source/NSNumber.m: ([numberWithBool:]) and ([initWithBool:])
	returns yes value for any non-zero argument. ([boolValue]) returns
	either YES or NO. So we are tolerant in what we accept, strict in
	what we produce.

2004-01-28  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSString.m:
	Corrected keyed decoding and implemented keyed encoding.
	
2004-01-28 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSKeyedUnrchiver.m: Store objects in map while they are
	decoding themselves so they can be self referential.
	* Source/GSArray.m:
        * Source/NSArray.m:
        * Source/GSSet.m:
        * Source/NSSet.m:
        * Source/GSDictionary.m:
        * Source/NSDictionary.m:
        * Source/NSString.m:
	Made keyed decoding able to handle more variations.
	Added keyed encoding support.

2004-01-27  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSPropertyList.m (nodeToObject()): Fixed bug in handling
	of data elements. Was using [GSMimeDocument decodeBase64String:]
	instead of [GSMimeDocument decodeBase64:].

2004-01-27  Fred Kiefer <FredKiefer@gmx.de>

	* Source/GSArray.m:
	* Source/NSArray.m:
	* Source/GSSet.m:
	* Source/NSSet.m:
	* Source/GSDictionary.m:
	* Source/NSDictionary.m:
	* Source/NSString.m:
	Implemented keyed decoding in [initWithCoder:].
	
2004-01-27 Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSKeyedArchiver.h: Expose internals a bit.
	* Source/NSKeyedArchiver.m: Fix decoding of geometry for locales
	where a comma is used as a decimal separator.

2004-01-26  Adam Fedor  <fedor@gnu.org>

	* Documentation/General/GNUmakefile: Update install
	location

2004-01-25  Adam Fedor  <fedor@gnu.org>

	* base.make.in: Move LIBXML variable outside gnu-foundation check.

	* Documentation/GNUmakefile (SUBPROJECTS): Add General
	* Documentation/General/GNUmakefile: New file.
	* Documentation/General/Degbugging.gsdoc: Moved to here.
	* Documentation/General/OpenStepCompliance.gsdoc: Idem.
	* Source/DocMakefile: Remove OpenStepCompliance.gsdoc

2004-01-25 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSPropertyList.m: Fix bug in encoding integers as xml.
	Fix to compile without xml if necessary.
	* Source/GSPrivate.h: Added internal class for handling old style
	arrays of items within keyed coding ... should this go elsewhere?
	* Source/NSCoder.m: Added internal class for keyed coding of
	arrays of items.
	* Source/NSKeyedArchiver.m: Added support for
	([encodeArrayOfobjCType:count:at:]) and the private
	([_encodeArrayOfObjects:forKey:]) method.  This completes (afaik) the
	implementation for archiving ... and it's somewhat tested for xml
	coding.  Time to start using and debugging.
	* Source/NSKeyedUnarchiver.m: All methods now implemented, but no
	proper type checking/coercion done, and minimal testing done.
	No attempt to handle OpenStep style property lists either, just xml!
	* configure.ac: Insist on libxml2 presence unless told not to.

2004-01-24 Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSKeyedArchiver.h:
	* Source/NSKeyedArchiver.m:
	Add keyed version of geometry encoding methods as pointed out by
	Fred Kiefer.

2004-01-24 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSKeyedArchiver.m:
	* Source/NSKeyedUnarchiver.m:
	Added NSPoint, NSRect, and NSSize coding methods.
	implemented quick hack of ([decodeValueOfObCType:at:])
	Set default property list format to xml ... The MacOS-X binary,
	format isn't supported yet (if ever), and I'm developing using
	the comon/portable XML format first anyway.
	* Source/NSMSoperamulti_test.m: Sort dictionary items in xml output

2004-01-23 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSSocketPort.m:
	* Source/NSMessagePort.m: Fixed return form method without unlocking
	a lock ... could cause a hang.  Also, tidied up add/romve watchers
	in runloops.

2004-01-22 Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSKeyedArchiver.h: Update ivars for unarchiver.
	* Source/NSKeyedUnarchiver.m: Partial implementation.

2004-01-21 Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSPropertyList.h: serialisation/deserialisation.
	* Source/NSPropertyList.m: serialisation/deserialisation code partly
	implemented.
	* Headers/Foundation/NSCoder.h: Add keyed coding methods.
	* Source/NSCoder.m: ditto
	* Headers/Foundation/NSKeyedArchiver.h: new keyed archiver/unarchiver.
	* Source/NSKeyedArchiver.m: New MacOS-X compatible class implementation.
	* Source/NSKeyedUnarchiver.m: Stub for new class implementation.
	* Source/GNUmakefile: build new keyed archiving stuff.
	* Source/GSCompatibility.m: fix indentation error in xml output.
	improve output of numeric values in xml format.
	* Source/Additions/GSMime.m: ([-setContentType:) make argument more
	strongly typed. ([-encodeBase64:])tweak buffer size.

2004-01-18 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSDistantObject.m: All code conditional on USE_FFCALL should
	also be conditional on USE_LIBFFI so it works for both mechanisms.

2004-01-14  Adam Fedor  <fedor@gnu.org>

	* Source/Additions/GSObjCRuntime.m: Fix previous method def.
	* Source/Additions/GSXML.m: Idem.

	* Tools/GNUmakefile (TOOL_NAME): Add cvtenc plmerge sfparse xmlparse
	for add=yes.
	* Tools/cvtenc.m: Add includes for compiling with darwin.
	* Tools/plmerge.m, Tools/sfparse.m, Tools/xmlparse.m: Idem.
	Suggestions and patches from Stephane Corthesy.

2004-01-13 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSURLHandle.m: ([-availableResourceData]) remove condition
	that returns nil while resource is loading.  Fix typo in method
	description.  Return copy a of internal variable rather than the
	actual mutable data object.

2004-01-12  Adam Fedor  <fedor@gnu.org>

	* SSL/GNUmakefile: Include ../config.mak

2004-01-12  Adam Fedor  <fedor@gnu.org>

	* Source/Makefile.preamble: Add library depends for baseadd
	* Source/Additions/GSLock.m: Include GSCategories.
	* Source/Additions/GSObjCRuntime.m: Define -methodForSelector:
	since Apple doesn't.
	* Source/Additions/GSXML.m: Idem as well as GSXPathObject method.
	Change warnings variable to NSHashTable*.

	* Tools/AGSHtml.m ([AGSHtml -outputNode:to:]): Change name
	of block variable to avoid clash
	* Tools/AGSOutput.m ([AGSOutput -split:]): Initialize local vars.
	Changes suggested by Stephane Corthesy.

2003-12-20 Sheldon Gill <sheldon@iinet.net.au>

	* Source/NSProcessInfo.m (+load): Fix coding standard violations.

2004-01-10  Bruno Haible  <bruno@clisp.org>

	* Locale.aliases: Add many new locales. Fix typo for EcuadorSpanish.

2004-01-10 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSCompatiblity.m: PString() fix erroneous use of unichar
	pointer as if it was a char pointer.

2004-01-08 Alexander Malmberg <alexander@malmberg.org>

	* Source/Additions/GSMiume.m: Fix bad use of NSString as C-string

2004-01-07 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSArray.m: minor cleanups to use gnucoding conventions for
	whitespace and little performance tweak (cache NSNull instance).

2004-01-08 01:48  Alexander Malmberg <alexander@malmberg.org>

	* Headers/Additions/GNUstepBase/GSCategories.h
	(GSCurrentThreadDictionary, NSStandardLibraryPaths): Fix the
	prototypes (add explicit void:s).

	* Source/GSAttributedString.m (_setAttributesFrom): Initialize
	range in the aRange.length==0 case. (Found by Andrew Ruder using
	valgrind.)

2004-01-06  Adam Fedor  <fedor@gnu.org>

	* Documentation/Base: New directory
	* Documentation/Base/Debugging.gsdoc: New.

2004-01-06  Manuel Guesdon <mguesdon@orange-concept.com>
	
	* Headers/Foundation/NSArray.h/.m: added -setValue:forKey:
		and -valueForKey: to comply to Mac OS X v10.3 and 
		later documentation.

2004-01-05 Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Additions/GNUstepBase/GSMime.h: add content deletion method
	* Source/Additions/GSMime.m: add content deletion method
	([-deleteContent:]) as counterpart for addition of content, for
	consistency.

2003-12-30  Fred Kiefer <FredKiefer@gmx.de>

	* Headers/Foundation/NSGeometry.h 
	* Headers/Foundation/NSRange.h
	Added a few additonal Cocoa type definitions.

2003-12-25 Gregory John Casamento <greg_casamento@yahoo.com> & 

	* Source/NSBundle.m: Corrected spelling of "Warning" and 
	"deprecated" in the pathForGNUstepResource:... method.

2003-12-25  Fred Kiefer <FredKiefer@gmx.de>

	* Tools/pl2link.m: Adopted to current OpenDesktop specification.

2003-12-23 23:33  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSCharacterSet.m: Rename 'abstract' to 'abstractClass' and
	make it static.
	(+allocWithZone:): Allocate an instance of self if self isn't the
	abstract class.

2003-12-23 18:38  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSThread.m: Don't use '\r\n' in printf strings (stdio/libc
	is responsible for converting it to local convention).

	(+detachNewThreadSelector:toTarget:withObject:): Don't set
	entered_multi_threaded_state to NO if the objc_thread_detach call
	fails.

2003-12-23 18:15  Alexander Malmberg <alexander@malmberg.org>

	* Documentation/news.texi, Headers/Foundation/NSDebug.h,
	Source/GSPrivate.h, Source/externs.m, Tools/plist-0_9.dtd: Fix
	spelling errors in comments.

2003-12-06 12:34  Alexander Malmberg <alexander@malmberg.org>

	* Headers/Foundation/NSGeometry.h (NSContainsRect): Return NO
	if bRect is empty.

	* Source/NSGeometry.m (NSIntegralRect): Calculate the new width
	and height correctly.

2003-12-01 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSObject.m: Fix error setting sigpipe handling where
	sigaction is available.

2003-11-30 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSNumber.m: Raise exception if user code incorrectly tries
	to deallocate a cached small number.
	* Source/NSUser.m: Use geteuid() to determine name of current user
	under unix.

2003-11-25 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSMime.m: fix for incremental parsing so that
	the parser insists on the crlf after the last boundary in a message
	(hold a flag to say we are still expecting the crlf).

2003-11-23 S.J.Chun <chunsj@embian.com>

	* Headers/Additions/GNUstepBase/GSCategories.h: Change
	KoreanEUCEncoding to KoreanEUCStringEncoding.
	* Headers/Foundation/NSString.h, Source/Additions/Unicode.m: Idem.

2003-11-23  Adam Fedor  <fedor@gnu.org>

	* Version 1.9.0

2003-11-23 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSTask.m: ([-suspend]) send SIGSTOP as documented ... bug
	reported by Jim Fowler.

2003-11-22  Adam Fedor  <fedor@gnu.org>

	* configure.ac: Typo fix - add original CPPFLAGS back when updating 
	netbsd CPPFLAGS.

2003-11-16 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSCompatibility.m: Add dummy gcFinalize
	implementations for NSLock and NSRecursiveLock so that the
	lazy locking classes can safely call them under MacOS-X

2003-11-10 Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/AGSHtml.m: Fix based on email by Chris Vetter to correct
	presentation of protocol names in index pages.

2003-11-10  David Ayers  <d.ayers@inode.at>

	Based on patches by Philip Moetteli <Philip.Moetteli@tele2.ch>.
	* Headers/Additions/GNUstepBase/GSCategories.h: Added
	NSKoreanEUCEncoding.  
	* Headers/Additions/GNUstepBase/GSLock.h
	* Headers/Additions/GNUstepBase/GSLocale.h: Guard includes for
	NeXT_Foundation_LIBRARY.  
	* Source/Additions/GSLock.m: Include GNUstepBase/GNUstep.h.  
	* Headers/Additions/GNUstepBase/GSCategories.h
	* Headers/Foundation/NSString.h:
	(+[NSString stringWithFormat:arguments:]): Move declaration to
	GSCategories.  
	* Source/NSString.m
	* Source/Additions/GSCategories.m:
	(+[NSString stringWithFormat:arguments:]): Move implementation to
	Additions.
	* macosx/config.h: Define HAVE_WCHAR_H.
	* macosx/gnustep.pbproj/project.pbxproj: Added GSLock files.

2003-11-10 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUserDefaults.m: Only obtain distributed lock for reading
	or writing defaults ... not needed just to check the modification
	date.  Avoids unnecessary filesystem writes.

2003-11-09  Frederic De Jaeger  <dejaeger@free.fr>

	* Source/GSFileHandle.m ([GSFileHandle
	-initAsClientInBackgroundAtAddress:service:protocol:forModes:]):
	the boolean 'beenHere' must be declared static.  Fixing it.

2003-11-06  David Ayers  <d.ayers@inode.at>

	* Source/GSPrivate.h (GS_REPLACE_CONSTANT_STRING): New macro.
	* Source/externs.m: Initialize constant strings statically.
	(GSBuildStrings): Replace static strings with dynamic
	versions.
	* Testing/benchmark.m: Added tests for NSString -hash and 
	-copy.  Aligned ouput.
	* Testing/externs.m: New test.
	* Testing/GNUmakefile: Added externs.m test.  Activated
	ADDITIONAL_TOOLS tests excluding gstcpport tests.

	* Source/Additions/GSCategories.m: Adjust declared lock type.
	Added comment.

2003-11-05 18:26  Richard Frith-Macdonald <rfm@gnu.org>

	* SSL/GSSSLHandle.m: Add support for server end handles.
	* Source/NSFileHandle.m: New -sslAccept method for servers.

2003-11-05 14:49  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSSerializer.m (serializeToInfo): Only save a string as
	a cstring if it only contains ASCII characters.

2003-11-05 03:10  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSString.m: Reorganize class heirarchy. Remove unused
	GSCEmptyString class. Add new concrete leaf classes GSCBufferString
	and GSCUnicodeString. Make GSString, GSCString, and GSUnicodeString
	abstract and move the real memory management code to the two new
	classes. Update the other concrete leaf classes. Update callers.

	* Source/GSPrivate.h: Update comment about the semantics of the free
	flag in GSString.

	* Source/NSSerializer.m: Clarify comments about the cached classes.
	Use GSCBufferString and GSUnicodeBufferString instead of GSCString
	and GSUnicodeString when creating string instances.

Mon Nov 03 12:30:00 2003  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSNotificationCenter.m: Use locking at all times until
	problems with GNUMail threading and notifications are analysed/fixed.

Mon Nov 03 08:35:00 2003  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSString.m: Remove unnecessary -copy implementations for
	simplicity, and add code to avoid creating substrings of strings
	which do not own their buffers ... stopgap until Alexander
	reorganises class hierarchy.

2003-11-02 01:53  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSString.m ([GSCSubString -copy]): Add as a stopgap
	workaround for problems uncovered by the previous change.

Sat Nov 01 11:10:00 2003  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSString.m: ([-copyWithZone:]) always do true copy
	* Source/GSString.m: Where the string data pointed to is not
	owned by the string instance, have copy operations create new
	instances rather than retaining the receiver.

Sat Nov 01 07:05:00 2003  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSNotificationCenter.m: Simplify locking code as original
	code was hanging in GNUMail after Davids recent locking changes ...
	not sure what the actual problem was, so this change may have merely
	re-hidden a bug :-(
	* Source/Additions/Unicode.m: Simplify to use non-recursive lock.
	* Source/NSCharacterSet.m 
	([NSCharacterSet _bitmapForSet:number:]): Restore caching while
	retaining the intended behavior of the previous change (is that
	intended behavior correct?).
	Perhaps should maintain a separate cache for each subclass ...
	or should that be the responsibility of the subclass itsself?

2003-10-31  David Ayers  <d.ayers@inode.at>

	* Source/NSCharacterSet.m 
	([NSCharacterSet _bitmapForSet:number:]): Insure only instances of
	NSCharacterSet a stored in the cache but return instances of the
	receivers class.

2003-10-30  David Ayers  <d.ayers@inode.at>

	* Headers/Additions/GNUstepBase/GSLock.h: Added missing forward
	declaration.
	* Headers/Additions/GNUstepBase/GSCategories.h: Remove declaraion
	of gnustep_global_lock.
	(GS_INITIALIZED_LOCK): New macro.
	(+[NSLock newLockAt:]): New method.
	(+[NSRecursiveLock newLockAt:]): Ditto.
	* Headers/Foundation/NSLock.h: Ditto.
	* Source/Additions/GSCategories.m: Replace global lock with local
	lock.
	(_GSLockInitializer): New class to initialize local lock safely.
	(newLockAt): New static function shared by +newLockAt:
	implementations to safely intialize lock variables.
	(+[NSLock newLockAt:]): Implemented and documented.
	(+[NSRecursiveLock newLockAt:]): Ditto.
	* Source/Additions/GSCompatibility.m: Remove gnustep_global_lock.
	* Source/Additions/GSObjCRuntime.m: Remove superfluous locking.
	* Source/Additions/Unicode.m: Use new GS_INITIALIZED_LOCK macro
	and replace global lock with local lock.  Moved out of the #ifdef
	as reported by Matt Rice (ratmice@yahoo.com).
	* Source/NSLock.m 
	(-[NSConditionLock lockWhenCondition:beforeDate:]): Implemented.
	* Testing/gslock.m: New test case.
	* Testing/GNUmakefile: Add new test case.

2003-10-28  Adam Fedor  <fedor@gnu.org>

	* configure.ac: Simplify and clarify ffi errors.

	* macosx/gnustep.pbproj/project.pbxproj: Update for 10.3 (Xcode).
	* macosx/REAMDE: Add comment
	(Update from Philip Mötteli <Philip.Moetteli@tele2.ch>).

Tue Oct 28 10:12:00 2003  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSRunLoop.m: Modified (acceptInputForMode:beforeDate:) and
	(runMode:beforeDate:) to poll input sources when given a date in the
	past, rather than ignoring them entirely ... this seems more useful
	and appears to be consistent with MacOS-X.
	Updated method documentation.

Mon Oct 27 13:37:00 2003  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSConnection.m: Rewrite/simplify methods dealing with DO
	retain/release and handling interaction with NSDistantObject.
	Attempts to make retain/release simpler and more reliable by
	(among other things) counting the nujmber of times an object is
	vended by reference.  Much care taken to try to ensure that
	backward compatibility is not broken ... hope it is ok.
	* Source/NSDistantObject.m: Modified to use slightly simpler 
	interaction with NSConnecxtion, to include count of times an
	object is vended by reference and to ensure thread safety.
	* Testing/nsconnection_client.m: Make the -d  option produce detailed
	debug output.
	* Testing/nsconnection_server.m: ditto.

Mon Oct 27 13:24:00 2003  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GNUmakefile: build new lock classes
	* Source/DocMakefile: document new lock classes.

Sun Oct 26 14:45:00 2003  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSLock.m: New lazy locking classes as discussed
	on the developer list.
	* Headers/Additions/GNUstepBase/GSLock.h: Declare new classes.
	Please try them out and provide feedback.

Sat Oct 25 18:47:00 2003  Richard Frith-Macdonald <rfm@gnu.org>

	* configure.ac: Judicious addition on spaces to fix test arguments.

Sat Oct 25 06:54:00 2003  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSCalendarDate.m: ([setCalendarFormat:]),([setTimeZone:])
	make nil arguments set default values for MacOS-X compatibility.
	Document this.

2003-10-24  Adam Fedor  <fedor@gnu.org>

	* configure.ac: Try to use libffi if ffcall not found.

2003-10-24  David Ayers  <d.ayers@inode.at>

	* Source/GSArray.m:
	(-[GSMutableArray _raiseRangeExceptionWithIndex:from:]): Declare
	private method obtained through behavior additions.
	(-[GSArray _raiseRangeExceptionWithIndex:from:]): Use 'unsigned' in
	favor of 'int' for index and count.  Move private method to the
	top of implementation context to avoid warnings.
	(-[GSMutableArray insertObject:atIndex:]): Use 'unsigned' in favor
	of 'int' for index.
	(-[GSMutableArray replaceObjectAtIndex:withObject:]): Correct
	selector name and parameter of method call.
	(-[GSMutableArray sortUsingFunction:context:]): Correct prototype.

Fri Oct 24 07:55:00 2003  Stefan Urbanek <stefanu@altair.des.elf.stuba.sk>

	* Source/GSArray.m: make exception messages more informative.

Thu Oct 23 17:45:00 2003  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSSocketPort.m:
	([portWithNumber:onHost:forceAddress:listener:]) minor fix for bug
	reported by Bjorn Giesler ... was ignoring requested listening port.

2003-10-22  David Ayers  <d.ayers@inode.at>

	* Source/NSConcreteNumber.h: Moved here from
	Headers/Foundation/NSConcreteNumber.h.  
	* Source/GNUmakefile: Make NSConcreteNumber.h private.  
	* Source/NSConcreteNumber.m: Include NSConcreteNumber.h from new
	location.  
	* Source/NSNumber.m: Ditto.
	* Source/NSURL.m: Include NSValue.h in favor of private
	NSConcreteNumber.h.  
	* Source/NSURLHandle.m: Do not include NSConcreteNumber.h.

2003-10-21  Adam Fedor  <fedor@gnu.org>

	* Source/Makefile.postamble (libgnustep-base.def): Generate at
	compile time using the proper dependencies.

Tue Oct 21 18:00:00 2003  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSDistantObject.m: Retain local objects on creation,
	and release on deallocation ... don't depend on the connection
	to do it.
	* Source/NSConnection.m: Restructured handling of proxies ...
	remove global tables of local object references and just look in all
	connections and cache when a local object cannot be found in the
	current connection.
	Don't retain local objects ... depend on the NSDistantObject class
	to do that.
	Don't keep counters of the number of connections in which a local
	object reference is used ... it's not needed if we don't need to
	track whether to release the local object or not.
	Shorten timeout for deferred deallocation of local object references
	(temporary measure).
	* Headers/Foundation/NSDistantObject.h: new ivar for future use
	keeping track of number of times an object is vended.

Tue Oct 21 15:25:00 2003  Richard Frith-Macdonald <rfm@gnu.org>

	* Testing/nsconnection_client.m: Add -r option.
	* Testing/nsconnection_server.m: support registration/degeristration
	* Testing/server.h: New methods.
	Add a test (-r) to have the client repeated register/unregister
	with server, and have server do a callback to the registered object.
	Should cause a crash if the retain counts of proxies get out of sync.

Mon Oct 20 16:50:00 2003  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Additions/GNUstepBase/GSMime.h: Fix missing copying method
	declararations.

Sat Oct 18 07:10:00 2003  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/Unicode.m: Allow GNUSTEP_STRING_ENCODING to give
	any supported iconv name in additiuon to OpenStep names.  Make check
	case insensitive.
	Documentation/Base.gsdoc: Remove obsolete comment that
	GNUSTEP_STRING_ENCODING may not specify a mu7ltibyte encoding.

2003-10-16  Bruno Haible  <bruno@clisp.org>

        * Source/NSString.m (initWithContentsOfFile:, initWithContentsOfURL:):
        Fix recognition of UTF-8 BOM.

Fri Oct 17 14:28:49 2003  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/GNUmakefile (LIBRARY_VAR): Unused variable removed.
	* Source/GNUmakefile (srcdir): Variable removed.
	* Source/Makefile.preamble: Removed references to srcdir.
	* Source/Makefile.postamble: Same changes.
	* Source/Makefile.preamble (ADDITIONAL_LIB_DIRS): Use
	$(GNUSTEP_OBJ_DIR), not ./$(GNUSTEP_OBJ_DIR).
	
Fri Oct 17 14:15:33 2003  Nicola Pero  <n.pero@mi.flashnet.it>

	* Makefile.postamble (.PHONY): Unused target removed.
	* Makefile.postamble: Use ECHO_NOTHING, ECHO_CREATING, END_ECHO.
	(after-distclean): Clean everything in a single command.
	
Fri Oct 17 14:04:27 2003  Nicola Pero  <n.pero@mi.flashnet.it>

	* Makefile.postamble (regenerate, stamp-regenerate): Do-nothing
	targets removed.
	* Tools/Makefile.postamble (after-install): Use ECHO_NOTHING, END_ECHO.
	* Tools/Makefile.preamble: Commented out unused line.

Thu Oct 16 21:45:00 2003  Richard Frith-Macdonald <rfm@gnu.org>

	* GSPrivate.h: Try to think of better macro names and documentation
	for stack/heap allocation.
	* NSArray.m: Use new macro names.

Thu Oct 16 19:30:00 2003  Richard Frith-Macdonald <rfm@gnu.org>

	* configure.ac: Check for sigaction()
	* configure: regenerate
	* Headers/Additions/GNUstepBase/config.h.in: Notice sigaction
	* Source/GSFileHandle.m: Remove SIGPIPE code
	* Source/GSTcpPort.m: ditto
	* Source/NSMessagePort.m: ditto
	* Source/NSSocketPort.m: ditto
	* Source/NSObject.m: New code to ignore SIGPIPE unless it's being
	explicitly handled.  Use sigaction so we can test to see if there
	is a handler installed without temporarily unsetting it (as signal
	does) so that it is safe in a multi-threaded system.

Thu Oct 16 16:45:00 2003  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSFileHandle.m:
	* Source/NSMessagePort.m:
	* Source/NSSocketPort.m: Only ignore SIGPIPE if there is no
	handler set up for it.  If some other code has set up a handler
        before GNUstep code is used, we should not be overriding that
	handler as the external code may later depend on receiving the
	signal.  Many thanks to Nicola for the investigative work
	leading up to this realisation.

Thu Oct 16 15:57:39 2003  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/NSObject.m: Do not include signal.h.

Wed Oct 15 12:36:33 2003  Nicola Pero  <n.pero@mi.flashnet.it>

	* SSL/Makefile.postamble: Removed regenerate, TAGS and FORCE
	rules.  Removed rule that GSSSLHandle.o depends on
	GNUSTEP_TARGET_DIR/config.h - this dependency is automatically
	determined by gnustep-make.

Wed Oct 15 12:17:24 2003  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/Makefile.postamble: Removed regenerate, TAGS and FORCE
	rules.

Wed Oct 15 12:14:32 2003  Nicola Pero  <n.pero@mi.flashnet.it>

	* NSTimeZones/GNUmakefile: Removed DIST_FILES variable.
	* NSTimeZones/Makefile.postamble: Removed regenerate rule.

Wed Oct 15 12:10:35 2003  Nicola Pero  <n.pero@mi.flashnet.it>

	* Tools/GNUmakefile: Removed HEADERS, SOURCES, DIST_FILES
	variables.
	* Tools/Makefile.postamble: Removed regenerate, copy-dist and
	documentation rules.
	
Wed Oct 15 11:48:42 2003  Nicola Pero  <n.pero@mi.flashnet.it>

	* Testing/GNUmakefile: Removed HDRS, SRCS, DIST_FILES,
	DYNAMIC_HFILES, DYNAMIC_MFILES variables.  Do not set
	GNUSTEP_INSTALLATION_DIR.  Manually disable installation
	of LoadMe bundle.
	* Testing/Makefile.postamble: Removed regenerate and copy-dist
	rules.

Wed Oct 15 11:36:49 2003  Nicola Pero  <n.pero@mi.flashnet.it>

	* Examples/GNUmakefile: Removed HDRS, SRCS, DIST_FILES variables.
	Do not set GNUSTEP_INSTALLATION_DIR.
	* Examples/Makefile.postamble: Removed regenerate and copy-dist
	rules.
	
Wed Oct 15 11:23:43 2003  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/Makefile.postamble: Removed rules to rebuild object files
	depending on headers included.  gnustep-make does it automatically
	without the need of keeping lists updated.

2003-10-14  Bruno Haible  <bruno@clisp.org>

	* Source/NSString.m (parseQuotedString): Fix interpretation of
	octal escape sequences.

2003-10-14  Richard Frith-Macdonald <rfm@gnu.org>

	* GSPrivate.h: New macros to aid with appropriate use of stack
	or heap for allocating temporary storage.
	* NSArray.m: Use new OBUFBEGIN() and OBUFEND() macros.

2003-10-09  Adam Fedor  <fedor@gnu.org>

	* configure.ac: Add special check for sys/mount.h for NetBSD.

	* Testing/GNUmakefile: Only make CHECKABLE_TOOLS by default.

2003-10-09  Richard Frith-Macdonald <rfm@gnu.org>

	* GSArray.m: memory leak decoding a placeholder fixed.
	Patch by <Roland.Schwingel@onevision.de>

2003-10-08  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/gdomap.c: Added some checks that getting/setting uid/gid
	worked as expected and moved getpwnam() call to where it works.
	* Source/Additions/GSMime.m: ([GSMimeDocument-rawMimeData:]) bugfix
	to remove mjime version header from inner documents.
	* Source/NSDebug.m: Additional functions for tracking memory problems.
	* Source/NSBundle.m: Fixup for windows.
	* Source/NSFileManager.m: Fixup for windows.
	* Source/NSString.m: Fixup for windows.
	Windows fixups adapted from patch by <Roland.Schwingel@onevision.de>
	* Source/NSArray.m: Fix memory leak initialising from coder.
	* Source/NSCountedSet.m: ditto
	* Source/NSSet.m: ditto
	* Source/NSDebug.m: Hook to change allocation checking functions.
	Memory fixes adapted from patch by <Roland.Schwingel@onevision.de>

2003-10-07  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSMime.m: ([GSMimeDocument-setContentType:])
	New convenience method.

2003-10-05  Adam Fedor  <fedor@gnu.org>

	* Documentation/GNUmakefile: Make manual
	* Source/DocMakefile: Remove dependencies file when cleaning.

	* Version: Bump to 1.8.90

2003-10-03  Adam Fedor  <fedor@gnu.org>

	* configure.ac: Use -Wl for netbsd linker options.

2003-10-02  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSMime.m: ([GSMimeDocument-makeBoundary])
	fixed memory leak.

2003-09-30  Adam Fedor  <fedor@gnu.org>

	* config/procfs.m4: Force disable /proc on Irix. Force enable
	on cygwin.

2003-09-30  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSThread.m: Protect the function handling notification
	of the process becoming multi-threaded with a recursive lock.
	This protection ensures that there is no race condition where
	two threads can start using GNUstep simultaneously and both
	end up sending out notifications etc.  Not a problem in normal
	ObjC applications, but a possibility where other non-gnustep
	code starts multiple threads which want to access gnustep.

2003-09-30  Derek Zhou <dzhou@chrontel.com>

	* Source/NSCharacterSet.m: patch to ensure lock is created as
	soon as the process goes multi-threaded, therefore avoiding
	a race condition causing a rare exception.

2003-09-26  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSString.m: Fix pathExtension bug reported by Roland
	Schwingel.  Was failing to handle the case when a dot appears 
	inside a path component properly.

2003-09-26  Adam Fedor  <fedor@gnu.org>

	* Version 1.8.0 on branch.

2003-09-25  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSConnection.m: Fix obscure bug releasing in-progress
	request information on connection deallocation.

2003-09-23  Adam Fedor  <fedor@gnu.org>

	* Source/Additions/Makefile.preamble: Add DLL build flag for cyginw

	* Testing/Makefile.postamble (check): Make CHECKABLE_TOOLS only

	* Tools/AGSHtml.m: Remove duplicate interface (on *-apple-*)
	* Tools/AGSIndex.m: Idem.

2003-09-23  Adam Fedor  <fedor@gnu.org>

	* Source/NSTimeZone.m (+systemTimeZone): Remove tzname extern decl.

2003-09-22  Adam Fedor  <fedor@gnu.org>

	* configure.ac: Check for getopt
	* Tools/gdomap.c: Use local getopt if no native getopt

2003-09-21  Adam Fedor  <fedor@gnu.org>

	* Tools/cvtenc.m (main): Write using local/set encoding when
	EscapeIn=YES.

	* Documentation/coding-standards.texi: Add section about object
	persistance.

	* configure.ac: Make it possible to override --enable-pass-arguments
	when on cygwin.
	* configure: Regenerate using 2.57

2003-09-20  yjchen <yjchenx@hotmail.com>

	* Resources/Languages/TraditionalChinese: Quote escaped strings.

2003-09-13  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSConnection.m: Add a couple of checks to raise exceptions
	when trying to use a connection from the wrong thread.  Also, change
	the code for handling multithreaded connections so that they are
	removed from the runloops of exiting threads in response to the
	thread exit notification.

2003-09-13  David Ayers  <d.ayers@inode.at>

	* Headers/Additions/GNUstepBase/GSCategories.h: Move declarations
	from Source/Additions/GSCompatibility.h to here.
	([NSObject -compare:]): Deprecate.
	* Source/Additions/GSCompatibility.h: Move contents from here to
	Headers/Additions/GNUstepBase/GSCategories.h.

	* Source/Additions/GSCategories.m: 
	([NSObject -compare:]): Deprecate.
	
	* Headers/Foundation/NSObject.h
	([NSObject -compare:]): Deprecate.

	* Source/Additions/GCDictionary.m: Include
	GNUstepBase/GSCategories.h rather than GSCompatibility.h.
	* Source/Additions/GCObject.m: Ditto.
	* Source/Additions/GSMime.m: Ditto.
	* Source/Additions/GSObjCRuntime.m: Ditto.
	* Source/Additions/GSXML.m: Ditto.
	* Source/Additions/Unicode.m: Ditto.

	* macosx/GNUstepBase/preface.h: Update include for new header
	structure.

2003-09-11  Adam Fedor  <fedor@gnu.org>

	* macosx/preface.h: Removed
	* macosx/GNUstepBase/preface.h: New
	* macosx/gnustep.pbproj/project.pbxproj: Update
	(from Philip Moetteli  <philip.moetteli@tele2.ch>).

2003-09-11  Philip Moetteli  <philip.moetteli@tele2.ch>

	* Source/Additions/GSCompatibility.h
	* Source/Additions/GSCompatibility.m
	(NSDecimalFromComponents): Added compatibility function.

2003-09-11  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Unicode.m: Fix minor errors in utf8 handling.
	Use endian version of UTF16 to avoid iconv inserting BOM where
	it is not wanted.

2003-09-10  David Ayers  <d.ayers@inode.at>

	* Headers/Additions/GNUstepBase/GSObjCRuntime.h (GSObjCSuper):
	Added test for uninitialized superclass reference.

2003-09-10  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSObject.m: Tidy use of GSObjCRuntime a little.

2003-09-10  Pete French <pete@twisted.org.uk>

	* Source/Additions/Unicode.m: patch to use UTF16 rather than
	UCS2 internally.

2003-09-10  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSCalendarDate.m:
	([years:months:days:hours:minutes:seconds:sinceDate:]) fix to return
	all positive values for a difference from a date in the past.

2003-09-07  Adam Fedor  <fedor@gnu.org>

	* Source/NSBundle.m (+_addFrameworkFromClass:): Check
	_loadingBundle != bundle when removing classes.

2003-09-07  S.J.Chun <chunsj@embian.com>

	* Source/Unicode.m: Added Korean encoding
	* Headers/Foundation/NSString.h: Added Korean encoding
	* Source/Additions/GSCompatibility.h: Idem.

Sun Sep  7 13:35:15 2003  Nicola Pero  <n.pero@mi.flashnet.it>

	* configure.ac: Fixed GNUSTEP_HDIR when not flattened.
	* configure: Regenerated.

2003-09-05  Adam Fedor  <fedor@gnu.org>

	* Headers/Additions/GNUstepBase/behavior.h: GS_EXPORT functions.

2003-09-04 18:41  Alexander Malmberg <alexander@malmberg.org>

	* Headers/Foundation/NSDistributedLock.h, Source/NSDistributedLock.m:
	Change return type of -initWithPath: to id.

2003-09-02  Adam Fedor  <fedor@gnu.org>

	* configure.ac: Check for tzset
	* Source/NSTimeZone.m (+systemTimeZone): Use it to find time zone
	(as a last resort).

2003-09-02  Adam Fedor  <fedor@gnu.org>

	* Tools/gdnc.m (main): Don't mess with file descriptors on MinGW.

2003-09-01  Adam Fedor  <fedor@gnu.org>

	* Tools/gdomap.c (main): Move getuid call inside #ifndef MINGW
	like the others.

2003-08-31  Adam Fedor  <fedor@gnu.org>

	* Tools/gdnc.m (main): Close any open file descriptors so we can
	be a proper daemon.  
	Fixes #4938.

2003-08-29  Adam Fedor  <fedor@gnu.org>

	* config/procfs.m4: Disable procfs for solaris

2003-08-26  Adam Fedor  <fedor@gnu.org>

	* Source/NSMessagePort.m: For older OS comptibility, define some
	macros if they are not already defined.
	* Source/NSMessagePortNameServer.m: Idem.

2003-08-24  David Ayers  <d.ayers@inode.at>

	* Headers/Additions/GNUstepBase/GSObjCRuntime.h
	(GSObjCClass):  Allow nil values.
	(GSObjCIsInstance): Ditto.
	(GSObjCIsClass): New function.
	(GSClassNameFromObject): Ditto.
	(GSObjCIsKindOf):  Use GSObjCSuper() in favor of
	class_get_super_class().

	* Headers/Foundation/NSRange.h
	(GS_RANGE_CHECK), (CHECK_INDEX_RANGE_ERROR):
	Use GSNameFromSelector() in favor of sel_get_name().

	* Source/GSFFCallInvocation.m
	(gs_method_for_receiver_and_selector), (gs_find_best_typed_sel),
	(-[GSFFCallInvocation invokeWithTarget:]), (GSInvocationCallback):
	Use GSObjCIsInstance() in favor of object_is_instance,
	GSObjCClass() in favor of object_get_class(),
	GSObjCIsClass() in favor of object_is_class(),
	GSNameFromSelector() in favor of sel_get_name(),
	GSObjCSuper() in favor of class_get_super_class() and
	GSClassNameFromObject() in  favor of object_get_class_name().  

	* Source/GSFFIInvocation.m
	(gs_method_for_receiver_and_selector), (gs_find_best_typed_sel),
	(-[GSFFIInvocation invokeWithTarget:]), (GSFFIInvocationCallback):
	Use GSObjCIsInstance() in favor of object_is_instance,
	GSObjCClass() in favor of object_get_class(),
	GSObjCIsClass() in favor of object_is_class(),
	GSNameFromSelector() in favor of sel_get_name(),
	GSObjCSuper() in favor of class_get_super_class() and
	GSClassNameFromObject() in  favor of object_get_class_name().

	* Source/NSConnection.m
	(-[NSConnection forwardForProxy:selector:argFrame:]),
	(-[NSConnection forwardInvocation:forProxy:]):
	Use GSNameFromSelector() in favor of sel_get_name().

	* Source/NSDistantObject.m
	(class_is_kind_of): Use GSObjCSuper in favor of
	class_get_super_class().
	(-[NSDistantObject forward::]): Use GSNameFromSelector() in favor of
	sel_get_name().

	* Source/NSInvocation.m
	(-[NSInvocation invokeWithTarget:])
	Use GSObjCSuper() in favor of class_get_super_class(),
	GSObjCIsInstance() in favor of object_is_instance()
	(-[NSInvocation description]):
	Use GSClassNameFromObject in favor of object_get_class_name().
	Avoid buffer overflow by using snprintf() in favor of sprintf().
	(-[NSInvocation initWithSelector:]):
	Use GSNameFromSelector() in favor of sel_get_name().

	* Source/NSObject.m
	(GSDescriptionForInstanceMethod), (GSDescriptionForClassMethod),
	(+[NSObject superclass], (-[NSObject description]),
	(-[NSObject doesNotRecognizeSelector:]),
	(-[NSObject performSelector:]),
	(-[NSObject performSelector:withObject:]),
	(+[NSObject setVersion:], -[NSObject error:]),
	(-[NSObject doesNotRecognize:], -[NSObject isClass]),
	(-[Object description]):
	Use GSNameFromSelector() in favor of sel_get_name(),
	GSObjCSuper() in favor of class_get_super_class(),
	GSClassNameFromObject() in favor of object_get_class_name() and
	GSObjCIsClass() in favor of object_is_class().

	* Source/NSProxy.m
	(+[NSProxy description]), (-[NSProxy description]),
	(+[NSProxy superclass]), (-[NSProxy forwardInvocation:]),
	(-[NSProxy init], (-[NSProxy notImplemented:]),
	(-[NSProxy performSelector:]),
	(-[NSProxy performSelector:withObject:]),
	(-[NSProxy performSelector:withObject:withObject:]):
	Use GSClassNameFromObject() in favor of object_get_class_name(),
	GSObjCSuper() in favor of class_get_super_class() and
	GSNameFromSelector() in favor of sel_get_name().

	* Source/Additions/GSCategories.m
	(-[NSObject notImplemented:]), (-[NSObject shouldNotImplement:]),
	(-[NSObject subclassResponsibility:]):
	Use GSNameFromSelector() in favor of sel_get_name() and
	GSClassNameFromObject() in favor of object_get_class_name().

	* Source/Additions/GSCompatibility.h
	(GS_RANGE_CHECK): Use GSNameFromSelector() in favor of
	sel_get_name().

	* Source/Additions/GSCompatibility.m
	(+[NSObject notImplemented:]):
	Use GSNameFromSelector() in favor of sel_get_name() and
	GSClassNameFromObject() in favor of object_get_class_name().

	* Source/Additions/GSObjCRuntime.m
	(GSObjCMethodNames), (GSObjCAddMethods):
	Use GSNameFromSelector() in favor of sel_get_name().

	* Testing/nsbundle.m (main): Update to reflect filesystem change.
	Use GSClassNameFromObject() in favor of object_get_class_name().

	* Testing/nsconnection_server.m
	Use GSNameFromSelector() in favor of sel_get_name().

	* Testing/Makefile.postamble: Build before checking.

2003-08-23  Adam Fedor  <fedor@gnu.org>

	* Version 1.7.3

2003-08-23  Adam Fedor  <fedor@gnu.org>

	* configure.ac: Fix mistake in checking for ffi.

	* Tools/AGSIndex.m: Add NSString compatibility interface
	when compiling on apple-apple-apple.
	* Tools/AGSHtml.m: idem.

2003-08-15  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSObject.m: Trivial cast to avoid compiler warnings.

2003-08-20 13:59  Alexander Malmberg <alexander@malmberg.org>

	Clean up code to remove warnings issued by (what will become)
	gcc 3.4.

	* Source/GSString.m, Source/NSArchiver.m, Source/NSAttributedString.m,
	Source/NSRunLoop.m: Don't return values from methods returning void.

2003-08-19  Adam Fedor  <fedor@gnu.org>

	* configure.ac: Clarify ffi interface warnings and disable_do on
	apple-apple-apple.
	Fixes #4824

2003-08-15  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSObject.m: Move hacked methods for getting protocol
	method info into functions so we can use them without going
	through the ObjC runtime.
	* Source/NSDistantObject.m: When attempting to check protocols,
	use functions from NSObject.m if the protocol has not been
	properly initialised (its class pointer is 0x2) as is the case
	for all but very recent versions of the compiler.
	FIXME ... this code should be removed at some future date when
	all common systems have shipped with a working compiler for
	a while.

2003-08-13  David Ayers  <d.ayers@inode.at>

	* Headers/Additions/GNUstepBase/preface.h: Remove generated
	file that should have been ignored by entry in .cvsignore.
	* Source/UnixFileHandle.m: Remove obsolete file.
	
2003-08-05  Martin Brecher <martin@mb-itconsulting.com>

	* Tools/gdnc.1: Updated man pages, fixed typos, unified format 
	and layout.  Man pages are now installed unprocessed as it should be.
	* Tools/gdomap.8: ditto.

2003-08-12  Yen-Ju Chen <yjchenx@hotmail.com>

	* Source/Additions/Unicode.m (GetAvailableEncodings): Include
	last encoding.

2003-08-08  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSXML.m: save and restore libxml global settings
	before/after each parse operation.

2003-08-07  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSString.m: nodeToObject() fix error in handling escape
	sequences in strings ... only treat a backslash specially when it
	is immediately followed by 'U' or 'u' and four hexadecimal digits.
	ensure data ia deallocated promptly.
	* Source/GSCompatibility.m: match changes to property list escapes
	* Source/Additions/GSXML.m: change ownership policy so that nodes
	are owned by theri parents, never by siblings ... prevent stack
	overflow deallocating nodes in long documents.
	* Tools/plist-0_9.dtd: document unicode escapes.

2003-08-02  Adam Fedor  <fedor@gnu.org>

	* Source/NSProxy.m: Fix limit.h -> limits.h

2003-08-02  Yen-Ju Chen <yjchenx@hotmail.com>

	* Resources/Languages/TraditionalChinese,
	Resources/TraditionalChinese.lproj: New
	* Resources/GNUmakefile: Install them.

2003-08-01  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSProxy.m: Include  limits.h for UINT_MAX
	* Source/NSProcessInfo.m: Avoid crash when given invalid argument list
	* Source/NSString.m: Minor cleanup for coding standards and remove
	pointer dereferencing of object which causes problems with new
	compiler
	Problems reported by Alexander and Roland

2003-07-31  David Ayers  <d.ayers@inode.at>

	* Created tag 'pre-header-reorg-20030731'.

	* Headers/Additions/GNUstepBase: New directory.
	* Headers/Additions/GNUstepBase/unicode: Ditto.
	* Headers/Foundation: Ditto.
	* Headers/gnustep/base: Obsoleted.
	* Headers/gnustep/unicode: Ditto.

	* Headers/Additions/GNUstepBase/DistributedObjects.h: Moved here
	from Headers/gnustep/base.
	* Headers/Additions/GNUstepBase/GCObject.h: Ditto.
	* Headers/Additions/GNUstepBase/GNUstep.h: Ditto.
	* Headers/Additions/GNUstepBase/GSCategories.h: Ditto.
	* Headers/Additions/GNUstepBase/GSConfig.h.in: Ditto.
	* Headers/Additions/GNUstepBase/GSFileHandle.h: Ditto.
	* Headers/Additions/GNUstepBase/GSIArray.h: Ditto.
	* Headers/Additions/GNUstepBase/GSIMap.h: Ditto.
	* Headers/Additions/GNUstepBase/GSLocale.h: Ditto.
	* Headers/Additions/GNUstepBase/GSMime.h: Ditto.
	* Headers/Additions/GNUstepBase/GSObjCRuntime.h: Ditto.
	* Headers/Additions/GNUstepBase/GSUnion.h: Ditto.
	* Headers/Additions/GNUstepBase/GSXML.h: Ditto.
	* Headers/Additions/GNUstepBase/Unicode.h: Ditto.
	* Headers/Additions/GNUstepBase/behavior.h: Ditto.
	* Headers/Additions/GNUstepBase/config.h.in: Ditto.
	* Headers/Additions/GNUstepBase/objc-gnu2next.h: Ditto.
	* Headers/Additions/GNUstepBase/preface.h.in: Ditto.
	* Headers/Additions/GNUstepBase/thr-mach.h: Ditto.
	* Headers/Additions/GNUstepBase/.cvsignore: Ditto.

	* Headers/Additions/GNUstepBase/unicode/caseconv.h: Moved here
	from Headers/gnustep/unicode.
	* Headers/Additions/GNUstepBase/unicode/cop.h: Ditto.
	* Headers/Additions/GNUstepBase/unicode/cyrillic.h: Ditto.
	* Headers/Additions/GNUstepBase/unicode/decomp.h: Ditto.
	* Headers/Additions/GNUstepBase/unicode/gsm0338.h: Ditto.
	* Headers/Additions/GNUstepBase/unicode/latin2.h: Ditto.
	* Headers/Additions/GNUstepBase/unicode/latin9.h: Ditto.
	* Headers/Additions/GNUstepBase/unicode/nextstep.h: Ditto.
	* Headers/Additions/GNUstepBase/unicode/thai.h: Ditto.

	* Headers/Foundation/Foundation.h: Moved here from
	Headers/gnustep/base.
	* Headers/Foundation/NSArchiver.h: Ditto.
	* Headers/Foundation/NSArray.h: Ditto.
	* Headers/Foundation/NSAttributedString.h: Ditto.
	* Headers/Foundation/NSAutoreleasePool.h: Ditto.
	* Headers/Foundation/NSBitmapCharSet.h: Ditto.
	* Headers/Foundation/NSBundle.h: Ditto.
	* Headers/Foundation/NSByteOrder.h: Ditto.
	* Headers/Foundation/NSCalendarDate.h: Ditto.
	* Headers/Foundation/NSCharacterSet.h: Ditto.
	* Headers/Foundation/NSClassDescription.h: Ditto.
	* Headers/Foundation/NSCoder.h: Ditto.
	* Headers/Foundation/NSConcreteNumber.h: Ditto.
	* Headers/Foundation/NSConnection.h: Ditto.
	* Headers/Foundation/NSData.h: Ditto.
	* Headers/Foundation/NSDate.h: Ditto.
	* Headers/Foundation/NSDateFormatter.h: Ditto.
	* Headers/Foundation/NSDebug.h: Ditto.
	* Headers/Foundation/NSDecimal.h: Ditto.
	* Headers/Foundation/NSDecimalNumber.h: Ditto.
	* Headers/Foundation/NSDictionary.h: Ditto.
	* Headers/Foundation/NSDistantObject.h: Ditto.
	* Headers/Foundation/NSDistributedLock.h: Ditto.
	* Headers/Foundation/NSDistributedNotificationCenter.h: Ditto.
	* Headers/Foundation/NSEnumerator.h: Ditto.
	* Headers/Foundation/NSException.h: Ditto.
	* Headers/Foundation/NSFileHandle.h: Ditto.
	* Headers/Foundation/NSFileManager.h: Ditto.
	* Headers/Foundation/NSFormatter.h: Ditto.
	* Headers/Foundation/NSGeometry.h: Ditto.
	* Headers/Foundation/NSHashTable.h: Ditto.
	* Headers/Foundation/NSHost.h: Ditto.
	* Headers/Foundation/NSInvocation.h: Ditto.
	* Headers/Foundation/NSKeyValueCoding.h: Ditto.
	* Headers/Foundation/NSLock.h: Ditto.
	* Headers/Foundation/NSMapTable.h: Ditto.
	* Headers/Foundation/NSMethodSignature.h: Ditto.
	* Headers/Foundation/NSNotification.h: Ditto.
	* Headers/Foundation/NSNotificationQueue.h: Ditto.
	* Headers/Foundation/NSNull.h: Ditto.
	* Headers/Foundation/NSNumberFormatter.h: Ditto.
	* Headers/Foundation/NSObjCRuntime.h: Ditto.
	* Headers/Foundation/NSObject.h: Ditto.
	* Headers/Foundation/NSPathUtilities.h: Ditto.
	* Headers/Foundation/NSPort.h: Ditto.
	* Headers/Foundation/NSPortCoder.h: Ditto.
	* Headers/Foundation/NSPortMessage.h: Ditto.
	* Headers/Foundation/NSPortNameServer.h: Ditto.
	* Headers/Foundation/NSProcessInfo.h: Ditto.
	* Headers/Foundation/NSProtocolChecker.h: Ditto.
	* Headers/Foundation/NSProxy.h: Ditto.
	* Headers/Foundation/NSRange.h: Ditto.
	* Headers/Foundation/NSRunLoop.h: Ditto.
	* Headers/Foundation/NSScanner.h: Ditto.
	* Headers/Foundation/NSSerialization.h: Ditto.
	* Headers/Foundation/NSSet.h: Ditto.
	* Headers/Foundation/NSString.h: Ditto.
	* Headers/Foundation/NSTask.h: Ditto.
	* Headers/Foundation/NSThread.h: Ditto.
	* Headers/Foundation/NSTimeZone.h: Ditto.
	* Headers/Foundation/NSTimer.h: Ditto.
	* Headers/Foundation/NSURL.h: Ditto.
	* Headers/Foundation/NSURLHandle.h: Ditto.
	* Headers/Foundation/NSUndoManager.h: Ditto.
	* Headers/Foundation/NSUserDefaults.h: Ditto.
	* Headers/Foundation/NSUtilities.h: Ditto.
	* Headers/Foundation/NSValue.h: Ditto.
	* Headers/Foundation/NSZone.h: Ditto.
	
	* Soruce/GSFormat.h: Ditto.
	* Source/GSInvocation.h: Moved here from Headers/gnustep/base.
	* Source/objc-load.h: Ditto.

	* configure.ac: Update to new header structure.
	* configure: Regenerated.
	* Makefile.postamble: Remove handling of header-links and update
	to new header structure.

	* Source/GNUmakefile: Update to new header structure.  
	Always install GSFileHandle.h, GSLocal.h, GSUnion.h, GSIArray.h,
	GSIMap.h, preface.h as public headers.  
	Do not install DistributedObjects.h, objc-load.h and thr-mach.h.
	Install GSMime.h and GSXML.h in GNUstepBase instead of Foundation.
	Include CompatibilityHeaders.make makefile fragement.

	* Source/Makefile.preamble: Update to new header structure.
	Split HEADER_DIR into HEADER_DIR_BASE and HEADER_DIR_FND.

	* Source/Makefile.postamble: Update to new header structure.
	Do not install mframe.h.
	Update for HEADER_DIR split.
	
	* Source/CompatibilityHeaders.make: New file which installs dummy
	headers in the place of the old headers, warning about obsoleting
	the old location and includeing the header from its new location.

	* Source/Additions/Makefile.preamble: Update to new header
	structure.  Only add -I../../Headers for *-gnu-*.
	
	* Source/*.[hm]: Update includes for new header structure.
	* Source/Additions/*.m: Ditto.
	* Source/mframe/mframe.head: Ditto.
	* Source/.cvsignore: Ignore config.h.

	* Testing/Makefile.preamble: Update to new header structure.  Only
	add -I../../Headers for *-gnu-*.
	* Testing/*.[hm]: Update includes for new header structure.

	* Tools/Makefile.preamble: Update to new header structure.  Only
	add -I../../Headers for *-gnu-*.
	* Tools/*.[hm]: Update includes for new header structure.

	* Tools/make_strings/GNUmakefile.preamble: Update to new header
	structure.  Only add -I../../Headers for *-gnu-*.
	
	* Source/DocMakefile: Update to new header structure.

	* SSL/Makefile.preamble: Update to new header structure.
	* SSL/GSSSLHandle.m: Ditto.

	* Examples/Makefile.preamble: Use -I../Headers only with *-gnu-*.

	* Headers/gnustep/base/UnixFileHandle.h: Removed.
	* Headers/gnustep/base/WindowsFileHandle.h: Ditto.
	
2003-07-30  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/gdomap.c: Some security fixes and tweaks.

2003-07-28  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSFFCALLInvocation.m: Make exception text more meaningful
	* Source/GSFFIInvocation.m: ditto
	* Source/Additions/GSXML.m: Add a couple of convenience methods to
	test node type.
	* Source/Additions/GSMime.m: Add convenience method for putting
	a new header in a document.
	* Source/NSCalendarDate.m: Tweak to avoid useless compiler warning.
	* Source/NSRunLoop.m: ditto
	* Source/NSURL.m: ditto
	* Source/Additions/GSMime.m: ditto
	* Source/Additions/Unicode.m: ditto


2003-07-27  Gregory John Casamento <greg_casamento@yahoo.com> & 
	Alexander Malmberg <alexander@malmberg.org>

	* Source/Additions/GSObjCRuntime.m: GSObjCMethodNames was not
	returning all methods for the object given.
	
2003-07-27  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSInvocation.m: implement methodSignatureForSelector for
	proxy.

2003-07-26  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSFFCALLInvocation.m: Add evil hack to cope with cases
	where type info was not available and we assumed a method returning
	an id but the actual method returned void.
	* config/procfs.m4: Test for procfs using 'mount'

2003-07-25  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSDistributedNotificationCenter.m: Partially reverted last
	change ... seemed to cause problems on some systems.
	* Tools/gdnc.m: ditto.
	* Source/NSDebug.m: Small thread safely fix.
	* Source/NSThread.m: Avoid multiple copies of housekeeping timer.
	* Source/NSConnection.m: Fix thread related memory leak leaving
	an NSRunLoop in a connection when the connection is no longer
	using it.
	* Source/NSURL.m: retain handle while doing background load.

2003-07-23  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSObject.m: Implement methodSignatureForSelector for zombies
	* Source/DocMakefile: Only remove directory with stamp for 'clean'

2003-07-22  Adam Fedor  <fedor@gnu.org>

	* Version 1.7.2

2003-07-22  Jeremy Bettis  <jeremy@deadbeef.com>

	* Headers/gnustep/base/objc-gnu2next.h (class_nextMethodList):
	Fix macro to return the method list.

2003-07-22  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/AGSHtml.m: Don't output authors heading if not needed.
	* Source/NSUser.m: Use HOMEPATH in preference to USERPROFILE for
	OPENSTEP compatibility and because USERPROFILE generally doesn't
	work due to the presence of spaces.
	* Headers/gnustep/base/NSDebug.h: Minor documentation fix.
	* Headers/gnustep/base/NSHashTable.h: ditto
	* Headers/gnustep/base/NSPort.h: ditto
	* Headers/gnustep/base/NSPortNameServer.h: ditto
	* Source/DocMakefile: Document serialization classes
	* Source/NSDebug.m: Fix broken cross reference
	* Source/NSLog.m: ditto
	* Source/NSMessagePortNameServer.m: Tidied
	* Source/NSPortNameServer.m: Tidied and documented.
	* Source/NSSocketPortNameServer.m: Documented and fixed methods
	to return NO on failure rather than raising exception.
	* Source/NSUndoManager.m: Fix documentation markup errors.

2003-07-21  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/Unicode.m (GROW): Fix shifting of pointers into
	local buffer for case where we are leaving room for a null terminator.
	This avoids moving pointer back before start of buffer.

2003-07-21  Roland Schwingel <Roland.Schwingel@onevision.de>

	* Source/libgnustep-base-entry.m: Don't create unnecessary window.

Mon Jul 21 11:03:48 2003  Nicola Pero  <n.pero@mi.flashnet.it>

	* Tools/HTMLLinker.m: Removed.
	* Tools/HTMLLinker.html: Removed.
	* Tools/GNUmakefile: Do not compile it.
	
2003-07-20  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSProxy.m: Implement essential methods for a proxy to be
	vended over an NSConnection.

2003-07-20 17:27  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSConnection.m (-invalidate): Don't kill the targetToCached
	timer when invalidating a connection.

2003-07-20  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSThread.m: Separate out sleeping into a more efficient
	function and improve use of nanosleep
	* Source/NSLock.m: Use new private sleeping function from NSThread.m
	and rewrite code to be more responsive, especially for cases where
	locks are heavily used for rapid interaction between threads.
	* Tools/thread.m: Test lockBeforeDate

2003-07-17  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSRunLoop.m: ([-acceptInputForMode:beforeDate:]) use the
	NSThread method to sleep rather than re-implementing it.
	* configure.ac: Check for nanosleep()
	* Headers/Foundation/config.h.in: Add entry for nanosleep
	* Source/NSThread.m: Use nanosleep if available.
	* Headers/Foundation/NSProcessInfo.h: Added new methods -
	([-setDebugLoggingEnabled:]) and ([-debugLoggingEnabled])
	* Source/NSProcessInfo.m: ditto

2003-07-16  David Ayers  <d.ayers@inode.at>

	* config.make.in: Default to builing -baseadd on non *-gnu-*
	configurations.

2003-07-15  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/gnustep/base/NSArray.h: Add methods for creating from URL
	* Headers/gnustep/base/NSDictionary.h: ditto
	* Source/NSArray.m: ditto
	* Source/NSDictionary.m: ditto

2003-07-15  David Ayers  <d.ayers@inode.at>

	* Headers/gnustep/base/NSUndoManager.h: Add
	NSUndoCloseGroupingRunLoopOrdering enum.  Replace instance
	variables _registeredUndo with _runLoopGroupingPending and
	_actionName with _unused1.
	* Source/NSUndoManager.m: Added documentation.
	Added actionName instance variable to PrivateUndoGroup.
	(-[PrivateUndoGroup actionName]): New method.
	(-[PrivateUndoGroup setActionName]): Ditto.
	(-[PrivateUndoGroup dealloc]): Release new instance variable.
	(-[PrivateUndoGroup initWithParent:]): Initialize actionName.
	(-[NSUndoManager forwardInvocation]): Implicitly call
	beginUndoGrouping if group has not been setup and we are grouping
	by events.  Register _loop: invocation if none is already pending
	and if we are grouping by event.
	(-[NSUndoManager registerUndoWithTarget:selector:object]): Ditto.
	(-[NSUndoManager methodSignatureForSelector:]): Overriden to
	forward request to target supplied by
	-prepareWithInvocationTarget: if available.
	(-[NSUndoManager _loop:]): Set flag to determine pending _loop:
	processing.
	(-[NSUndoManager init]): Removed access to _actionName.  Have
	receiver default to group by event.
	(-[NSUndoManager dealloc]): Ditto.
	(-[NSUndoManager enableUndoRegistration]): Remove access to
	_registeredUndo.
	(-[NSUndoManager redo]): Simplified implementation.
	(-[NSUndoManager redoActionName:]: Retrieve action name from first
	grouping of the redo stack.
	(-[NSUndoManager redoMenuTitleForUndoActionName:]): Add comment
	about localization.
	(-[NSUndoManager undoMenuTitleForUndoActionName:]): Ditto.
	(-[NSUndoManager setActionName:]): Forward call to current
	grouping.
	(-[NSUndoManager undoActionName:]: Retrieve action name from first
	grouping of the undo stack.
	(-[NSUndoManager setRunLoopModes:]): Use correct run loop ordering
	and set flag for pending _loop: invocation.
	(-[NSUndoManager undoNestedGroup]): Removed special case handling
	of _registeredUndo.  Raise NSInternalInconsistencyException if
	grouping is still in progress.  Simplified implementation.

2003-07-15  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSConnection.m: When creating new connection with registered
	name on host, ensure that send and receive ports are of same class.
	* Source/NSMessagePort.m: New for private local connections.
	* Source/NSMessagePortNameServer.m: New for private local connections.
	* Source/NSPortNameServer.m: Made abstract
	* Source/NSSocketPortNameServer.m: Concrete version based on original.
	* Source/NSSocketPort.m: GSTcpPort.m renamed
	Alexanders modifications added by RFM and altered slightly to use
	NSSocketPort by default and to refrain from building new code under
	windows, so this *shouldn't* break any existing code I hope.

2003-07-15  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSDistributedNotificationCenter.m: Use loopback network
	interface for local center.
	* Tools/gdnc.m: ditto.

2003-07-11  David Ayers  <d.ayers@inode.at>

	* Source/GNUmakefile: Make GNUstep.h public.
	* Source/Additions/GSXML.m: Use cached NSString class variable. 
	* Source/Additions/GSObjCRuntime.m
	(GSCGetInstanceVariableDefinition): Make more robust.

2003-07-11  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSPort.h: Tweak for mingw and correct conditional
	compilation to only include NSSocketPort for MacOS-X
	* Source/GSFileHandle.m: Incorporate S.J.Chuns mingw fixes with huge
	simplification to avoid lots of conditional compilation.
	* Source/GSTcpPort.m: ditto.
	* Source/NSSocketPort.m: ditto.

2003-07-11 02:33  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSAssertionHandler.m: Use the correct key to store the
	NSAssertionHandler in the thread dictionary, and document the
	storing and the key.

2003-07-09 15:54  Alexander Malmberg <alexander@malmberg.org>

	* Source/Additions/Unicode.m (GSToUnicode, GSFromUnicode): Make sure
	dst isn't set to NULL in GSToUnicode, too. Make sure it is set if
	an allocated buffer turns out not to need resizing.

2003-07-09 02:41  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSString.m (getCString_u): Rewrite to correctly handle
	all encodings, the range argument, and the leftoverRange attribute.

	* Source/Additions/Unicode.m (GSToUnicode): Clarify the documentation
	(and fix a few typos in it).
	(GSFromUnicode): Clarify the documentation. Signal failure correctly
	from the utf8 encoder. Make sure dst isn't set to NULL if zone is
	NULL but *size is 0.

2003-07-08  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSString.m: Avoid using atof() in parsing plists ... we
	don't want libc localised handling of numbers.

2003-07-08 03:44  Alexander Malmberg <alexander@malmberg.org>

	* Source/Additions/Unicode.m (GSToUnicode, GSFromUnicode): In iconv
	case, only try to expand the buffer when we really need extra space.
	Correctly handle all output from flushing iconv.

2003-07-08 03:03  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSConnection.m (-locateLocalTarget:): The targetToCached
	map contains CachedLocalObject:s, not GSLocalCounter:s. Extract the
	GSLocalCounter from the CachedLocalObject.

	Unlock the global_proxies_gate lock before calling
	-proxyWithLocal:connection:.

2003-07-07  David Ayers  <d.ayers@inode.at>
	
	* Headers/gnustep/base/GSObjCRuntime.h:
	* Source/Additions/GSObjCRuntime.m:
	Added typedef for GSIVar.
	(GSCGetInstanceVariableDefinition): New function.
	(GSObjCGetInstanceVariableDefinition): Ditto.
	* Testing/nstimer.m ([TestDouble -sayCount]): Quit test after 20
	invocations.

2003-07-07  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Source/GSFFCallInvocation.m: gs_objc_msg_forward() trust the
	selector we are given. Rather than trying to find a better one.
	* Source/GSFFIInvocation.m: ditto
	* Source/NSScanner.m: Add a couple of internal utility functions.
	* Source/NSString.m: Fix floatValue and doubelValue to use non
	localised conversions.
	* Source/GSString.m: ditto.

2003-07-06  Adam Fedor  <fedor@gnu.org>

	* configure.ac: Add -R flags for netbsdelf

2003-07-06  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/AGSHtml.m: Fix bug in linking to category methods from index.
	* Tools/AGSParser.m: Improve parsing of clock comments.

2003-07-05  Adam Fedor  <fedor@gnu.org>

	* configure.ac: Add flags for openbsd like freebsd.

	* Tools/gdnc.1, Tools/gdomap.8: Unzip
	* Tools/GNUmakefile (MAN1_PAGES): gzip man pages.

2003-07-04  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSDistributedNotificationCenter.m: Use -setProtocolForProxy:
	and implement dummy class to work around bug in old compilers.
	* Tools/gdnc.m: ditto
	* Source/NSDistantObject.m: Fix for calls to remote system where we
	can get no method signature.
	Documented.

2003-07-04  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Source/GSFFCallInvocation.m: Modify to use local type
	information if it looks like it has come from a protocol ...
	as too much existing code is broken in that DO server objects
	which are supposed to conform to protocols in fact do not!
	* Source/GSFFIInvocation.m: ditto

Fri Jul  4 11:09:37 2003  Nicola Pero  <n.pero@mi.flashnet.it>

	* NSTimeZones/Makefile.postamble: Make the code more robust by
	adding rule to create the installation dirs.

2003-07-04  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSDistantObject.m: Avoid recursion fetching method signature.
	* Source/NSObject.m: ([methodSignatureForSelector:]) modified to take
	into account any protocols that the receiver conforms to, so the
	returned signature has the fullest possible type information.
	Category Protocol(Fixup) ... evil hack to work around runtime bug.
	* Source/GSFFCallInvocation.m: Fetch method signature from receiver
	in preference to using other info.  Ensures we have correct info for
	the object we are sending the message to.
	* Source/GSFFIInvocation.m: ditto

2003-07-03  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSCalendarDate: ([-initWithString:calendarFormat:]) default
	year to 0001 s the gregorian calendar does not go earlier.
	([-initWithYear:month:day:hour:minute:second:timeZone:]) don't
	override a previously set calendar format.

2003-07-01  David Ayers  <d.ayers@inode.at>

	* Headers/gnustep/base/GSObjCRuntime.h/m (GSPrintf),
	* Headers/gnustep/base/NSObjCRuntime.h (GSPrintf),
	* Source/NSLog.m (GSPrintf): Moved implementation from NSLog.m to
	GSObjCRuntime.m and declaration from NSObjCRuntime.h to
	GSObjCRuntime.h.

2003-07-01  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/Unicode.m: Flush iconv buffer at end of conversion
	to handle obscure cases where it says it has converted all the input
	sequence, but hasn't written all the output.

2003-06-30  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/Unicode.m: Add 'UTF-7' so iconv can be used to
	handle utf7 if available.
	* Tools/AGSParser.m: Don't always strip asterisks from comments,
	Check first line of comment to see if it has one first.

2003-06-28 15:48  Alexander Malmberg <alexander@malmberg.org>

	* Tools/make_strings/StringsFile.h, Tools/make_strings/StringsFile.m,
	Tools/make_strings/make_strings.h, Tools/make_strings/make_strings.m:
	Clean up handling of key matching and ignoring. Add
	--aggressive-remove option.

2003-06-28  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSBundle.m: Don't NSLog when we can't find a localizable
	file ... log only when bundle debugging is turned on.

2003-06-27  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSPipe.m: Fix descriptor leak ... close on dealloc

2003-06-25  Adam Fedor  <fedor@gnu.org>

	* Tools/gdnc.1.gz: New file (from Martin Brecher).
	* Tools/GNUmakefile (MAN1_PAGES): Install it

2003-06-24  David Ayers  <d.ayers@inode.at>

	* Source/GSFFCallInvocation.m
	(gs_method_for_receiver_and_selector): Replace usage of
	class_get_instance/class_method with GSGetInstance/ClassMethod and
	Method_t with GSMethod.
	(gs_find_by_receiver_best_typed_sel): Ditto.
	(GSInvocationCallback): Ditto.
	([GSFFCallInvocation -invokeWithTarget:]): Ditto.
	* Source/GSFFIInvocation.m
	(gs_method_for_receiver_and_selector): Ditto.
	(gs_find_by_receiver_best_typed_sel): Ditto.
	(GSFFIInvocationCallback): Ditto.
	([GSFFIInvocation -invokeWithTarget:]): Ditto.
	* Source/NSConnection.m
	([NSConnection -_service_typeForSelector:]): Ditto.
	* Source/NSInvocation.m
	([NSInvocation -invokeWithTarget:]): Ditto.
	* Source/NSObject.m
	([NSObject +instanceMethodSignatureForSelector:]): Ditto.
	([NDObject -methodSignatureForSelector:]): Ditto.
	([NSObject +descriptionForInstanceMethod:]): Ditto.
	([NSOnject -descriptionForMethod:]: Ditto.
	* Source/NSProxy.m 
	([NSProxy +methodSignatureForSelector:]): Ditto.
	([NSProxy -methodSignatureForSelector:]): Ditto.
	* Source/NSDistantObject.m
	([NSObject -selectorTypeForProxy:]): Ditto.
	([NSDistantObject +respondsToSelector:]): Ditto. Corrected
	implementation to check class methods instead of instance methods.
	
2003-06-23  Adam Fedor  <fedor@gnu.org>

	* Testing/diningPhilosophers.m: Locking and output fixes (from
	Chris Beaham).
	* Testing/create-abbrevs, Testing/create-regions: Remove.

2003-06-23  Adam Fedor  <fedor@gnu.org>

	* Source/NSProcessInfo.m (+load): use the KVM library where
	available when procfs doesn't work (FreeBSD, others?) (patch from
	Pete French <pete@twisted.org.uk>).

2003-06-21  David Ayers  <d.ayers@inode.at>

	* Headers/gnustep/base/objc-gnu2next.h: Remove simple mappings for
	class_get_class_method they cannot work due to different
	parameter expectations.  Added mapping from NeXT->GNU runtime. 
	The other way does not work.  Added simple mapping for internal
	flush function __objc_update_dispatch_table_for_class and
	_objc_flush_caches.

	* Headers/gnustep/base/GSObjCRuntime.h/m:
	Added typedef for GSMethod.
	(GSGetInstanceMethod): New function.
	(GSGetClassMethod): Ditto.
	(GSGetInstanceMethodNotInherited): Ditto.
	(GSGetClassMethodNotInherited): Ditto.
	(GSFlushMethodCacheForClass): Ditto.
	(flush_method_cache_for_class): Removed function which is replaced
	by GSFlushMethodCacheForClass.
	(GSObjCGetMethod): Removed function which is replaced by
	GSGetInstanceMethod and GSGetClassMethod.
	(GSObjCReplaceMethod): Removed function.

2003-06-21  Adam Fedor  <fedor@gnu.org>

	* configure.ac: Check for libkvm.
	* configure, Headers/gnustep/base/config.h.in: Regen.

2003-06-20  Adam Fedor  <fedor@gnu.org>

	* Documentation/Makefile.postamble (after-clean): Remove Base
	and BaseAdditions

2003-06-20  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSString.m: Allow more length when converting unicode
	string to integer.
	* Source/NSObject.m: ([methodSignatureForSelector:]) return nil if
	the receiver does not implement it.

2003-06-20  Adam Fedor  <fedor@gnu.org>

	* Documentation/Makefile.postamble (after-clean): 
	* Version 1.7.1

	* Source/DocMakefile (after-all): Check if Base exists before
	removing it.

2003-06-19  Adam Fedor  <fedor@gnu.org>

	* GNUmakefile (SUBPROJECTS): Revert last change.

2003-06-19  Andrew Ruder <aeruder@yahoo.com>

	* Source/Additions/Unicode.m: Increase size of table by one to
	avoid error if all possible character encodings were supported.
	Never happens ... but might conceivably do so one day.

2003-06-18  Kazunobu Kuriyama  <kazunobu.kuriyama@nifty.com>

	* configure.ac: Add --with--ffcall-include=PATH and
	--with-ffcall-library=PATH options

2003-06-18  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSXML.m: Implement -description for nodes.

2003-06-17  Adam Fedor  <fedor@gnu.org>

	* GNUmakefile (SUBPROJECTS): Add Documentation

2003-06-17  Chris Vetter <chrisv@web4inc.com>

	* Tools/AGSHtml.m: Tidy up formatting of author output.

2003-06-16 13:36  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSFormat.m (GSFormat()): Free malloc memory in all cases
	after handling %s, %S, %@ with strings longer than 8192 characters.

2003-06-15  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSAutoreleasePool.m: Documented.
	* Headers/gnustep/base/NSObject.h: Documented memory management macros
	for autogsdoc.

2003-06-14  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSMime.m: Better attempt to infer charset from
	string only when needed.
	Don't insert transer encoding header if not needed.

2003-06-11  Adam Fedor  <fedor@gnu.org>

	* Source/NSNumberFormatter.m
	(-getObjectValue:forString:errorDescription:): Simple
	implementation.

2003-06-08  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSString.m
	In [initWithContentsOfURL:] changed variable test to unichar* to
	keep the compiler quiet.
	* Source/Additions/Unicode.m
	In GSFromUnicode() removed type cast of *_conv_base as the
	gcc 3.3 compiler complained about it.

2003-06-07  David Ayers  <d.ayers@inode.at>

	* Headers/gnustep/base/GSObjCRuntime.h
	* Source/Additions/GSObjCRuntime.m : White space patch to better
	conform with GNU coding standards and improve readability.
	Wrap deprecated API in NO_DEPRICATED macro.

2003-06-06  David Ayers  <d.ayers@inode.at>

	* Source/GSArray.m: Change syntax of include <> to "" for
	local headers. Change base/ to gnustep/base/ in includes.
	Source/GSAttributedString.m, Source/GSCompatibility.m,
	Source/GSCountedSet.m, Source/GSDictionary.m,
	Source/GSFFCallInvocation.m, Source/GSFFIInvocation.m,
	Source/GSFTPURLHandle.m, Source/GSFileHandle.m,
	Source/GSFormat.m, Source/GSHTTPURLHandle.m,
	Source/GSLocale.m, Source/GSSet.m,
	Source/GSString.m, Source/GSTcpPort.m,
	Source/GSTemplateValue.m, Source/GSValue.m,
	Source/NSArchiver.m, Source/NSArray.m,
	Source/NSAssertionHandler.m, Source/NSAttributedString.m,
	Source/NSAutoreleasePool.m, Source/NSBitmapCharSet.m,
	Source/NSBundle.m, Source/NSCalendarDate.m,
	Source/NSCallBacks.h, Source/NSCallBacks.m,
	Source/NSCharacterSet.m, Source/NSClassDescription.m,
	Source/NSCoder.m, Source/NSConcreteNumber.m,
	Source/NSConnection.m, Source/NSCopyObject.m,
	Source/NSCountedSet.m, Source/NSData.m,
	Source/NSDate.m, Source/NSDateFormatter.m,
	Source/NSDebug.m, Source/NSDecimal.m,
	Source/NSDecimalNumber.m, Source/NSDictionary.m,
	Source/NSDistantObject.m, Source/NSDistributedLock.m,
	Source/NSDistributedNotificationCenter.m, Source/NSEnumerator.m,
	Source/NSException.m, Source/NSFileHandle.m,
	Source/NSFileManager.m, Source/NSFormatter.m,
	Source/NSGeometry.m, Source/NSHashTable.m,
	Source/NSHost.m, Source/NSInvocation.m,
	Source/NSKeyValueCoding.m, Source/NSLock.m,
	Source/NSLog.m, Source/NSMapTable.m,
	Source/NSMethodSignature.m, Source/NSNotification.m,
	Source/NSNotificationCenter.m, Source/NSNotificationQueue.m,
	Source/NSNull.m, Source/NSNumber.m,
	Source/NSNumberFormatter.m, Source/NSObjCRuntime.m,
	Source/NSObject.m, Source/NSPage.m,
	Source/NSPipe.m, Source/NSPort.m,
	Source/NSPortCoder.m, Source/NSPortMessage.m,
	Source/NSPortNameServer.m, Source/NSProcessInfo.m,
	Source/NSProtocolChecker.m, Source/NSProxy.m,
	Source/NSRange.m, Source/NSRunLoop.m,
	Source/NSScanner.m, Source/NSSerializer.m,
	Source/NSSet.m, Source/NSSocketPort.m,
	Source/NSString.m, Source/NSTask.m,
	Source/NSThread.m, Source/NSTimeZone.m,
	Source/NSTimer.m, Source/NSURL.m,
	Source/NSURLHandle.m, Source/NSUnarchiver.m,
	Source/NSUndoManager.m, Source/NSUser.m,
	Source/NSUserDefaults.m, Source/NSValue.m,
	Source/NSZone.m, Source/UnixFileHandle.m,
	Source/callframe.h, Source/callframe.m,
	Source/cifframe.h, Source/cifframe.m,
	Source/externs.m, Source/libgnustep-base-entry.m,
	Source/mframe.m, Source/objc-gnu2next.m,
	Source/objc-load.m, Source/preface.m,
	Source/thr-mach.m, Source/thr-pthread.m,
	Source/Additions/GCArray.m, Source/Additions/GCDictionary.m,
	Source/Additions/GCObject.m, Source/Additions/GSCategories.m,
	Source/Additions/GSCompatibility.h, Source/Additions/GSMime.m,
	Source/Additions/GSNextRuntime.m, Source/Additions/GSObjCRuntime.m,
	Source/Additions/GSXML.m, Source/Additions/Unicode.m,
	Source/Additions/behavior.m: Idem.

2003-06-03  Adam Fedor  <fedor@gnu.org>

	* Source/mframe/powerpc/darwin: New file.

2003-06-02  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/mframe.m: Allow for structure names in type specifications.

2003-05-29  Adam Fedor  <fedor@gnu.org>

	* configure.ac: Pass on original CPPFLAGS to config.mak.
	* config/objc-con-autoload.m4: Test for constructors directly.
	* config/objc-sys-dynamic.m4: Check for dl lib if we are using dladdr.

	* Source/objc-load.m (objc_get_uninstalled_dtable): Remove unused.

	* Source/Additions/GSXML.m (unparsedEntityDeclFunction): Add block
	around START so it will compile on GCC 2.

	* Testing/nsbundle.m: Errors to stdout.

2003-05-26  Adam Fedor  <fedor@gnu.org>

	* Testing/Makefile.postamble (check): Define to run all
	checkable tools (ones that exit in a finite amount of time).
	* Testing/README: New.

2003-05-23  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSXML.m: Some work towards making it possible to
	subclass GSTreeSAXHandler cleanly, so you can build a tree
	representation of a document but still handle data incrementally.

2003-05-22  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSXML.m: ([GSXPathContext-evaluateExpression:])
	Test for NULL return from libxml and return nil rather than trying
	to dereference the null pointer.
	New features to record error and warning messages added.
	* Headers/Foundation/GSXML.h: ([GSXMLParser-messages]) returns saved
	messages. ([GSXMLParser-saveMessages:]) Says whether to save messages
	or write to stderr.
	* Source/Additions/GSObjCRuntime.m: Hack to fix type clash in
	declaration of __objc_exec_class()

2003-05-19  Adam Fedor  <fedor@gnu.org>

	* Version 1.7.0.
	* Documentation/news.texi: Updated.

	* NSObject: Revert last change

2003-05-20  David Ayers <d.ayers@inode.at>

	* Headers/gnustep/base/GSObjCRuntime.h (GSObjCGetMethod(),
	GSObjCReplaceMethod()):  Removed declarations for release as these
	functions will be replaced by a more consistent approach.
	
2003-05-19  Adam Fedor  <fedor@gnu.org>

	* Source/NSObject (GSAtExit): New function.
	(+initialize): Use it with atexit.

	* Source/objc-load.m (objc_invalidate_dtable): Remove.
	(objc_load_callback): Don't call it.

2003-05-16  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSDate.m: Documented.

2003-05-14  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSMime.m: Fix occasional error unfolding
	headers.

2003-05-14 16:50  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSUser.m, Headers/gnustep/base/NSPathUtilities.h: Add
	GSApplicationSupportDirectory constant for
	NSSearchPathForDirectoriesInDomains.

2003-05-14  David Ayers  <d.ayers@inode.at>

	* Tools/Makefile.postamble: Added safe handling of empty
	MAN1_PAGES variable.
	* Tools/pl2link.m (main): Initialize variable to supress
	compiler warning.
	
2003-05-13  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Tools/gdnc.m: Tidy termination code.
	* Source/Additions/GSMime.m: ([GSMimeDocument-copyWithZone:])
	corrected implementation to do a real copy rather than just a
	retain.

2003-05-13 15:57  Alexander Malmberg <alexander@malmberg.org>

	* Tools/gdnc.m (ihandler): Declare variables.

2003-05-12  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSXML.m: New -escapedContent method to provide
	text with the five entities libxml automatically substitutes even
	when told not to.
	* Tools/AGSHtml.m: Use -escapedContent to get text suitable for
	output in html documents.

2003-05-11  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/gdomap.8.gz: Added man page adapted from internal docs by
	martin@mb-itconsulting.com
	* Tools/GNUmakefile: Declare man pages to be installed
	* Tools/Makefile.postamble: Install man pages

2003-05-08  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/xmlparse.m: new utility to parse/validate xml, for testing
	gsdoc and new style property lists etc.
	* Source/NSBundle.m: ([+allBundles]) Make sure the main bundle is
	present.  Add some documentation.

2003-05-07  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSString.m: ([-initWithCStringNocopy:length:freeWhenDone:])
	check encodings and convert to unicode if necessary. Thanks to
	Alaxander for pointing out bug.

2003-05-06  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSString.m: Fix call to GSFormat() to append to a mutable
	string whose contents should not be freed.
	Removed bogus TODO comments saying code broken when defEnc!=intEnc
	in routines which should never be called when defEnc!=intEnc anyway.
	* Source/NSData.m: Remove windows specific code for simplification
	as the standard code actually works as well or better according to
	<Roland.Schwingel@onevision.de>
	* Tools/AGSParser.m: Ignore forward declarations of protocols.

2003-05-05 15:28  Alexander Malmberg <alexander@malmberg.org>

	* Source/Unicode.m (GSFromUnicode, GSToUnicode): Make sure the
	internal work buffer isn't returned to the caller.

	* Source/NSString.m: Clarify some comments, and mark code that is
	broken when defEnc!=intEnc.

	(fillHole, makeHole): Remove STABLE_MEMCPY. Use memmove.

	(transmute): Set the zone to the default zone when transmuting.
	Check the return value from GSToUnicode.

	(getCharacters_c): Check the return value from GSToUnicode.

2003-05-02  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSTcpPort.m: ([dispatch]) catch exceptions handling the port
	message, so as to ensure that locking won't get out of sync.

Mon Apr 28 12:09:44 BST 2003  Nicola Pero  <nicola@brainstorm.co.uk>

	* NSCharacterSets/GNUmakefile (base-resources_RESOURCE_FILES_INSTALL_DIR): 
	Define using the full relative path.
	* Resources/GNUmakefile (base-resources_RESOURCE_FILES_INSTALL_DIR): Idem.
	
2003-04-27  Adam Fedor  <fedor@gnu.org>

	* Updates for filesystem change.
	* GNUmakefile (GNUSTEP_MAKEFILES): Remove
	* Documentation/GNUmakefile, Examples/GNUmakefile,
	NSTimeZones/GNUmakefile, SSL/GNUmakefile, SSL/configure.ac,
	Source/DocMakefile, Source/GNUmakefile,
	Source/Additions/GNUmakefile, Testing/GNUmakefile,
	Tools/GNUmakefile: Idem.
	* configure.ac: Replace $GNUSTEP_SYSTEM_ROOT/Makefiles with
	$GNUSTEP_MAKEFILES.  Replace Libraries with Library/Libraries.
	Replace Headers with Library/Headers.
	* Source/mframe/configure.ac: Idem.
	* NSCharacterSets/GNUmakefile: Use resource-set.make.
	* Resources/GNUmakefile: Idem.
	* Resources/GNUmakefile.postamble: Remove before/after install cmds.

	* Source/NSBundle (+pathForLibraryResource:ofType:inDirectory:): 
	New method.
	(+pathForGNUstepResource:...): Depreciate.
	* Source/Additions/GSXML.m: Use it to find DTDs.

	* Source/GSLocale.m (GSLanguageFromLocale): Use +bundleForLibrary
	to locate resources.
	* Source/NSCharacterSet.m (+_bitmapForSet:number:): Idem.
	* Source/NSUserDefaults.m (+standardUserDefaults): Idem.
	* Source/Additions/Unicode.m (GSEncodingFromLocale): Idem.
	* Source/NSTimeZone.m (_time_zone_path): New function.
	(+systemTimeZone, +getAbbreviationFile, +getRegionsFile,
	+getTimeZoneFile): Use it.

	* Source/NSUser.m (NSSearchPathForDirectoriesInDomains): Change
	libsDir to "Library/Libraries", docDir to "Library/Documentation".

	* Source/Additions/GSCompatibility.[hm]: Change 
	+pathForGNUstepResource:...  to +pathForLibraryResource:...

2003-04-27  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUserDefaults.m: ([synchronize]) fix locking to permit
	recursive call to this method, ensuring the distributed lock is
	only obtained once.
	* Headers/gnustep/base/GSCategories.h: removed varargs helper macros
	* Headers/gnustep/base/GSObjCRuntime.h: and put them here.

2003-04-17  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/gnustep/base/GSCategories.h:
	* Headers/gnustep/base/NSCalendarDate.h:
	* Headers/gnustep/base/NSData.h:
	* Headers/gnustep/base/NSObject.h:
	* Headers/gnustep/base/NSString.h:
	* Headers/gnustep/base/NSValue.h:
	* Headers/gnustep/base/Foundation.h:
	Tidied use of GSCategories.
	* Source/NSFileManager.m: ([linkPath:toPath:handler:]) implemented.

2003-04-16  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/gnustep/base/NSUserDefaults.h: remove timer ivar, now unused.
	* Source/NSRunLoop.m: Support a housekeeping timer which is ignored
	for purposes of deciding whether the loop shoiuld terminate.
	* Source/NSThread.m: Set up housekeeping timer to trigger housekeeping
	notifications in the default mode of the runloop of the main thread.
	* Source/NSUserDefaults.m: Use housekeeping notifications to trigger
	synchronise rather than using timers ... avoid circular dependencies.
	Thanks to Derek Zhou for bug report.

2003-04-15  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSData.m: Experimantal disable ReadFile and WriteFile on MINGW

2003-04-14  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSObjCRuntime.m: NSClassFromString(), NSSelectorFromString()
	avoid doing an unnecessary autorelease.

2003-04-12  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/callframe.m:
	* Source/cifframe.m:
	Fix error in returning pointer to struct values.

2003-04-11  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSConnection.m: ([_service_forwardForProxy:]) don't free the
	decoded selector name ... the NSPortCoder now does it.
	([typeForSelector:]) return autoreleased copy of the type string.

2003-04-10  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/callframe.m:
	* Source/cifframe.m:
	Fix error in returning data via pointer arguments ... was writing to
	wrong memory location.
	* Source/GSFFCallInvocation.m: minor tidy up.
	* Source/NSArchiver.m: Structure encoding/decoding fixes.
	* Source/NSData.m: Structure encoding/decoding fixes.
	* Source/NSPortCoder.m: Structure encoding/decoding fixes.
	Manage memory used by decoded pointers (including c-strings).
	* Source/NSUnarchiver.m: Structure encoding/decoding fixes.
	* Source/NSConnectiom.m: Don't try to autorelease decoded pointers.
	* Testing/server.h: Make large structure have tricky layout.
	* Testing/nsconnection_client.m: Add harder structure test.
	* Testing/nsconnection_server.m: Add harder structure test.

2003-04-09  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSTcpPort.m:
	* Source/NSData.m:
	* Source/NSSerializer.m:
	* Source/NSURL.m:
	Replace __alignof__() with calls to objc_alignof_type() so that if
	__alignof__() is broken we can hope that the objc runtime library
	has a workaround.

2003-04-08  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/gnustep/base/Foundation.h: Include GNUstep extensions
	from GSCategories.h

2003-04-08 15:37  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSCalendarDate.m (-initWithString:calendarFormat:locale:):
	Fix assignment of 'found' in %z handling.

2003-04-07 13:21  Alexander Malmberg <alexander@malmberg.org>

	* configure.ac:	Link directly to the foreign function interfaces
	section in the build guide in the error message for missing ffi
	library.

	* configure: Regenerate.

2003-04-07  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/gnustep/base/GSCategories.h (GS_USEIDLIST and
	GS_USEIDPAIRLIST): Complete implementation and testing.
	* Source/NSDictionary.m: Use macro.

2003-04-06 23:30  Alexander Malmberg <alexander@malmberg.org>

	* Headers/gnustep/base/GSCategories.h (GS_USEIDLIST): Make the
	implementation match the actual use in NSArray and NSSet. Clarify
	documentation.

2003-04-06  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSThread.m: (GSPerformHolder) execute perform operations
	in the same order in which they were submitted.
	* Headers/GNUstep/base/GSCategories.h: Added two new macros to
	agressively optimise the use of varargs when initialising arrays
	etc by avoiding multiple allocation/reallocation of memory to hold
	arrays of objects taken from the varargs list.
	* Source/NSArray.m: Use the new macros.

2003-04-04  Stephane Corthesy <stephane@sente.ch>

	* macosx/config.h, macosx/preface.h: Update.
	* macosx/gnustep.pbproj/project/pbxproj: Use relative paths.

2003-04-04  Adam Fedor  <fedor@gnu.org>

	* Source/Additions/GSCompatibility.m ([NSString(GSCompatibility)
	-substringFromRange:]): Add.

2003-04-04  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSInvocation: Added NS_INVOCATION asnd NS_MESSAGE
	* Source/NSInvocation.m: Support the two new macros. Documented.
	* Testing/nsinvocation.m: Trivial tests added.
        * Documentation/OpenStepCompliance.gsdoc: Updated.
	* Source/NSConnection.m: ([-forwardInvocation:forProxy:]) set
	invocation target explicitly, in case this was called as a result
	of a manual setup of the invocation rather than real forwarding.

2003-04-03  Adam Fedor  <fedor@gnu.org>

	* Documentation/OpenStepCompliance.gsdoc: New file.
	* Documentation/Base.gsdoc: Reference it.
	* Source/DocMakefile: Update.

2003-04-02  Stephane Corthesy <stephane@sente.ch>

	* Source/Additions/GSCompatibility.m: Fix up incorrectly applied 
	patch.
	* Source/Additions/Unicode.m (GSEncodingName): Don't define if
	NeXT_Foundation_Library.

2003-04-02  Adam Fedor  <fedor@gnu.org>

	* Headers/gnustep/base/Foundation.h: Revert previous change

2003-04-02  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSXML.m: ([-content]) fix to produce string
	content of elements rather than just text nodes.
	* Source/GSMime.m: ([-rawMimeData]) ensure that the transfer encoding
	of a multipart document is 8bit if any of its constituent parts are
	8bit or binary

22003-04-01  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSCalendarDate.m: ([initWithString:calendarFormat:locale:])
	add support for %F millisecond initialisation.
	make trivial simplification of timezone handling.
	on failure to parse zone using %z, use local time zone.

2003-03-31  Stephane Corthesy <stephane@sente.ch>

	* Source/Additions/GCArray.m: Replace retain/release by 
	RETAIN/RELEASE macros.
	* Source/Additions/GCDictionary.m: Idem.

	* Source/Additions/GSCompatibility.h: Add NSBundle category.
	* Source/Additions/GSCompatibility.m (GSEncodingName): New.
	Add -[NSBundle pathForGNUstepResource:ofType:inDirectory:].

	* Source/Additions/GSObjCRuntime.m: Include GNUstep.h.
	(GSObjCMethodNames): Cast method_name to const char *.

2003-03-31  Adam Fedor  <fedor@gnu.org>

	* Headers/gnustep/base/Foundation.h: Add GSCategories.h

2003-03-30  Adam Fedor  <fedor@gnu.org>

	* Headers/gnustep/base/NSString.h: (stringByTrimmingLeadSpaces,
	stringByTrimmingTailSpaces, stringByTrimmingSpaces, 
	stringByReplacingString:withString:, replaceString:withString:,
	trimLeadSpaces, trimTailSpaces, trimSpaces): Move to GSCategories.h
	* Headers/gnustep/base/NSValue.h (valueFromString): Idem.
	* Source/NSNumber.m (valueFromString:): Move to GSCategories.m
	* Source/NSString.m: Idem as above.
	* Source/Additions/GSCategories.m: Methods moved here.
	* Source/Additions/GSCompatibility.h: Rearrange, add
	NSDistantObject, NSFileHandle category, GSCurrentThreadDictionary().
	* Source/Additions/GSCompatibility.m: Add GSCurrentThreadDictionary
	NSDistantObject, and NSFileHandle methods.

2003-03-28 20:48  Alexander Malmberg <alexander@malmberg.org>

	* configure.ac: Fail the configure if neither ffcall nor ffi is
	available unless --disable-do is passed to configure. Add a message
	about why a user most likely does not want to build with ffcall and
	ffi, and with a link to the build guide.

	* configure: Regenerate.

2003-03-27  Adam Fedor  <fedor@gnu.org>

	* Source/NSBundle.m ([NSBundle -bundleIdentifier]): New.

2003-03-27  Stephane Corthesy <stephane@sente.ch>

	* Tools/autogsdoc.m, AGSHtml.m, AGSIndex.m, AGSOutput.m: Add
	MacOSX compatibility headers.
	* Tools/AGSParser.m: Idem.
	(-log:arguments:): Replace strinWithFormat:arguments: with
	initWithFormat:arguments:

2003-03-26  David Ayers  <d.ayers@inode.at>

	* Source/NSKeyValueCoding.m: Added documentation. 
	* Source/NSKeyValueCoding.m ([NSObject -takeValue:forKey:]),
	([NSObject -valueForKey:]): Corrected search order of instance
	variables.

2003-03-25  Stephane Corthesy <stephane@sente.ch>

	* macosx: New directory holding MacOSX project for building 
	Additions framework.

2003-03-25  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSURL.m: When loading a resource and attempting to notify
	a client, check that the client responds to the selectors before
	sending messages to it.
	Make ([-loadResourceDataNotifyingClient:usingCache:]) work in
	background (non-blocking).
	
2003-03-25  David Ayers  <d.ayers@inode.at>

	* Headers/gnustep/base/GSObjCRuntime.h
	* Source/Additions/GSObjCRuntime.m (GSObjCGetMethod),
	(GSObjCReplaceMethod): Added new functions. 
	* Source/Additions/GSObjCRuntime.m (search_for_method_in_class):
	Renamed static function for NeXT runtime to better reflect
	reality.
	(GSObjCAddMethods): Updated usage.
	(search_for_method_in_class): New static function for GNU runtime.
	(flush_method_cache_for_class): New static function.
	* Headers/gnustep/base/GSCategories.h: Included necessary headers.

2003-03-23  Richard Frith-Macdonald <rfm@gnu.org>

	* Completed merge of changes from 1.6.0 branch.

2003-03-17  Adam Fedor  <fedor@gnu.org>

	* Version 1.6.0

2003-03-17  Adam Fedor  <fedor@gnu.org>

	* Testing/LoadMe.m (afterLoad): Use description, not name.
	* Testing/nsfilemanager.m: Print some output. Clean up.
	* Testing/scanner.m, nstimezone.m, release.m: Idem.

	* config/config.vsprintf, config/config.vasprintf: Rewrite to
	properly call a variable argument function.

2003-03-14  Adam Fedor  <fedor@Eldorado.local.>

	* Testing/nsarray.m (compare): Un-nest function.

	* Source/NSProcessInfo.m (-operatingSystem): Add darwin. 

2003-03-13  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSFileManager.m: ([-isDeletableFileAtPath:]) Fix for the
	case where the path is a file in the current directory.

2003-03-11  Adam Fedor  <fedor@gnu.org>

	* configure.ac: Fix some typos (Reported by
	Alexander Malmberg <alexander@malmberg.org>).

2003-03-07  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/gnustep/base/NSSet.h: Added a few non-openstep declarations
	* Source/GSCompatibility.m: OAppend() sort dictionary keys even if
	locale is nil.

2003-03-06  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSData.m: Fix reference to zone of deallocated object.
	Bug reported by Roland Schwingel
	* Source/NSFileManager.m: Fix typo (using logical or rather than
	bitwise or) in call to access()
	Bug reported by Roland Schwingel

2003-02-17  Wim Oudshoorn  <woudshoo@agilisys.com>

	* GNUmakefile (GNUSTEP_TARGET_INSTALL_PREFIX)
	(GNUSTEP_TARGET_LOCAL_ROOT, GNUSTEP_TARGET_NETWORK_ROOT): On
	mingw32 replace / with \\057 to avoid the msys shell translating /
	with \.

2003-03-04  Richard Frith-Macdonald <rfm@gnu.org>

	* config/config.vasprintf.c:
	* config/config.vsprintf.c: Correct the number of arguments passed
	so that modern compilers don't fail on these files.  A compiler
	failure is seen by configure as the same as a runtime failure, and
	configure would infer incorrect runtime behavior!

2003-03-01  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSSerializer.m: Fix crash when deserializing a corrupt or
	truncated archive ... raise exception rather than segfaulting.
	Added code to recognize newer versions of the serialiser format and
	give up if they are encountered and cannot be handled.
	* Source/GSTcpPort.m: Added code to recognise newer versions of the
	port format and give up if they are encountered and cannot be handled.
	This allows for the addition of decent versioning in later formats.

2003-02-28  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/AGSParser.m: Fix to understand __attribute__() in declaration.

2003-02-27  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/AGSIndex.m: Convert nil content to empty strings before use.
	* Tools/AGSHtml.m: ditto ... prevent some crashes.

2003-02-24  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSProcessInfo.m (_gnu_process_args): Tidied patch and add
	code to print error and abort if argv is null under unixy systems.

2003-02-24  Tom Koelman <tkoelman@xs4all.nl>

	* Source/NSProcessInfo.m (_gnu_process_args): If argv is 0 (e.g.
	on MingW) set executable name using module name info.

2003-02-23  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUser.m: Don't prepend HOMEDRIVE to HOMEPATH if HOMEPATH
	already contains a drive letter.

2003-02-22  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSObjCRuntime.m: GSObjCSetValue() correct to call
	([unableToSetNilForKey:]) when it should.
	* Source/NSDecimalNumber.m: Override initialisers from NSNumber to
	create NSDecimalNumber objects ... bug report by David Ayers.

2003-02-21  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSDistributedNotificationCenter.m: ([_connect]) make the
	connection to the server usable from any thread.

2003-02-19  Adam Fedor  <fedor@gnu.org>

	* Source/NSKeyValueCoding.m ([NSObject -handleQueryWithUnboundKey:]): 
	Raise NSUnknownKeyException.
	([NSObject -handleTakeValue:forUnboundKey:]): Idem.

2003-02-18  Adam Fedor  <fedor@gnu.org>

	* Source/GSFFIInvocation.m (GSFFIInvocationCallback): Cast
	invocation to access ivars correctly. Check validReturn.

2003-02-18  Tom Koelman <tkoelman@xs4all.nl>

	* Source/NSProcessInfo.m (_gnu_process_args): If argv is 0 (e.g.
	on MingW) set executable name to empty string.

2003-02-17  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSString.m: (fillHole) fix memory overrun (read only) and
	argument order errors (in code not normally compiled) spotted by
	Manuel Guesdon.


2003-03-23  Richard Frith-Macdonald <rfm@gnu.org>

	* Start merged of changes from 1.6.0 branch.


2003-03-20  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSMime.m: (_unfoldHeader) Check that input pointer doesn't
	run past end of data.

2003-03-05 15:50  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSBundle.m (+initialize) [PROCFS_EXE_LINK]: Make sure that
	the link is a path before using it.

2003-03-03  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/gnustep/base/objc-gnu2next.h: Added some trivial reverse
	mappings to use gnu runtime from old next code.

2003-03-02  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/gnustep/base/GSObjCRuntime.h:
	* Source/GSFFIInvocation.m:
	* Source/GSString.m:
	* Source/NSInvocation.m:
	* Source/NSObject.m:
	* Source/NSPortCoder.m:
	* Source/NSUnarchiver.m:
	* Source/Additions/GSObjCRuntime.m:
	* Source/Additions/Unicode.m:
	Rename _fastMallocBuffer() to GSAutoreleasedBuffer() for clarity
	and consistency.  Moved implementation from NSObject.m to
	GSObjCRuntime.m so this is available for use withing the Additions
	library when built standalone.
	Add a couple of trivial functions to list ivars and methods.

2003-02-19  Mirko Viviani  <mirko.viviani@rccr.cremona.it>

	* Headers/gnustep/base/NSArray.h: fixed declarations.

2003-02-19  David Ayers  <d.ayers@inode.at>

	* Source/NSArray.m (compare()),
	([-sortedArrayUsingFunction:context:]),
	([-sortedArrayUsingFunction:context:hint:]),
	([-sortUsingFunction:context:]):  Changed declarations
	and implementation to account for 64 bit architectures.
	* Headers/gnustep/base/NSArray.h: Ditto.
	* Source/NSKeyValueCoding.m ([-takeStoredValuesFromDictionary:]):
	Implemented.
	* Headers/gnustep/base/NSKeyValueCoding.h: Ditto.
	
2003-02-18  Richard Frith-Macdonald <rfm@gnu.org>

	* NSObject.m: ([+instancesRespondToSelector:]),([-respondsToSelector])
	Return NO when given a null selector unless in MacOS-X compatibility
	mode.  rewritten from patch by Willem Rein Oudshoorn.

2003-02-16  Adam Fedor  <fedor@gnu.org>

	* Version 1.5.2
	* Documentation: Update.

	* Source/GSFFIInvocation.m (GSFFIInvocationCallback): Autorelease
	and invalidate the return value object before returning.

2003-02-16  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSDictionary.m: ([-isEqualToDictionary:]) implement optimised
	version which does not need to create a key enumerator.
	* Source/GSArray.m: ditto
	* Source/GSSet.m: similar minor optimisations.

2003-02-15 15:53  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSRunLoop.m (-performSelector:target:argument:order:modes:):
	Order the performers correctly (lower order values first). Correct
	the documentation.

2003-02-13  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSTimeZone.m: Fix memory leak when making absolute
	timezone for offset 0.

2003-02-11  Tom Koelman <tkoelman@xs4all.nl>

	* Source/NSTask.m: Make arguments into windows quoted strings for
	mingw.  Adjustments to conform to GNUstep style and use static
	functions to avoid adding methods by RFM.

2003-02-11  Adam Fedor  <fedor@gnu.org>

	* configure (LDFLAGS): Remove extra spaces that cause problems
	on Darwin/gcc

i2003-02-11  Willem Rein Oudshoorn  <woudshoo@xs4all.nl>

	* Headers/Foundation/NSFileManager.h: Added a little bit to the
	* documentation of the NSFileManagerHandler protocol.
	(some documentation markup fixes by RFM also)
	* Source/NSFileManager.m ([NSFileManager -copyPath:toPath:handler:]): 
	use new private methods to cope with handlers that do not implement
	the informal protocol.  Pass more information to the handler in case
	of an error.
	([NSFileManager -removeFileAtPath:handler:]):  see above
	([NSFileManager -movePath:toPath:handler:]): see above
	([NSFileManager -_copyPath:toPath:handler:]): see above
	([NSFileManager -_copyFile:toFile:handler:]): see above, also fixed
	leaking of file descriptors in case of error without a handler.
	([NSFileManager -_sendToHandler:handlerwillProcessPath:path]):
	new method
	([NSFileManager -_proceedAccordingToHandler:handlerforError:
	errorinPath:path]): new method
	([NSFileManager -_proceedAccordingToHandler:handlerforError:
	errorinPath:pathfromPath:fromPathtoPath:toPath]): new method

2003-02-11  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSFileManager.m: ([+attributesAt:traverseLink:]) check for
	null pointer and return nil.  Crash reported by Tom Koelman.

2003-02-10 13:56  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSRunLoop.m [HAVE_POLL] (-pollUntil:within:): Set fdEnd
	to pollfds_count instead of setting it separately (which was being
	done incorrectly).

2003-02-07 19:21  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSAttributedString (-setAttributes:range:): Fix memory
	leak.

2003-02-06  Richard Frith-Macdonald <rfm@gnu.org>

	* Sourcewin32-def.top: Remove recently added external functions.
	* Source/libgnustep-base.def.in: Regenerated to just contain
	public classes.  The manual hacks are no longer needed as the
	make system now handles inclusion of symbols from subprojects
	in dlls.

2003-02-05  Richard Frith-Macdonald <rfm@gnu.org>

	* Sourcewin32-def.top: Manually added external functions.
	* Source/libgnustep-base.def.in: Regenerated to combine external
	functions and all public classes.
	* Source/NSConnection.m: ([-init]) creates a connection usable as
	a server.

2003-02-04  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSBundle.m: Implement new MacOS-X isLoaded method.
	* Headers/gnustep/base/NSBundle.h: ditto

2003-02-04  Willem Rein Oudshoorn  <woudshoo@xs4all.nl>

	* Headers/gnustep/base/GSInvocation.h (CLEAR_RETURN_VALUE_IF_OBJECT):
	* New macro, if invocation returns object release it.
	(RETAIN_RETURN_VALUE): New macro, if invocation returns object
	release it.
	* Source/NSInvocation.m ([NSInvocation -dealloc]): Implement RELEASE
	* return object
	([NSInvocation -setReturnValue:]) Implement RETAIN/RELEASE on return
	object ([NSInvocation -invokeWithTarget:]): Implement RETAIN/RELEASE
	on return object,
	fixed  _validReturn flag setting
	* Source/GSFFIInvocation.m ([GSFFIInvocation -invokeWithTarget:]): 
	Fix _validReturn flag setting, Implement RETAIN/RELEASE on return
	object.
	* Source/GSFFCallInvocation.m ([GSFFCallInvocation
	* -invokeWithTarget:]): 
	Fix _validReturn flag setting.  Implement RETAIN/RELEASE on return
	object.

2003-02-04  Adam Fedor  <fedor@Eldorado.local.>

	* Headers/gnustep/base/.cvsignore: Don't include config.h.in
	* Documentation/.cvsignore: Don't include *texi
	* Source/Additions/GSXML.h: Fix up GSXLM.h include on MacOSX

2003-02-02  Stephane Corthesy <stephane@sente.ch>
	    Adam Fedor  <fedor@gnu.org>

	* Headers/gnustep/base/GSObjCRuntime.h (GS_STATIC_INLINE): Rename
	from FOUNDATION_STATIC_INLINE
	* Headers/gnustep/base/GCObject.h, GSXML.h: include 
	Foundation/Foundation.h	on MacOSX.
	* Source/Additions/GCArray.m, GCDictionary.m, GCObject.m: Idem.
	* Source/Additions/GSCompatibility.[hm]: Change category names to
	GSCompatibility.
	* Source/Additions/GSNextRuntime.m (ROUND): Expand inline due to
	gcc 3.1 compile problems.
	* Source/Additions/Unicode.m: Don't define GetEncodingName on MacOSX
	Added #ifdef HAVE_ICONV around definition of iconv_stringforencoding().

2003-02-01  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/Unicode.m: Fix error in check for legality of
	three-byte utf-8 sequences.

2003-01-31  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSRunLoop.m: Fix memory leak with timed performs.

2003-01-31  Stephane Corthesy <stephane@sente.ch>
	    Adam Fedor  <fedor@gnu.org>

	* Headers/gnustep/base/GSCategories.h: Moved
	NSString(GSCategories), NSMutableString(GSCategories), and copied
	NSObject(GSCategories) to here
	* Headers/gnustep/base/NSString.h, Headers/gnustep/base/NSObject:
	From here.
	* Headers/gnustep/base/GSMime.h: Include Foundation on MacOSX.

	* Source/Additions/GSCategories.m: Fix includes.
	* Source/Additions/GSCompatibility.h: Defined DebugLog, WarnLog 
	macros. Add Additional NSObject, NSInvocation, NSString and
	NSProcessInfo methods. Add NSStandardLibraryPaths.
	* Source/Additions/GSCompatibility.m: Idem.

2003-01-30  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/libgnustep-base.def.in: Regenerated

2003-01-27  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/Unicode.m: Fixed bug in utf-8 output for three
	byte sequences.
	* Tools/AGSOutput.m: Fix loss of trailing info after a closing
	square bracket round a class name.
	* Source/Additions/GCArray.m: make mutable copy shallow for
	consistency with other arrays.

2003-01-26  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSString.m: Added new MacOS-X method ...
	([MSMutableString-replaceOccurrencesOfString:withString:options:range:])
	* Source/Headers/gnustep/base/NSString.h: ditto
	* Source/Additions/GSCategories.m: Added
	([NSData-initWithHexadecimalRepresentation:])
	* Source/Headers/gnustep/base/GSCategories.h: ditto

2003-01-26  Adam Fedor  <fedor@gnu.org>

	* Compiling gdl2 on MacOSX.
	* Headers/gnustep/base/NSObject.h (-notImplemented:,
	-subclassResponsibility:, -shouldNotImplement:, -compare:): Move
	to GSCategories category.
	* Headers/gnustep/base/NSString.h (-stringByDeletingPrefix:,
	-stringByDeletingSuffix:, -deleteSuffix:, -deletePrefix:): Idem.
	* Source/NSObject: Move methods to Additions/GSCategories.m
	* Source/NSString: Idem.

	* Source/Additions/GSCompatibility.h (GetEncodingName): Add.
	* Source/Additions/GSCompatibility.m (GetEncodingName): Cocoa
	implementation.

2003-01-24  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSCategories.m: Changed name of md5 digest method
	and added -hexadecimalRepresentation.
	* Source/Additions/GSMime.m: Update for md5 change.
	* Documentation/GNUmakefile: Fixed error in installation location.
	* Documentation/Makefile.postamble: Fixed to install BaseAdditions
	documentation.
	* Source/md5.c: Tidy up ... removed ... no longer used
	* Source/md5.h: ditto
	* Source/numbers.c: ditto
	* Headers/gnustep/base/numbers.h: ditto

2003-01-23  Richard Frith-Macdonald <rfm@gnu.org>

	* Documentation/Base.gsdoc: Refer to additions.
	* Documentation/BaseAdditions.gsdoc: New intorduction for additions
	* Headers/gnustep/base/GSCategories.h: Added MD5Digest NSData method
	* Source/DocMakefile: Build additions documentation separately
	* Source/Additions/GSCategories.m: Added MD5Digest NSData method
	* Source/Additions/GSMime.m: Use MD5Digest NSData method.

2003-01-22  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSMime.m: ifdefed out my last change ...not sure
	it was good.
	* Source/GSFileHandle.m: Removed bogus semicolon which was causing
	code to be executed repeatedly rather than just once ... trivial
	optimisation.

2003-01-21  Adam Fedor  <fedor@gnu.org>

	* Source/Additions/(GCArray.m, GCDictionary.m, GCObject.m, 
	GSCategories.m): Include config.h
	* Source/Additions/GSMime.m: Add extra arg to some NSDebugMLog to
	get it to compile right on OSX.

2003-01-20  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/gnustep/unicode/latin9.h: Latin9 string encoding tables
	* Source/Additions/Unicode.m: Added built-in support for the Latin9
	character encoding ... contains the Euro symbol ... nice for
	european users.
	* Source/NSArray.m: Make abstract copying implementation like that
	of latest MacOS-X rather than OPENSTEP ... no relationship between
	mutability and depth.
	* Source/NSDictionary.m: ditto
	* Source/NSSet.m: ditto
	* Source/GSArray.m: Implement optimised copies ... copying an immutable
	object just retains it, and copying a mutable object is shallow.
	* Source/GSDictionary.m: ditto
	* Source/GSSet.m: ditto

2003-01-16  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSURL.m: Support MacOS-X style initialisation using a path
	with a leading slash.

2003-01-09  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSCategories.m: Additional ([weekOfYear]) method
	for NSCalendarDate.
	* Headers/gnustep/base/GSCategories.h: ditto

2003-01-07  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSLock.m:
	* Source/NSPage.m:
	Mingw fixes ... problems reported by Fred.

2003-01-04  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSConcreteNumber.m: ([compare:]) explicitly cast to promote
	values to a type where comparisons can be done without loss of
	precision.

2003-01-03  Richard Frith-Macdonald <rfm@gnu.org>

	* base.make.in:
	* configure:
	* configure.ac:
	* Headers/gnustep/base/GSIArray.h:
	* Headers/gnustep/base/GSIMap.h:
	* Headers/gnustep/base/NSGeometry.h:
	* Headers/gnustep/base/NSInvocation.h:
	* Source/GSArray.m:
	* Source/GSAttributedString.m:
	* Source/GSCompatibility.m:
	* Source/GSCountedSet.m:
	* Source/GSDictionary.m:
	* Source/GSFFCallInvocation.m:
	* Source/GSFTPURLHandle.m:
	* Source/GSFileHandle.m:
	* Source/GSFormat.m:
	* Source/GSString.m:
	* Source/GSTcpPort.m:
	* Source/GSTemplateValue.m:
	* Source/NSArray.m:
	* Source/NSAutoreleasePool.m:
	* Source/NSBundle.m:
	* Source/NSCalendarDate.m:
	* Source/NSConcreteNumber.m:
	* Source/NSCountedSet.m:
	* Source/NSData.m:
	* Source/NSDebug.m:
	* Source/NSInvocation.m:
	* Source/NSLog.m:
	* Source/NSMethodSignature.m:
	* Source/NSNotificationCenter.m:
	* Source/NSObject.m:
	* Source/NSPortCoder.m:
	* Source/NSRunLoop.m:
	* Source/NSScanner.m:
	* Source/NSSerializer.m:
	* Source/NSString.m:
	* Source/NSTimeZone.m:
	* Source/NSUnarchiver.m:
	* Source/mframe.m:
	* Source/Additions/GSMime.m:
	* Source/Additions/GSXML.m:
	* Tools/AGSOutput.m:
	* Tools/AGSParser.m:
	* Tools/defaults.m:
	* Tools/gdomap.c:
	* Tools/pl2link.m:
	* Tools/sfparse.m:
	* Tools/make_strings/StringsFile.m:
	Tweaks for warning free compilation with gcc-3.4 ... many comparisons
	os signed and un signed values avoided etc.

2003-01-03  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/AGSHtml.m: Don't try to make a type reference to the
	superclass of NSObject.

2002-12-31  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSPage.m: Document all functions.

2002-12-31  Kelvin  <kelvin@xbar.org>

	* Source/NSPage.m (NSRealMemoryAvailable): Add support for MINGW
	and BeOS.

2002-12-31  Richard Frith-Macdonald <rfm@gnu.org>

	*  Source/GSEQ.h: Optimisations for normalising sequences, especially
	where they contain latin1 characters.
	* Source/Additions/GCDictionary.m: Update map tables for macosx
	* Source/NSMapTable.m: Update for macosx compatibility, add some
	documentation and move stuff from externs.m
	* Source/NSHashTable.m: Update for macosx compatibility, add some
	documentation and move stuff from externs.m
	* Source/externs.m: Remove map and hash table stuff
	* Source/NSException.m: Fix documentation cross ref error.
	* Source/NSAssertion.m: Improve documentation.
	* Headers/gnustep/base/NSException.h: Include assertion documentation.
	* Headers/gnustep/base/NSMapTable.h: Update for macosx compatibility.
	* Headers/gnustep/base/NSHashTable.h: Ditto
	* Tools/AGSHtml.m: Fix typo ... excess semicolon in constant output.
	* Tools/AGSParser.m: Fix error failing to find comment for constants.
	* Source/NSObjCRuntime.m: Document functions.

2002-12-30  Adam Fedor  <fedor@gnu.org>

	* SSL/GNUmakefile: Don't compile if base=no

	* Tools/AGSIndex.h: Include gnustep/base/GSXML.h.
	* Tools/AGSHtml.m: Include GNUstep.h
	* Tools/AGSInde.m, Tools/AGSOutput.m, Tools/AGSParser.m,
	Tools/HTMLLinker.m: Idem.
	* Tools/GNUmakegile: Only compile autogsdoc when add=yes
	* Tools/Makefile.preamble: Include -lgnustep-baseadd when add=yes

Mon Dec 30 18:19:55 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* configure.ac: Recognize apple OBJC_RUNTIME_LIB.
	* configure: Regenerated.
	* Makefile.postamble: Updated check for gnu FOUNDATION_LIB.
	* Source/Makefile.preamble (libgnustep-baseadd_LIBRARIES_DEPEND_UPON): 
	Do not add -framework Foundation on Apple, it's added automatically
	by gnustep-make.
	* Source/GNUmakefile: Updated check for OBJC_RUNTIME_LIB.
	* Source/Additions/GNUmakefile: Updated checks for
	OBJC_RUNTIME_LIB and FOUNDATION_LIB.
	
2002-12-28  Kelvin  <kelvin@xbar.org>

	* Source/NSPage.m: Add BeOS support.
	* Source/NSProcessInfo.m ([NSProcessInfo -operatingSystem]): Idem
	(Also added solaris (fedor@gnu.org)).

2002-12-24  Richard Frith-Macdonald <rfm@gnu.org>

	*  Source/Additions/Unicode.m: Tidied and optimised binary searches.

2002-12-19  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/AGSParser.m: Fix bug handling repeated opeing braces.

2002-12-17  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/AGSIndex.m: Fix error indexing vararg methods.
	* Source/Additions/Unicode.m: Added home-brewed support for UTF8 to
	avoid use of iconv where not necessary.q  Hope the code is OK :-)

2002-12-12  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/gnustep/base/NSDistributedNotificationCenter.h: add type
	for LAN-wide notifications.  Add ivar to support this.
	* Source/NSDistributedNotificationCenter.m: Implement support for
	a LAN-wide notification center.  Fully document class.
	* Tools/gdnc.m: Add new GSNetwork flag to operate as LAN-wide
	notification center.
	* Tools/AGSHtml.m: Don't output contents section if there is
	nothing to show (ie must have at least two sections to index).
	* Source/NSConnection.m: Add locks to protect proxy cache in timeout.

2002-12-10  Adam Fedor  <fedor@gnu.org>

	* configure.ac: Enable libffi on darwin by default.

2002-12-10  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSArray.m: ([removeObjectsFromIndices:numIndices:])
	bugfix for sorting by Kelvin Sherlock.
	* Source/NSConnection.m: Experimental code to keep local objects
	retained long enough to deal with most cases where the remote
	process may want them again.
	* Source/NSHost.m: Don't cache local host name ... it may change
	due to use of DHCP etc.

2002-12-08  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSThread.m: Fix race condition firing perform holder.
	Fix supplied by Philip Derrin.

2002-12-05  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUserDefaults.m: Fix uninitialised local variable 'locale'
	which was causing a crash ... not 100% sure my fix is making the code
	work as intended.  Could Adam please check it?

2002-12-04  Adam Fedor  <fedor@gnu.org>

	* Headers/gnustep/base/GSLocale.h: Add category arg to
	SetLocale functions.
	* Source/GSLocale.m (GSSetLocaleC, GSSetLocale): Update for change.
	* Source/NSObject.m (+initialize): Idem.
	* Source/NSUserDefaults.m ([NSUserDefaults +standardUserDefaults]):
	Idem.

2002-12-04  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSSerializer.m: bugfix deserialisation ... was trying to	
	read size of date/number when these values were not being serialized.

2002-12-03  Mirko Viviani  <mirko.viviani@rccr.cremona.it>

	* Source/NSBundle.m ([NSBundle +initialize]): check for linked
	framework in two passes, first collect all the framework classes, then
	add it. The previous routine failed to add all the frameworks.

2002-12-02  Adam Fedor  <fedor@gnu.org>

	* Port baseadd to MacOSX.
	* Makefile.postamble (header-links): Don't link gnustep/gui to 
	Foundation for FOUNDATION_LIB=nx
	* Headers/gnustep/base/NSObjCRuntime.h (FOUNDATION_EXPORT): Define
	only if not defined already.
	* Headers/gnustep/base/objc-gnu2next.h: Define _CLS_META, _CLS_CLASS
	* Source/Makefile.preamble (libgnustep-baseadd_LIBRARIES_DEPEND_UPON):
	Depend on framework Foudation if FOUNDATION_LIB=nx
	* Source/objc-gnu2next.m: Move most functions...
	* Source/Additions/GSNextRuntime.m: ...to here.
	* Source/Additions/GSCompatibility.[hm]: New files.
	* Source/Additions/GCDictionary.m: Include it.
	* Source/Additions/GSMime.m: Idem.
	* Source/Additions/GSXML.m: Idem.
	* Source/Additions/GCObject.m: Idem. Null out mutex code
	on NeXT_RUNTIME (Need a better fix).
	* Source/Additions/GNUmakefile: Don't compile Unicode.m
	on FOUNDATION_LIB=nx (not ported yet).
	* Source/Additions/GSObjCRuntime.m (GSObjCAddClasses): Version
	for NeXT_RUNTIME.
	(GSObjCAddClassBehavior): Fixes for NeXT_RUNTIME.
	* Source/Additions/behavior.m (behavior_class_add_class): Idem.

2002-12-02  Jonathan Gapen  <jagapen@wisc.edu>

	* Headers/gnustep/base/NSPort.h: Add NSSocketPort interface.
	* Source/NSSocketPort.m: New file. New MacOS X class partially
	implemented; serves as BSD socket wrapper.

2002-12-02  Adam Fedor  <fedor@gnu.org>

	* base.make.in (CONFIG_SYSTEM_LIBS): Set only if shared=no.
	* config.make.in (CONFIG_SYSTEM_LIBS): Set only if shared=yes.
	* Source/Makefile.preamble (libgnustep-base_LIBRARIES_DEPEND_UPON):
	Depend on $(CONFIG_SYSTEM_LIBS) if shared=yes.

2002-11-29  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/plparse.m: Stefan Urbaneks patch to return 1 on failure.
	* Tools/sfparse.m: Similar code for this tool.
	* Source/Additions/GSObjCRuntime.m: Tidied function names
	* Headers/gnustep/base/GSObjCRuntime.h: ditto.
	* Source/NSKeyValueCoding.m: Use new function names.

2002-11-28  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/AGSParser.m: Fix so we document static declarations made in
	headers and only ignore them in implementation.
	* Tools/AGSOutput.m: Bugfix to output ivar type information.
	* Tools/AGSHtml.m: Reduce space around examples.
	Bugs reported by Chris B. Vetter
	* Source/Additions/GSObjCRuntime.m: Tidied function name conventions.
	* Headers/gnustep/base/GSObjCRuntime.h: ditto.
	* Source/NSKeyValueCoding.m: Use new function names.
	* Source/mframe.m: When scanning arguments, skip type information
	for things poionted to by a pointer - more efficient than scanning
	the fine structure and then throwing away the scanned information.
	* Source/additions/GSMime.m: Fill in 'type' field in multipart/related
	and fix bug in seaarch by content id.  Also minor consistency change
	to API.

2002-11-27  Manuel Guesdon <mguesdon@orange-concept.com>

	* Source/Additions/GSObjCRuntime.m: fixed type call typo 
	in GSFindInstanceVariable
	
2002-11-27  Adam Fedor  <fedor@gnu.org>

	* configure.ac (INCLUDE_FLAGS): New for holding flags needed for
	compiling base.
	* config.make.in (CONFIG_SYSTEM_INCL): Use it.
	* base.make (CONFIG_SYSTEM_INCL): Remove CPPFLAGS
	(CONFIG_SYSTEM_DEFS): Remove.
	* Source/Additions/GNUmakefile: include config.mak

2002-11-27  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSObjCRuntime.m: New file with GNUstep extensions
	from NSObjCRuntime, plus renamed behavior functions, plus a few other
	runtime manipulation functions. EXPERIMENTAL
	* Headers/gnustep/base/GSObjCRuntime.h: declarations for above.
	* Source/GSCompatibility.m: Don't use new format plists when writing
	descriptions.
	Also, honor NSWriteOldStylePropertyLists user default to write old
	style property-lists rather than new style or xml style.
	* Source/NSUser.m: Use USERPROFILE for default home directory on
	windoze.
	* Source/NSArray.m: Write non-xml property lists as ascii.
	* Source/NSDictionary.m: Write non-xml property lists as ascii.
	* Source/mframe.m: use objc_alignof_type() as suggested by Roland
	Schwingel.  Long ago the objc runtime version was buggy so mframe
	implemented its own algorithm.  Now the objc runtime one is better.

2002-11-26  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GCObject.m: Attempt to make garbage collecting
	thread-safe.
	* Source/Additions/GCArray.m: Fix count initialising mutable array.
	* Source/Additions/GSMime.m: Provide a method to generate and return
	a string suitable for use as a boundary.  Make tolerant of multipart
	messages with 'application' as the message type.
	Added ([-setBuggyQuotes:]) method for parsing stuff produced by
	microsoft ;-(

2002-11-25  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUserDefaults.m: Treat '-' on its own as an argument
	rather than the start of a flag name.
	* Source/Additions/GSMime.m: Place angle brackets around generated
	content ID. Add method to generate message ID.  Tidy comments a
	little.

2002-11-20  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/libgnustep-base.def: Add garbage collecting classes.

2002-11-20  Adam Fedor  <fedor@gnu.org>

	* Source/NSBundle.m (+preferredLocalizationsFromArray:forPreferences:): 
	Check for array with no objects.
	([NSBundle -localizedInfoDictionary]): Idem.

2002-11-20  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/Unicode.m: Work around bug in the redhat 8 iconv
	library ... was sucessfully opening the encoding "" when it shouldn't.

2002-11-19  Adam Fedor  <fedor@gnu.org>

	* Version: 1.5.1
	* Documentation/news.texi: Updated.

2002-11-19  Adam Fedor  <fedor@gnu.org>

	* Headers/gnustep/base/NSBundle.h: More documentation. Add missing
	MacOSX methods.
	* Source/NSBundle.m (-executablePath): New
	(-load): Use it.
	(+pathsForResourcesOfType:inDirectory:): New stub.
	(-pathsForResourcesOfType:inDirectory:forLocalization:): Idem.
	(-pathForResource:ofType:inDirectory:forLocalization:): Idem.
	(+preferredLocalizationsFromArray:): New method.
	(+preferredLocalizationsFromArray:forPreferences:): Idem.
	(-localizedInfoDictionary): Idem.
	(-localizations): Idem.
	(-preferredLocalizations): Idem.

	* Source/cifframe.m (cifframe_from_info): Fix so that stucture
	returns get space allocated.

2002-11-19  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/behavior.m: Moved to Source/Additions/behavior.m
	* Source/Unicode.m: Moved to Source/Additions/Unicode.m
	* Source/Additions/GCObject.m: new experimental GC class.
	* Source/Additions/GCArray.m: ditto
	* Source/Additions/GCDictionary.m: ditto
	* Headers/gnustep/base/GCObject.h: Garbage collection classes intended
	for use by gdl2 and gsweb.

2002-11-18  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSCompatibility.m: Fix for case where a non property list	
	object is found when outputting a description.

2002-11-12  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUserDefaults.m: Fix for getting integer, float and bool
	values when they are stored as NSNumbers (problem reported by
	Ludovic Marcotte).  Also optimise a little.

2002-11-15  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSThread.m: Port pipe to mingw.
	* Tools/gdomap.c: Fix for modern mingw interface lookup.
	Patch by Tom Koelman

2002-11-12  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUserDefaults.m: Try again ... get
	([-setVolatileDomain:forName:]) and ([-setPersistentDomain:forName:])
	to conform to both the OpenStep standard and the current MacOS-X
	documentation.

2002-11-11  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSString.m: adocument property list stuff.
	* Source/NSUserDefaults.m: set integers, floats and bools as NSNumber
	Bugfix ([-setVolatileDomain:forName:]) was checking wrong list of
	domains.  Tidied.

2002-11-10  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/gnustep/base/NSObject.h: Removed GNUstep plist extensions.
	* Source/NSObject.m: ditto.
	* Source/GSCompatibility.m: Implement new plist generator.
	* Source/NSArray.m: Use new plist code
	* Source/NSData.m: ditto
	* Source/NSDictionary.m: ditto
	* Source/NSSerializer.m: handle NSNumber and NSDate
	* Source/NSString.m: ditto, plus implement extensions to old plist
	support so we can encode NSNumber and NSDate values.
	Remove GNUstep property list extensions from the api ... make more
	like MacOS and OpenStep spec by having a central mechanism for
	generating property lists rather than spreading the code across the
	plist classes.
	Also ... maintain allocation debug accounting when making objects
	immutable.

2002-11-09  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSObject.m: use NSString implementation of
	([descriptionWithLocale:indent:to:])
	* Source/NSUserDefaults.m: ([setObject:forKey:]) validate and raise
	exceptions if given bad info.

2002-11-07 02:21  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSString.m: (-makeImmutableCopyOnFail:): Set isa to correct
	class.

2002-11-04  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSArray.m: Ensured some documentation in place for almost all
	methods.
	* Source/Additions/GSMime.m: Fix broken method reference.
	* Source/Additions/GSXML.m: ditto
	* Source/NSScanner.m: ditto
	* Source/NSUnarchiver.m: ditto
	* Tools/AGSIndex.m: Minor fix for superclass reference lookup.
	* Tools/AGSHtml.m: ditto

2002-11-03  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSRunLoop.m: Revert to remove unneeded notification setup.
	* Source/NSThread.m: Rewrite pierres changes, scrapping all
	conditionally compiled code that would never be used, rewriting
	unix specific stuff (so it might run under windoze ... not yet tested)
	removed unnecessary code and simplified, etc etc.
	Fixed bugs in usage of condition locks so it actually works.
	* Testing/thread.m: New test to try out
	performSelectorOnMainThread:withObject:waitUntilDone:modes:

2002-11-02  Pierre-Yves Rivaille <pyrivail@ens-lyon.fr>

	* Source/NSRunLoop.m ([NSRunLoop -init]): ask to be informed about
	NSWillBecomeMultiThreadedNotification if _willBecomeMultiThreaded:
	method existes.
	* Source/NSRunLoop.m: new GSAppKitInterThreadRunLoopWatcher private
	class.
	([NSRunLoop -_willBecomeMultiThreaded:]): new method, sets up the 
	lock, the socket and new run loop watcher that'll listen on the socket.
	[NSObject -performSelectorOnMainThread:withObject:waitUntilDone:modes:]):
	modified to use the previous changes.

2002-11-01  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/gnustep/base/NSBundle.h: Tidied/corrected documentation
	markup.
	* Headers/gnustep/base/NSDate.h: Added NSTimeIntervalSince1970 and
	removed GSTimeNow() from public API.
	* Source/NSDate.m: Update to use NSTimeIntervalSince1970
	* Source/NSTimer.m: Declare GSTimeNow() locally
	* Source/NSprocessInfo.m: ditto
	* Source/Additions/GSMime.m: more tolerant parsing ... ignore excess
	data in multi-part document.
 
Thu Oct 31 00:46:23 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Headers/gnustep/base/NSBundle.h: Added more documentation.

Wed Oct 30 23:42:50 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/NSBundle.m ([+_addFrameworkFromClass:]): New code
	locating linked frameworks magically - no matter where they are on
	disk - by using objc_get_symbol_path().  If that fails or is not
	available, fall back on the existing code.  Fixed NSLog() message.

2002-10-30  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSThread.m: Implemented and documented new MacOS-X methods -
	([-performSelectorOnMainThread:withObject:waitUntilDone:modes:])
	and ([-performSelectorOnMainThread:withObject:waitUntilDone:])

Wed Oct 30 03:14:34 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Headers/gnustep/base/objc-load.h: Added copyright notice.
	(objc_get_symbol_path): Declare to take a Category *, not a struct
	objc_category *, argument; documented.
	* Source/objc-load.m: Include config.h first.  Define _GNU_SOURCE
	if HAVE_DLADDR is defined.
	(objc_get_symbol_path): Fixed crash with classes or categories
	with long names.  Updated declaration.
	* config/objc-sys-dynamic.m4 (OBJC_SYS_DYNAMIC_LINKER): Print a
	message displaying the type of dynamic linker found.  Add -ldl on
	the link line for linux-gnu and other systems, so that dladdr() is
	actually found.  With the 'simple' linker, print a message saying
	if we found dladdr() or not.
	(OBJC_SYS_DYNAMIC): Historical unused macro removed.
	* configure: Regenerated.

2002-10-28  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSFileManager.m: include statvfs.h if available.

2002-10-26  Adam Fedor  <fedor@gnu.org>

	* Source/NSException.m: Document.
	* Source/NSFileHandle.m: Partial Documentation.
	* Source/NSObject.m: Fix typo in docs.

2002-10-25  Mirko Viviani  <mirko.viviani@rccr.cremona.it>

	* Source/NSBundle.m ([NSBundle -load]): set _codeLoaded before loading
	the bundle.

2002-10-22  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/AGSParser.m: Avoid duplication of method comments when
	parsing the same file as both header and source.

2002-10-22  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/AGSOutput.m: ([-split:]) In links generated from class and
	method specifications in square brackets, place a space between the
	class and the method name.
	* Tools/gsdoc-1_0_0.dtd: Corrected minor entity errors.

2002-10-21  Adam Fedor  <fedor@gnu.org>

	* Headers/gnustep/unicode/thai.h: New file.
	* Headers/gnustep/base/NSString.h (_NSStringEncoding): Add
	NSISOThaiStringEncoding.
	* Source/NSString.m (-dataUsingEncoding:allowLossyConversion:): 
	Handle it.
	* Source/Unicode.m (struct _strenc_ str_encoding_table[]): Idem. 
	(GSEncodingForRegistry): Idem.
	(GSToUnicode, GSFromUnicode): Idem.
	(Patches, modified, from Banlu Kemiyatorn <id@project-ile.net>).

2002-10-21  Adam Fedor  <fedor@gnu.org>

	* Source/GSLocale.m (GSLanguageFromLocale): Implement regardless
	of HAVE_LOCALE_H.

	* Source/Unicode.m (GSEncodingForRegistry): New (from
	[GSFontInfo +encodingForRegistry:encoding:]).
	(GSEncodingFromLocale): New.
	(GetDefEncoding): Rearrange encoding check.
	* Resources/Languages/Locale.encodings: New file.

2002-10-21  Adam Fedor  <fedor@gnu.org>

	* Documentation/coding-standards.texi: Update.

2002-10-14  Richard Frith-Macdonald <rfm@gnu.org>

	Source/NSObject.m: Add ([-makeImmutableCopyOnFail:]) for use by methods
	wishing to return constant string/array/dictionary etc results after
	building them using mutable objects they created.
	Source/GSArray.m: Implement ([makeImmutableCopyOnFail:])
	Source/GSString.m: ditto
	Source/GSDictionary.m: ditto
	Source/GSSet.m: ditto
	Source/NSFileManager.m: Use it

2002-10-13  Mirko Viviani  <mirko.viviani@rccr.cremona.it>

	* Source/NSBundle.m ([NSBundle +_addFrameworkFromClass:]): remove
	the classes in the _loadingBundle that does not belong to it but with
	frameworks linked with it.
	([NSBundle +bundleForClass:]): construct a list of NSFramework_*
	classes loaded with the bundle.
	([NSBundle -load]): call _addFrameworkFromClass: for all linked
	frameworks with the bundle.

2002-10-13  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/AGSHtml.m: Create automatic references to protocols in
	type specifications of the form (id<protocol1,protocol2,...>)
	* Tools/autogsdoc.m: Add -Files option to read names of files
	to process as a property list rather than using command line args.
	Add -Clean flag to remove generated output files and purge
	generated data from templates.  Add -CleanTemplates to completely
	temove template files.
	* Tools/AGSParser.m: Warn about private methods and ivars.

2002-10-12  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSProcessInfo.m: Make safe to reinitialise with args.
	* Source/Additions/GSXML.m: Correct handling of atttribute values.
	* Tools/autogsdoc.m: Initialise NSProcessInfo explicitly.

2002-10-11  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUserDefaults.m: ([-initWithContentsOfFile:]) check to see
	if the file is writable and the directory exists.
	If we can't operate properly, run in read-only ,mode where we try
	to read the file if possible, but never write defaults back.

2002-10-10  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUserDefaults.m: ([-synchronize]) handle locking more
	carefully ... avoid cpu intensive busy loops and give up after
	a while.

2002-10-10  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSLog.m: Added GSPrintf()
	* Tools/defaults.m: Use GSPrintf()
	* Tools/pldes.m: ditto
	* Tools/plser.m: ditto
	* Tools/plmerge.m: ditto
	* Tools/plparse.m: ditto
	* Tools/sfparse.m: ditto
	* Documentation/Base.gsdoc: Bump gsdoc version to 1.0.0
	* Documentation/Functions.gsdoc: ditto
	* Documentation/TypesAndConstants.gsdoc: ditto
	* Source/NSLog.m: Fix typo in comment.
	* Tools/AGSOutput.m: Bump gsdoc version to 1.0.0
	* Tools/GNUmakefile: Add gsdoc 1.0.0 dtd
	* Tools/autogsdoc.m: Bump gsdoc version to 1.0.0
	* Tools/gsdoc-0_6_7.dtd: Revert to earlier version
	* Tools/gsdoc-1_0_0.dtd: New from latest update to 0.6.7
	I think the documentation dtd is pretty complete now.

2002-10-09  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/GNUmakefile: revert ... can't build if base library isn't
	installed.

2002-10-09  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSLog.m: Lots of documentation added.
	* Tools/GNUmakefile: build autogsdoc documentation automatically
	if possible.
	* Tools/AGSOutput.m: Make automatic cross references for functions.
	* Source/Docmakefile: Use handcrafted template files.  Document the
	path utilities file.
	* Documentation/Functions.gsdoc: Handcrafted template.
	* Documentation/TypesAndConstants.gsdoc: Handcrafted template.

2002-10-08  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSDebug.h: Make warn logs de-selectable at
	runtime by setting the NoWarn debug level.  Document.  Say that
	debug levels can be added by putting them in the GNU-Debug
	array in the defaults database.
	* Source/NSUserDefaults.m: Add contents of the GNU-Debug array to
	the set of active debug levels.
	* Tools/AGSParser.m: Updated with support for documenting macros.
	* Tools/AGSOutput.m: ditto
	* Tools/AGSHtml.m: ditto

2002-10-07  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSData.m: Update logging after checks for results of memory
	allocation.
	* Source/NSTimeZone.m: Don't abort on failure to allocate memory ...
	just print a log and continue returning a null pointer.

2002-10-06  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSData.m: readContentsOfFile() fix use of atomic memory
	on GC systems ... problem noticed by Fred.

Sat Oct  5 19:53:03 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/NSData.m ([NSDataMappedFile
	-initWithContentsOfMappedFile:]): release self and return nil -
	rather than returning NO, if the path is bad.

2002-10-05  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/AGSOutput.m: Improve warning code, support text output
	in chapter/section/subsection.
	* Tools/AGSParser.m: move concatenation of comments into a single
	method, make it insert a linebreak between concatenated comments,
	and make it refrain from appending the same comment onto itsself
	(which would happen if the same file was parsed twice, as both a
	header and as source).
	Treat the 'main()' function specially ... don't document it as a
	function but insert its comments at the end of the 'chapter' part
	of the output document.  These modifications make it easy to
	document a directory containing tools, by listing the tool source
	files as arguments to autogsdoc.
	Tools/gsdoc_0_6_7.dtd: Fix bug preventing use of text in a chapter!
	* Source/GSString.m: Implement -UTF8String method for better
	performance.
	* Source/NSPortNameServer.m: Improve diagnostic message in exception
	when reporting failure to register ... try to provide all the info
	needed to begin diagnosing any problem.
	* Tools/gdomap.c: Make -M flag work with -N.  Make -M flag work when
	used after -N or -L.  Improve diagnostic messages on failure so
	people know what it is trying to do.

2002-10-04  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSArray.m: Tidied init from file to ensure that everything
	is released properly on failure, and we don't generate log messages
	where a lower level API should be doing it.  Added some documentation.
	* Source/NSDictionary.m: ditto
	* Source/NSString.m: ditto.  Also add support for understanding the
	unicode BOM at the start of UTF8 data and stripping it.
	* Source/NSData.m: Tidied read from and write to file,
	adding lots of logging information.  Also documented quite a bit.
	Resolved all conflicts found with Adam's change ... generally in
	favor of the most informative logging.
	* Source/NSPortNameServer.m: On failure to register name, make
	exception message provide lots of detail/advice for newbies.

2002-10-03  Adam Fedor  <fedor@gnu.org>

	* Source/NSData.m (readContentsOfFile): Change NSDebugLog(s) to
	NSWarnLog or NSLog.
	(-writeToFile:atomically:): Idem.
	([NSDataMappedFile -initWithContentsOfMappedFile:]): Idem.
	* Source/NSDictionary.m ([NSDictionary -initWithContentsOfFile:]):
	Release ourselves and return nil if file cannot be read.

2002-10-03  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSRunLoop.m: ([-runMode:beforeDate:]) permit the use of a
	nil date and document it.  This is the behavior MacOS seems to have
	and seems to be more useful than prohibiting nil dates.

2002-10-02  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSDistributedLock.m: Document and tidy.
	* Source/NSTimeZone.m: Don't set system zone prematurely.
	* Source/NSString.m: Don't bother to cache constant string
	class.  Document it.

2002-10-01  Adam Fedor  <fedor@gnu.org>

	* config/pathxml.m4: Filter -L/usr/lib out of XML_LIBS.
	* configure: Regenerate.

2002-10-01 02:21  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSUserDefaults.m (-synchronize): Handle lockDate being nil.

2002-09-30  Richard Frith-Macdonald <rfm@gnu.org>

	* NSTimeZones/NSTimeZones.tar: Updated to latest information.
	* Source/NSCalendarDate.m: Tidy up a little.
	* Source/NSTimeZone.m: Rewrite main timezone code for performance -
	Roughly doubles speed of most NSCalendarDate stuff.
	* NSThread.m: Fix for single threaded operation ... suggested by
	Ludovic Marcotte.

2002-09-29  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSFileHandle.m: Encapsulate read and write operations in
	new low level methods to ease subclassing.
	* SSL/GSSSLHandle.m: Use new read and write methods to simplify. 

2002-09-28  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSCalendarDate.m: Fix problem with signed/unsigned type
	conversion when initialising a date at a daylight savings time
	boundary, and attempt to improve the code for adding offsets to
	dates.
	* Source/Makefile.postamble: patch to fix some warnings in
	uninstall (by David Ayers).

2002-09-27  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSTcpPort.m: ([GSTcphandle+initialize]) ignore SIGPIPE in
	case a socket gets closed while we are writing.

2002-09-26  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSMime.m: Fix typo.

Thu Sep 26 01:28:33 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Tools/make_strings/GNUmakefile: Do not include ctool.make.

2002-09-25  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSXML.m: Added ([-previousElement]) to match the
	[(-nextElement]) method.

Wed Sep 25 02:46:28 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Tools/make_strings/make_strings.m (main): Remove "" languages
	from the list of languages before processing.

2002-09-24  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSTcpHandle.m: ([-handleForPort:beforeDate:]) fix bug where
	we could end up using the last (non-matching) handle rather than
	creating a new one.

2002-09-20  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSTcpHandle.m: ([-connectToPort:beforeDate:]) Added more
	informative logging for problem condition reported by Nicila ...
	perhaps it will help tracking down cause.

2002-09-19  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSFormat.m: Where a %p format prints a null pointer,
	print the text (null).
	* Source/GSTcpHandle.m: Check port for invalidation while looping
	on write events, so we can fail if we become invalid while sending
	or connecting, before the port timeout expires.
	* Source/NSConnection.m: Check connection for invalidation while
	looping waiting for a reply, so we can fail if we become invalid
	before the timeout expires.
	* Source/DocMakefile: Specify template options
	* Tools/autogsdoc.m: Remove hack to turn templates on by default.
	Document the use of templates.
	* Tools/gsdoc-0_6_7.dtd: Hack in more types for indexing ... don't
	know if the software works for them though.

2002-09-17  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Unicode.m: Restructure conversion from unicode slightly,
	to make it clearer and more readable and to include handling of
	lossy conversions.
	* Headers/gnustep/unicode/gsm0338.h: Added table for lossy conversion
	from unicode.

2002-09-16  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/AGSParser.m: Bugfix ... look for source files more
	intelligently. Try both current directory and relative to header.
	* Tools/AGSOutput.m: When creating template output file for functions
	etc because none was supplied, take account of the -Up flag and
	create an up link in it.
	* Source/GSHTTPURLHandle.m: If response parsing fails, fail the
	load operation and (conditionally when debug enabled) log an error.

2002-09-16  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSFileManager.m: Basic/dummy implementations of new MacOS-X
	methods added. Attribute handling totally rewritten to work in a lazy
	way ... so we only set up attribute info in the dictionary when we
	actually need it.  Account 'Number' methods and dictionary keys changed
	to be account 'ID' instead ... in accordance with MacOS-X usage.
	Documented the class.
	* Source/NSData.m: ([-writeToFile:atomically:]) implement workaround
	for bug in windoze implementation of rename()
	* Source/NSString.m: Remove some redundant code duplicating stuff in
	GSMime.m

2002-09-15  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSFileManager.m: MacOS-X ([componentsToDisplayForPath:]) and
	([displayNameAtPath:]) methods implemented.  Creation date added.
	* Source/NSString.m: More alterations to GNUstep extension methods
	to make their names consistent with other methods.
	Q. Should we deprecate/remove them entirely?
	* Tools/gsdoc.m: Update for changes to extension methods... though
	this tool has been deprecated for some time now, so perhaps we
	should remove it?

2002-09-13  Adam Fedor  <fedor@gnu.org>

	* Source/cifframe.m (cifframe_guess_struct_size): Recurse if
	element contains structures.
	(cifframe_from_info): Alloc room for return value even if caller
	doesn't use it.

Thu Sep 12 11:02:03 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/NSObject.m ([+_becomeMultiThreaded:]): Fixed typo - this
	method was declared to take a 'NSNotification' rather than a
	'NSNotification *' argument.

2002-09-10  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSLocale.m: Double locking check fix
	* Source/NSFileManager.m: Double locking check fix
	Fixes contributed by David Ayers <d.ayers@inode.at>

2002-09-08  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/gnustep/base/GSIArray.h: Minor optimisation
	* Headers/gnustep/unicode/gsm0338.h: Correct unicode to gsm table
	* Source/Unicode.m: Correct gsm conversion and optimise unicode to
	8-bit charaacter conversion for other character sets. Also correct
	lossy/non-lossy conversion using iconv.

2002-08-30  Adam Fedor  <fedor@gnu.org>

	* Version: 1.5.0

2002-08-30  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSString.m: Implemented new MacOS-X methods -
	([-stringByPaddingToLength:withString:startingAtIndex:]), and
	([-stringByTrimmingCharactersInSet:])
	Tidied a couple of extension method names for consistency and
	documented several methods.

2002-08-29  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSXML.m: Get libxml to put filename in error
	messages when it is available.

2002-08-28  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Unicode.m: Rewritten the way that iconv is used to decide
	upon the available encodings ... lazy evaluation so that we don't
	try to lookup an encoding until we have to.  This should improve
	process startup time (especially in gdb) since the iconv operations
	seem to be very slow.

2002-08-27  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSXML.m: Integrated GSXPath code by Nicola Pero
	provides an API to use the xpath support built into libxml from
	version 2.3 onwards.
	* Source/NSThread.m: Implement new priority methods.
	* Source/NSObject.m: Raise exception when passed null selector.

2002-08-27  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSData.m: ([-writeToFile:atomically:]) Removed bogus line
	which deleted files when it shouldn't.
	Added new MacOS-X methods supporting NSData objects where the bytes
	are not owned by the data object.  Removed GNUstep extension which
	provided this functionality before.
	* Source/NSUserDefaults.m: Use distributed lock to ensure that there
	is no possible window when the defaults file is invalid ... not all
	systems guarantee that the rename() system call is atomic.
	* Source/NSArray.m: New MacOS-X methods ([-initWithArray:copyItems:])
	([-exchangeObjectAtIndex:withObjectAtIndex:])
	* Source/NSTimer.m: Update for compatibility with latest MacOS-X
	* Source/NSObject.m: New ([+isSubclassOfClass:]) and perform
	cancellation from MacOS-X
	* Source/NSRunloop.m: New perform cancellation method from MacOS-X
	proofreading help/fixes from David Ayers.
 
2002-08-25  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/WindowsFileHandle.m: Removed ... no longer used.
	* Source/GSHTTPURLHandle.m: Don't use getpid() ... not portable.
	* Tools/gdomap.c: Don't use getuid() under windoze. 

2002-08-24  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSURL.m: ([-initFileURLWithPath:]) check to see if path is
	a directory and append a trailing slash if necessary.  Remove hack
	to refrain from stripping last patch component in file URLs.

2002-08-24  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSURL.m: Hacks for compatibility with MacOS-X in returning
	path of a file URL ... the RFC says we should only return a path
	for a generic URL (scheme://user:passwd@host:port/path#frag?query)
	which a file URL certainly isn't.  However, for compatibility we
	now treat a file URL more like a generic one.
	Also when creating absolute file URLs from base plus relative,
	the MacOS-X code doesn't strip the last path component of the
	base URL as it should ... we emulate that too.

2002-08-22  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSFileManager.m: Fix typo ... missing closing brace under
	windoze. Reported by Alex Stockdale.

2002-08-21  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSObject.m: ([-replacementObjectForPortCoder:])
	Documented method and removed unused/unwanted code dealing with
	NSDistantObject (NSDistantObject overrides the method).

2002-08-20  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSObject.m: Fix silly typo.

2002-08-20  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSConnection.m: (-removeProxy:) Remove unbalanced release.

2002-08-20  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSCountedSet.m:
	* Source/GSFileHandle.m:
	* Source/NSArchiver.m:
	* Source/NSData.m:
	* Source/NSDistributedNotificationCenter.m:
	* Source/NSHashTable.m:
	* Source/NSMapTable.m:
	* Source/NSObjCRuntime.m:
	* Source/NSObject.m:
	* Source/NSPortCoder.m:
	* Source/NSScanner.m:
	* Source/NSString.m:
	* Source/Unicode.m:
	* Source/UnixFileHandle.m:
	* Source/WindowsFileHandle.m:
	* Source/callframe.m:
	* Source/cifframe.m:
	* Source/mframe.m:
	Fix trivial typos and spelling errors pointed out by David Ayers.

2002-08-20  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSCountedSet.m:
	* Source/NSAutoreleasePool.m:
	* Source/NSCharacterSet.m:
	* Source/NSCountedSet.m:
	* Source/NSData.m:
	* Source/NSDebug.m:
	* Source/NSDictionary.m:
	* Source/NSFileHandle.m:
	* Source/NSLock.m:
	* Source/NSNull.m:
	* Source/NSNumber.m:
	* Source/NSObject.m:
	* Source/NSPipe.m:
	* Source/NSScanner.m:
	* Source/NSSerializer.m:
	* Source/NSSet.m:
	* Source/NSString.m:
	* Source/NSThread.m:
	* Source/NSTimeZone.m:
	* Source/Additions/GSMime.m:
	* Headers/gnustep/base/NSBundle.h:
	* Headers/gnustep/base/NSRange.h:
	* Headers/gnustep/base/NSSet.h:
	Modify comments to include gsdoc documentation for autogsdoc.
	This completes the transfer of all gsdoc documentation into
	the source code.
	* Documentation/gsdoc:  All obsolete files removed.

2002-08-19  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSProxy.m: Documented all methods and corrected implementation
	of some introspection methods.

2002-08-16  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Base.gsdoc: Moved to Documentation.
	* Source/GNUmakefile: Removed documentation building code.
	* Source/DocMakefile: New file for building refetrence documentation.
	* Documentation/Base.gsdoc: New from source directory.
	* Documentation/GNUmakefile: Set up installation directory name.
	* Documentation/Makefile.postamble: Use ../Source/DocMakefile to build
	library reference documentation and deal with installation.

2002-08-15  Adam Fedor  <fedor@gnu.org>

	* configure.ac: Add NetBSD header/ldflag support (Patch from
	Peter Cooper).

	* Headers/gnustep/base/GNUstep.h: New compatibility file.

2002-08-15  Richard Frith-Macdonald <rfm@gnu.org>

	* SSL/GNUmakefile: Added -lgnustep-base and -lobjc to SSL_BUNDLE_LIBS
	So that bundle is linked with a dependency on these libraries ... to
	ensure that dynamic linkage works when the bundle is loaded in from
	java via jigs.

2002-08-15  Adam Fedor  <fedor@gnu.org>

	* SSL/configure.ac: Simplified check for libraries. Added socket
	lib check for Solaris.

	* Headers/gnustep/base/NSDecimalNumber.h: Add NSNumber category
	for decimalValue.
	* Source/NSDecimalNumber.m ([NSNumber -decimalValue]): Implemented.

2002-08-14  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSString.m: Allow 'true' as boolean value
	* Source/NSConcreteNumber.m: Output 'YES' as boolean in description.
	* Source/NSNotificationCenter.m: Fix dumb memory leak.
	* Source/NSNumber.m: Output 'YES' as boolean in description.
	* Source/NSUserDefaults.m: Set 'YES' as boolean string.
	* Headers/Foundation/NSObject.h: Fix v dumb memory leak.
	* Source/GSHTTPURLHandle.m: Append crlf to separate headers from body
	rather than just an lf.
	* SSL: Renamed SSL class and source file to reflect the fact
	that the code is not unix specific.

2002-08-11  Richard Frith-Macdonald <rfm@gnu.org>

	* configure.ac: Check for libxml version 2.3.0 or greater to ensure
	we have xpath support.
	* Source/NSDecimalNumber.m: implement ([-getValue:]) and
	([-initWithBytes:objCType:])

2002-08-09  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSNotificationCenter.m: ([-postNotification:]) Correct to
	post the actual notification we are given rather than a notification
	built from that one.  Bug report by Alexander Malmberg.

2002-08-08  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSProcessInfo.m: ([-globallyUniqueString]) Ensure that the
	string contains no dots, so it can be used as a filename under
	windoze.
	* Source/Additions/GSXML.m ([GSXMLNode -setNamespace:]): Documented.

2002-08-07  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSString.m: ([-boolValue]) Accept 'true' as well as 'YES'
	* Source/NSThread.m: Modified to avoid using non-standard notification
	initialisation.
	* Source/NSNotification.m: Rewritten as abstract/cluster class for
	implementation compatibility with MacOS-X
	* Source/NSNotificationCenter.m: Modified posting to behave like the
	MacOS-X implementation.  Implement concrete subclass of
	NSNotification.
	* Source/NSUserDefaults.m: Try to make creation of new defaults
	database an atomic operation.
	* Source/NSObject.m: Remove dealloc notifications hack ... the
	dealloc method can now safely be used to refrain from deallocating
	objects, so I don't think the hack is needed any more.
	* Source/NSProcessInfo.m: ([-globallyUniqueString]) Update to ensure
	uniqueness across all hosts, processes, and threads.
	* Tools/gdomap.c: Tidyup patch by Matthias Klose

2002-07-29  Adam Fedor  <fedor@gnu.org>

	* Merge changes from 1.4.0 onto main branch.

2002-07-09  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSTcpHandle.m: Always use runloop in NSConnectionReplyMode
	to avoid other NSDefaultRunLoopMode events being triggered while
	executing a DO method.  **EXPERIMENTAL**

2002-08-06  Adam Fedor  <fedor@gnu.org>

	* Source/NSString.m (-getLineStart:end:contentsEnd:forRange:):
	Change location of start of end char search (Patch from Pete
	French).

2002-07-27  Adam Fedor  <fedor@gnu.org>

	* Version: 1.4.0

2002-07-23  Adam Fedor  <fedor@gnu.org>

	* Source/NSInvocation.m ([GSFrameInvocation
	-initWithMethodSignature:]): Return nil if signature is nil.
	* Source/GSFFCallInvocation.m (-initWithMethodSignature:): Idem.
	* Source/GSFFIInvocation (-initWithMethodSignature:): Idem.
	
2002-07-20  Adam Fedor  <fedor@gnu.org>

	* Source/NSDecimal.m: ifdef for compiling on Darwin (report
	from Carl Eugen).
	* Source/NSInvocation.m ([-initWithSelector:): Rewrite to use
	designated initializer.
	(-initWithTarget:selector:): Idem.

2002-07-18  Adam Fedor  <fedor@gnu.org>

	* Tools/gdomap.c (main): Write the pidfile before switching away
	from root, but only if the user is root.

2002-07-17  Adam Fedor  <fedor@gnu.org>

	* Source/NSString.m (-getLineStart:end:contentsEnd:forRange:): Fix
	lineEnd and contentEnd check for \r\n (particularly at end of
	string.

Tue Jul 16 16:43:59 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Headers/gnustep/base/GSXML.h ([GSXMLNode -setNamespace:]): Added
	missing method essential to use namespaces.
	* Source/Additions/GSXML.m ([GSXMLNode -setNamespace:]): Implemented.
	
2002-07-08  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSFileManager.m: Don't standardise path before converting to
        filesystem representation.
        * Tools/gdomap.c: Security enhancement - call setgroups().

2002-07-03  Adam Fedor  <fedor@gnu.org>

	* Version: 1.3.4
	* configure.ac: Remove warning about libffi
	* Documentation/news.texi: Update.

2002-07-03  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSMime.m: Ensure mime-version header appears
	before other headers. Fix bug in terminatimg mime data.

2002-07-02  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/gdomap.c: Don't write to pidfile until *after* setuid away
	from root. Bug reported by James Kehl <mkehl@gil.com.au>

2002-07-01  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSMime.m: Correct test for multipart content when
	generating raw data.  Fix by Mark Allison <mark@brainstorm.co.uk>

2002-06-30  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/gnustep/base/GSFileHandle.h: New version of UnixFileHandle
	for combined unix/windoze use.
	* Source/GSFileHandle.m: New combined unix/windows implementation.
	* Source/NSFileHandle.m: Use GSFileHandle.
	* Source/GNUMakefile: Build GSFileHandle.
	* SSL/GSUnixSSLHandle.m: Update for combined GSFileHandle

2002-06-29  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSObject.m: ([-respondsToSelector:]) handle nul selectors.
	Bug report by Andy Ruder <aeruder@yahoo.com>

2002-06-28  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSString.m: Change to quote strings in plist output
	aggressively (quote characters that don't really need quoting)
	while still parsing flexibly ... ie handle unquoted strings as
	long as they don't contain 'special' characters.
	Fix for Tom Hageman <th@xs4all.nl>

2002-06-27  Richard Frith-Macdonald <rfm@gnu.org>

        * Tools/AGSParser.m: ([-parseDeclaration:]) Correct wrongly
	positioned autorelease pool in last change. Hope that's the only
	one.

Wed Jun 26 15:32:36 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* base.make.in (OBJC_LIBS): Don't add -lobjc_gc -lgc for gc=yes,
	now should be done by gnustep-make automatically.

Tue Jun 25 13:31:12 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Tools/AGSHtml.m: Tidy up autorelease pool macros so that it
	compiles with gc=yes and old compilers.
	* Tools/AGSParser.m: Idem.
	* Tools/AGSOutput.m: Idem.
	* Tools/HTMLLinker.m: Idem.
	* Tools/autogsdoc.m: Idem.
	* Tools/gdnc.m: Idem.
	* Tools/gsdoc.m: Idem.
	* Tools/make_strings/make_strings.m: Idem.	

Tue Jun 25 13:13:00 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/Additions/GSMime.m ([-rawMimeData:]): Create the
	autorelease pool after the other variables, so that it compiles
	with gc=yes and gcc < 3.x.
	* Source/NSLog.m (NSLogv): Idem.
	
2002-06-23  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSFileHandle.h: add async read of specific length.
	* Source/NSFileHandle.m: Make the async wconvenience methods call
	the core ones.
	* Source/UnixFileHandle.m: Remove async convenience methods and add
	one to read specified length of data.

2002-06-21  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSMime.m: add a few consistency checks to raise an exception
	if we try to unparse a GSMimeDocument with inconsistent headers and
	content.

2002-06-19  Adam Fedor  <fedor@gnu.org>

	* Source/GSLocale.m (GSSetLocaleC): Only set locale for LC_CTYPE.

2002-06-18  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSURL.m: Cope with a URL where the path is missing.
	Check user, password, host, port parts for illegal characters.
	Thanks to bug report by Marco Manfredini <mldb@gmx.org>
	* Source/GSMime.m: add convenience method for setting document type.
	Fix error in recent change to base64 encoding.

2002-06-17  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSTimer.m: Retain target and user info on initialisation
	Release them on invalidation.  Ensure timer is invalidated on
	deallocation. Documented timer methods.
	Changes based on bug report by Andy Ruder <aeruder@yahoo.com>
	* Source/NSURL.m: Fixed one possible nul pointer indirection,
	and added some comments about the internal data structure.
	Handle percentage escape sequences in user, password, host and port
	even though MacOS-X only seems to do it for the user name and host.
	* Tools/plmerge.m: Fixed some crasher bugs where given bad arguments.

2002-06-16  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSFTPURLHandle.m: simple implementation added
	* Source/NSURLHandle.m: Register GSFTPURLHandle for ftp scheme.
	* Source/GSHTTPURLHandle.m: modified so that data being read is
	reported periodically during the read proces rather than just at end.

2002-06-15  Adam Fedor  <fedor@gnu.org>

	* Source/NSProcessInfo.m: Include sys/fcntl for Solaris.

2002-06-14  Richard Frith-Macdonald <rfm@gnu.org>

	* config/pathxml.m4: Adjust path to headers.
	* Tools/gsdoc.m: Adjust path to headers.  Add warning about
	deprecation.
	Patch by e.sammer <eric@linuxstep.org>
	* Source/NSObject.m: Added some compatibility methods in a
	categpory of Object.
	* Source/Additions/GSMime.m: Add a couple of convenience methods.
	* Source/GSHTTPURLHandle.m: Use one of them.
	* SSL/Makefile.postample: on distclean, don't need to delete
	bundle, but do delete config.h explicitly.

2002-06-13  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSXML.m: Include NSInvocation.h to avoid
	compiler warning.

2002-06-12  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSObject.m: Fix a few errors which crept in to the map
	table based reference counting.
	* Examples/GNUmakefile: Permit local makefile to be missing.
	* Source/UnixFileHandle.m: Added outgoing SOCKS5 support.
	* Source/NSFileHandle.m: Added SOCKS5 documentation.
	* Source/Base/gsdoc: Dopcumented SOCKS enironemnet variables and defs.
	* Source/NSNotification.m: Made -description more informative.
	* Testing/call.m: Trivial test program for tcp connections.
	* SSL/GSUnixSSLHandle.m: Updated for socks.
	* Additions/GSMime.m: Utilites to encode/decode base64
	* Source/GSHTTPURLHandle.m: Use encoding.

2002-06-10  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/UnixFileHandle.m: Avoid some unnecessary autoreleases.

2002-06-09  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSObject.m: Implemented and documented -className
	* Tools/AGSOutput.m: When Verbose = YES log all documentable
	entities for which no comment text was found.
	* Source/NSException.m: Added NSParseErrorException and tidied other
	general exceptions.
	* Source/extern.m: Removed generic exceptions ... now in NSException.m

2002-06-06  Adam Fedor  <fedor@gnu.org>

	* Source/cifframe.m (cifframe_from_info): Set value locations
	after prepping cifframe.

2002-06-06  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSLog.m: patch by Jeff Teunissen to avoid adding date/time
	info when using syslog.
	* Source/NSURL.m: Fix loading codde to set self as client of handle.
	* Tools/AGSParser.m: Fix to avoid warnings about unimplemented protocols
	* Headers/gnustep/base/GSXML.h:
	* Headers/gnustep/base/NSArchiver.h:
	* Headers/gnustep/base/NSAutoreleasePool.h:
	* Headers/gnustep/base/NSCoder.h:
	* Headers/gnustep/base/NSDictionary.h:
	* Headers/gnustep/base/NSFileHandle.h:
	* Headers/gnustep/base/NSNotification.h:
	* Headers/gnustep/base/NSRunLoop.h:
	* Headers/gnustep/base/NSURL.h:
	* Headers/gnustep/base/NSURLHandle.h:
	* Source/GSHTTPURLHandle.m:
	* Source/NSArray.m:
	* Source/NSCoder.m:
	* Source/NSFileHandle.m:
	* Source/NSNotification.m:
	* Source/NSRunLoop.m:
	* Source/NSURLHandle.m:
	* Source/NSUnarchiver.m:
	* Source/externs.m:
	* Source/Additions/GSXML.m:
	Tidied for documentation purposes ... no substantial code changes

Wed Jun  5 17:46:47 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/NSLog.m (_NSLog_standard_printf_handler): Fixed
	syslogging of strings: add a NULL at the end of strings before
	feeding them to syslog.

2002-06-05  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSURL.h: Added a couple of ivars and removed
	non-standard methods.
	* Source/NSURL.m: Rewrite everything apart from the code dealing
	with NSURLHandle objects (and change some of that) to conform to
	the documentation (I hope) and to try to match behavior with that
	of MacOS-X.

2002-06-04  Adam Fedor  <fedor@gnu.org>

	* Headers/gnustep/base/NSByteOrder.h: Hack for bug in gcc 3.1
	* Source/externs.m (_gcc3_1_hack): Idem. (modified patch from 
	benhur@inf.ufsm.br).

	* Source/GSFFIInvocation.m (gs_objc_msg_forward): Alloc closure
	with fastMallocBuffer.

	* Documentation/coding-standards.texi: Update.

2002-06-02  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSObject.h: Removed  ([_dealloc]),
	([-deallocNotificationsActive]), ([setDeallocNotificationsActive:])
	* Source/NSObject.m: Removed  ([_dealloc]),
	([-deallocNotificationsActive]), ([setDeallocNotificationsActive:])
	as these methods are no longer necessary now that the dealloc method
	itsself is able to refrain from performing deallocation if if wishes
	(the retain count mechanism can no longer reach a zero retain count).

2002-06-01  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSObject.m: Change NSDecrementExtraRefCountWasZero() to
	refrain from decrementing when the count is zero.  Documented
	the retain/release/retainCount methods (and others).
	* Headers/Foundation/NSObject.h: Documented extra ref count functions.

2002-05-28  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSObject.m: Change order of zombie initialisation for
	darwin port.

2002-05-28  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/gnustep/base/GSMime.h: Make set... methods return void.
	* Source//GSMime.m: Make set... methods return void.  Also fix
	parsing to use different 'specials' for HTTP and MIME
	* Headers/gnustep/base/GSIMap.h:
	* Headers/gnustep/base/NSHashTable.h:
	* Headers/gnustep/base/NSMapTable.h:
	* Source/GSArray.m:
	* Source/GSSet.m:
	* Source/GSTcpPort.m:
	* Source/NSBundle.m:
	* Source/NSConnection.m:
	* Source/NSData.m:
	* Source/NSHashTable.m:
	* Source/NSMapTable.m:
	* Source/NSObject.m:
	* Source/NSRunLoop.m:
	Applied patches by James Knight, to improve memory efficiency and
	insertion.deletion speed to hash and map tables.  Also fixes for
	some GC problems.
	Fixed minor problem in patch, and added code to call functions to
	clean up after hash and map enumerations.  Modified cleanup function
	to clear enumerator ... for memory release on GC system.
	Rewrote enumeration code so that it maintains the characteristic
	that objects can safely be removed from maps after being enumerated
	(this feature is used in several places).
	*WARNING* This introduces a binary incompatibility in that the size
	of the map table and hash table enumeration types has grown.
	If you have binaries which use the NSEnumerateHashTable() or the
	NSEnumeratemapTable() functions, you need to rebuild them.

2002-05-27  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/GSMime.h: Tidy up and add convenience methods.
	* Source/Additions/GSMime.m: Tidy up and add convenience methods.
	Added methods to convert content between string and data for ease
	of use from java.  Added support for most character sets handled
	by GNUstep-base.  Improved ContentID generation to be both unlikely
	to recur, and to be guaranteed unique within a process.
	* Source/NSBundle.m: ([+allBundles]) Don't enumeraste if map table
	has not been created yet.
	* Source/NSLog.m: Allow output descriptor to be changed.
	* Source/NSProcessInfo.m: Add method to change log output to go to
	another file for applications where stderr has been hijacked.

2002-05-26  Fred Kiefer <FredKiefer@gmx.de>

	* Source/Additions/GSXML.m
	Define GSXMLAttribute in the case when libxml is found. 
	Otherwise it wont compile on MS Windows.

2002-05-26  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/GSMime.h: Add GSMimeHeader class.
	* Source/Additions/GSMime.m: Add GSMimeHeader class.
	Update API to use GSMimeheaders rather than dictionaries.

2002-05-23  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSXML.m: Fix a few errors in last changes.
	* Source/NSString.m: Updates for GSXML changes.
	* Tools/AGSHtml.m: Updates for GSXML changes.
	* Tools/AGSIndex.m: Updates for GSXML changes.

2002-05-22  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/gnustep/base/GSXML.h: Add _parent ivars
	* Source/Additions/GSXML.m: Implement memory mangement so that the
	underlying libxml data is not freed unless all objects derived from
	it have been deallocated.  Remove comments warning about original
	memory management scheme.

2002-05-22  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSeq.h: Fix bug matching sequences with zero length range.
	* Headers/gnustep/base/GSMime.h: Tell autogsdoc where to look for source
	* Headers/gnustep/base/GSXML.h: Updates for consistency etc.
	* Source/Additions/GSXML.m: ditto
	* Tools/AGSHtml.m: Modified for changed GSXML
	* Tools/AGSIndex.m: ditto
	* Tools/AGSParser.m: ditto
	* Tools/autogsdoc.m: ditto
	* Tools/defaults.m: Fixed typo
	Mostly, changes to make methods which were intended to be private
	really private, and lots of modifications to make mathod names
	consistent with OpenStep usage ... suggestions made by many people.
	* configure.ac: Use better names for GMP and ZLIB flags
	* configure: regenerate
	* Headers/gnustep/base/GSConfig.h.in: GMP and ZLIB update
	* Headers/gnustep/base/NSDecimal.h: GMP update
	* Headers/gnustep/base/UnixFileHandle.h: ZLIB update
	* Source/NSDecimal.m: GMP update
	* Source/UnixFileHandle.m: ZLIB update

2002-05-15  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSLog.m: Altered logging format for compatibility with
	MacOS-X (and easier collating).  Thanks to report by lcampbell

2002-05-14  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Unicode.m: GSFromUnicode(), GSToUnicode(), bugfix - ensure
	that returned memory is allocated from specified zone, rather than
	returning internal buffer.
	* Tools/AGSIndex.m: When a string mismatch is found when merging,
	update the output to the new string as well as warning.
	* Tools/autogsdoc.m: Don't automatically include refs to installed
	copies of the project being documented.

2002-05-13  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSFileManager.m: Don't try to release memory using free()
	when it was allocated using NSZoneMalloc().
	* Tools/autogsdoc.m: Improve dependency rule management.
	* Tools/AGSParser.h: ditto
	* Tools/AGSParser.m: ditto
	* Tools/AGSIndex.h: ditto
	* Tools/AGSIndex.m: ditto
	Store all dependency information in the .igsdoc file and keep it up
	to date.  Never regenerate a file that doesn't need it.
	Mostly the changes are to cope with the fact that we now have
	common files into which all functions, constants, variables, and
	typedefs within a project are combined.

2002-05-11  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Unicode.m: Rationalise so that all conversion operations
	go through the two new functions.  Gets rid of a load of old code.
	* Source/GSString.m: ([-replaceCharactersInRange:withString:])
	minor performance enhancement when copying from a 16-bit string
	to an 8-bit string.

2002-05-10  Adam Fedor  <fedor@gnu.org>

	* Source/Additions/GSXML.m: Change libxml strings to UTF8
	(makeText:) New.
	Add GSXMLDummy for MinGW
	* Source/Additions/libgnustep-base.def: Remove GSXMLHandler.
	(patch from Kai Henningsen).

2002-05-10  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/gdnc.m: Make gdnc log to syslog by default, and close
	stdin, stdout, stderr to run as daemon.
	* Source/NSUser.m: Restructured path generation code slightly.
	Added support for system-wide .GNUsteprc with force options.
	Removed use of FORCE_USER_ROOT and FORCE_DEFAULTS_ROOT
	* Source/Base/gsdoc: Document the .GNUsteprc files.
	* Source/NSArray.m: Fix bug with GC pointed out by James Knight

2002-05-09  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSHTTPURLHandle.m: Insert port information to URL passed
	to proxy.

2002-05-09  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSBundle.m
	Use fileSystemRepresentation instead of cString to get the file 
	name to load. 
	
2002-05-08  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSTask.m: When launching under windoze, don't forget to
	use the fileSystemRepresentation of the program name.

2002-05-08  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSXML.m: Fix function prototype ... gets rid of
	compiler warning.
	* Source/GNUmakefile: remove o_vscanf.c ... unused
	* Source/o_vscanf.c: remove unused file.
	* Source/mframe.m: Fix compiler warning about unused function.
	* Source/GSFormat.m: Fix compiler warning about unused var.
	* Source/NSDebug.m: Fix compiler warning about unused var.
	* Source/externs.m: Fix compiler warnings ... move some exceptions
	to source files relating to where they are declared.
	* Source/NSArchiver.m: define exception.
	* Source/NSConnection.m: define exception.
	* Source/NSPort.m: define exception.
	* Tools/gdomap.c: Remove unused variable (log_perror).

2002-05-07  Adam Fedor  <fedor@gnu.org>

	* configure.ac: Make all AC_DEFINES define 1
	* config/objc-con-autoload.m4: Idem.
	* config/objc-sys-dynamic.m4: Idem.

2002-05-07  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUser.m: mingw path fixes and debugging
	* Source/NSFileManager.m: ditto

2002-05-06  Adam Fedor  <fedor@gnu.org>

	* Source/NSMethodSignature.m (-isEqual:): Implemented (from
	znek@mulle-kybernetik.com).

2002-05-06  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSMapTable.m: Delete line teft over by accident ... could
	cause crach if passes nul table.  Thanks to Lars Sonchocky-Helldorf
	* Source/NSCalendarDate.m: ([-initWithString:calendarFormat:]) don't
	supply current date information as default ... for compatibility
	with MacOS-X use zero date instead. Thanks to lcampbell.

2002-05-04  Adam Fedor  <fedor@gnu.org>

        * Testing/nsbundle.m: Update to work without installing bundle.

2002-05-04  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUser.m: NSHomeDirectoryForUser() ... fix windoze bug ...
	was returning the current users home directory irrespective of the
	user asked for.  Now returns nil for other users ... should really
	find some mechanism to determine home directories for other users.
	* Source/Additions/GSXML.m: If ([_parseChunk:]) is called with nil
	data, terminate parsing.  Report by Alexander Malmberg.

2002-05-03  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSAssertion.m: Added comments and fixed bug in handling
	an assertion in a function ... was calling va_end() before the last
	use of the arguments.  Also, release new handler after adding it to
	thread dictionary ... fix memory leak.
	* Source/NSThread.m: Add fprintf of alert message to STDERR if we
	are unable to determine the current thread.  Don't attempt to use
	NSLog() or similar ... since chances are, without a thread object,
	that would just crash.
	In GSRegisterCurrentThread(), add code to handle the case where the
	NSThread class has not been initialised.
	* Source/NSObject.m: NSAllocateObject() raise exception if passed
	something other than a class to allocate an instance of.

2002-05-02  Richard Frith-Macdonald <rfm@gnu.org>

	* SSL/GSUnixSSLHandle.m: Change '#if HAVE...' to '#ifdef HAVE_...'
	* Source/GSFormat.m: ditto
	* Source/GSHTTPURLHandle.m: ditto
	* Source/GSTcpPort.m: ditto
	* Source/NSBundle.m: ditto
	* Source/NSData.m: ditto
	* Source/NSDate.m: ditto
	* Source/NSFileManager.m: ditto
	* Source/NSHost.m: ditto
	* Source/NSLock.m: ditto
	* Source/NSLog.m: ditto
	* Source/NSPage.m: ditto
	* Source/NSPipe.m: ditto
	* Source/NSProcessInfo.m: ditto
	* Source/NSRunLoop.m: ditto
	* Source/NSString.m: ditto
	* Source/NSTask.m: ditto
	* Source/NSThread.m: ditto
	* Source/NSUser.m: ditto
	* Source/UnixFileHandle.m: ditto
	* Source/WindowsFileHandle.m: ditto
	* Tools/gsdoc.m: ditto
	* Tools/autogsdoc.m: ditto
	Fixes to handle configuration changes where AC_DEFINE is setting
	preprocessor constants to be empty (but defined) rather than to be 1

2002-05-02  Adam Fedor  <fedor@gnu.org>

	* configure.ac: Updated to autoconf 2.53 from configure.in
	* configure, config.h.in: Regenerate.
	* Source/mframe/configure.ac: Idem.
	* SSL/configure.ac: Idem.
	* acconfig.h, aclocal.m4: Remove
	* config/pathxml.m4: New from aclocal.m4.
	* config/objc-con-autoload.m4: Updated from aclocal.m4
	* config/procfs-exe-link.m4: Idem.
	* config/procfs.m4: Idem.

2002-05-02  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSURLHandle.m: Implement ([-hash]) and ([-isEqual:]) based on
	([-absoluteString]) rather than simple pointer comparison.
	* Source/GSHTTPURLHandle.m: ([-bgdConnect]) check for existing
	headers before writing ... avoid overriding them and only set things
	that the programmer has not bothered to set.
	([-loadInBackGround]) use URL port if available.
	More fixes thanks to lcampbel via savannah
	* Headers/Foundation/NSURLHanlde.h: include NSObject.h
	* Source/UnixFileHadle.h: add missing semicolon thanks to Paul Windey

2002-05-01  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSURLHandle.m: ([URLHandleClassForURL:]) Fix to return most
	recently registered class rather than first registered one.
	Bug report via savannah

2002-04-30  Adam Fedor  <fedor@gnu.org>

	* Version: 1.3.2
	* Documentation/news.texi: Update.
	* NEWS Regen.

2002-04-29  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSFileManager.m: Standardise handling for windoze drive
	specifiers in file paths.
	* Source/NSUser.m: Use ([-stringWithFileSystemRepresentation:length:])
	when importing file names.
	* Source/NSString.m: Update all path handling methods for windoze 
	changes.  Fix several bugs where we did not conform to documentation.

2002-04-28  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSFileManager.m: Port
	([-stringWithFileSystemRepresentation:length:]) to windoze...
	Have it convert backslashes to slashes etc.

2002-04-25  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/AGSParser.m: Improve handling of identifier mapping so that
	an identifier mapped to an empty string (or //) an any place where
	whitespace is permissable is treated as part of that white space.

2002-04-25  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/AGSParser.m: Interpret a mapping to '//' in the WordMap as
	meaning that the rest of the line containing the mapped value
	should be ignored.

2002-04-24  Gregory John Casamento <greg_casamento@yahoo.com>

	* Tools/make_strings/GNUmakefile - modified to prevent build
	error when building from scratch
	* Tools/make_strings/GNUmakefile.preamble - added to provide
	paths to include and lib directories for linking make_strings
	tool when building from scratch.
	
2002-04-23  Adam Fedor  <fedor@gnu.org>

	* Source/GSFFIInvocation.m
	(-initWithCallback:returnp:values:frame:signature:): Simplify
	setting values. Structs passed by ref when MFRAME_STRUCT_BYREF.
	(GSFFIInvokeWithTargetAndImp): Encoding values unneedded now.
	(gs_objc_msg_forward): Free the closure via NSData.

	* Source/mframe/powerpc/generic: Fix offset for structs.
	* Source/mframe/powerpc/linux-gnu: Idem.
	* Source/mframe/powerpc/darwin: Idem.
	
2002-04-22  Adam Fedor  <fedor@gnu.org>

	* Tools/gdomap.c (gdomap_log): For LOG_INFO, write to 1, not 0.

	* Tools/make_strings: New tool from Alexander Malmberg
	<alexander@malmberg.org>

	* Source/Additional/Makefile.preamble (ADDITIONAL_OBJCFLAGS):
	Add for building DLL on mingw32

2002-04-20  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSURL.m: ([-absoluteString]) anonymous bugfix applied.

2002-04-19  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/gdnc.m: If given -NSHost specification for the current host,
	ignore it and use the standard name.
	* Source/GSTcpPort.m: ([-invalidate]) call superclass implementation
	at end ... so handles can find this port when they are destroying
	themselves.  Reverses last change I made to this.

2002-04-18  Richard Frith-Macdonald <rfm@gnu.org>

	* SSL/COPYING.LIB: New file ... just to make it *REALLY* obvious
	this code is under the LGPL

2002-04-18  Adam Fedor  <fedor@gnu.org>

	* Minimally working libffi support. Needs work.
	* configure.in: Allow libffi to be enabled.
	* Source/GSFFIInvocation.m: Rewrite.
	* Source/NSConnection.m (-forwardInvocation:forProxy:): Add libffi
	function.
	* Source/NSInvocation.m: Fixup cifframe arg functions.
	* Source/cifframe.m: Rewrite.
	* Testing/nsinvocation.m: Bug fix.

	* Documentation/coding-standards.texi: Remove info dir tag.
	* Documentation/gnustep-base.texi: Idem.
	* Resources/Languages/Slovak: New file (from Stefan Urbanek).

Thu Apr 18 11:10:04 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Headers/gnustep/base/NSObjCRuntime.h: Updated #defines and
	Windows DLL export/import machinery to the new gnustep-make
	conventions.

2002-04-18  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/gdomap.c: re-order headers so config.h is used on windoze
	* Source/NSFileManager.m: ([-fileSystemRepresentationWithPath:])
	modified to handle MSYS paths with '/drive/' prefix.
	* Source/GSTcpPort.m: ([-invalidate]) call superclass implementation
	at start, so flag gets set to say we are not valid, and we avoid any
	recursive calls.

2002-04-16  Richard Frith-Macdonald <rfm@gnu.org>

	* config/config.reuseaddr.c: New test for broken SO_REUSEADDR
	* configure.in: test for broken SO_REUSEADDR
	* acconfig.h: Add BROKEN_SO_REUSEADDR
	* configure: regenerated
	* Source/UnixFileHandle.m: Use reuseaddr info.
	* Source/GSTcpPort.m: Use reuseaddr info.
	* Tools/gdomap.c: Use reuseaddr info.
	* Source/NSPortNameServer.m: Improved warnings about launching
	gdomap.
	* Source/NSDistributedNotification.m: Improved warnings about
	launching gdnc.
	* Source/NSException.m: Log uncaught exceptions with executable name.
	* Source/NSProcessInfo.m: New private function for exception msg.
	* Source/GSString.m: Applied fix by Malexander Malmberg for
	transmuting strings where the default encoding is not the same as
	the internal 8-bit encoding.
	* Source/Unicode.m: Logic fix for selecting strict conversion from
	unicode by Alexander Malmberg.

2002-04-12  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSXML.m: New method ([-nextElement]) to traverse
	tree skipping non-element nodes.  Also ([-childElement]) to get the
	first child element of a node.

Thu Apr 11 15:34:33 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/GSAttributedString.m ([GSMutableAttributedString
	-sanity]): Renamed to -_sanity, and changed so that we always
	compile this in so that regression testcases can use it.

2002-04-08  Richard Frith-Macdonald <rfm@gnu.org>

	* Resources/GNUmakefile: install new language files.
	* Resources/Languages/Russion: language file added.
	* Resources/Languages/UkraineRussion: language file added.
	Added language files provided by Serg Stoyan <stoyan@on.com.ua>
	* Source/UnixFileHandle.m: Permit accept/connect on descriptors
	by default.
	* Source/WindowsFileHandle.m: ditto
	* Headers/Foundation/NSProcessInfo.h: Added MacOS-X operating system
	methods and enum
	* Source/NSProcessInfo.m: Added operating system methods and documented
	all methods for autogsdoc.

2002-04-07  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSString.m: Tidy initialisers for case where the default
	C-string encoding is not usable internally.
	* Source/NSLog.m: Try default cString encoding.
	* Tools/cvtenc.m: Add -EscapeIn and -EscapeOut flags to handle \u
	escapes in files.
	* Resources/Languages/Italian: Correct to use \u escapes
	* Resources/Languages/French: ditto.
	* Resources/Languages/German: ditto.
	* Resources/Languages/README: New file to tell editors that they
	should use \u escapes ... and suggesting use of the cvtenc tool
	to make the job easy.

2002-04-06  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSString.m: Fix error in unicode BOM handling
	Write plist unicode escapes using the conventional \u rather than \U,
	but read in either form.
	* Source/GSString.m: Fix error in length of unicode data produced.
	* Tools/cvtenc.m: Made easy to use and added instructions.

Sat Apr  6 02:42:43 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/NSUser.m (NSSearchPathForDirectoriesInDomains): Fixed
	typo, gnustep_local_root being used instead of gnustep_user_root
	for developer dirs in user root.
	
2002-04-05  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSObject.m: Fix locking bug with NSZombie ... was not
	locking when adding/removing zombies.
	* Source/NSString.m: Fix property list parsing code to raise
	exceptions on failure rather than logging messages.  Also check for
	extra data at end of parsed string.
	* Tools/ctvenc.m: new tool for converting string encodings.

2002-03-28  Manuel Guesdon <mguesdon@orange-concept.com>

	* Tools/gsdoc.m: corrected inversed test for missing entities
	
2002-03-27  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSPrivate.h: Added function to fetch boolean value from env
	* Source/NSException.m: Use new function.
	* Source/NSProcesInfo.m: Implement new function.
	* Source/NSObject.m: Implement NSZombie functionality.
	* Headers/Foundation/NSDebug.h: Document NSZombie functionality.

2002-03-25  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSTask.m: Implement code to watch for child process exit
	under mingw and rewrite various methods to handle process
	termination nicely under windoze.
	* Source/NSException.m: flush stderr ... under windoze stderr is
	not automatically flushed!
	* Source/GSWindowsFileHandle.m: watch for exceptional conditions
	so we can handle socket connection failures in mingw32.
	Added code to try to cope with standard files properly, not just
	network sockets.
	* Source/GSTcpPort.m: ditto.
	* Source/Unicode.m: GSToUnicode(), GSFromUnicode(), if terminate
	option is specified, always produce output with a nul terminator
	even for input of an empty string.

2002-03-22  Richard Frith-Macdonald <rfm@gnu.org>

	* SSL/GNUmakefile: Remove -lobjc and -lgnustep-base from bundle
	libraries ... it should not need them.

2002-03-21  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSArray.m: Ensure property-list read/write uses UTF8
	* Source/NSDictionary.m: ditto
	* Source/NSConnection.m: Change timeouts to 300 seconds and
	document all methods.

2002-03-20  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSString.m: lossyCString_u() handle case where cString
	contains more bytes than unicode string has characters.
	* Tools/gdomap.c: Suppress unnecessary warnings except under debug.
	Implement spawning to run as daemon under windoze.
	* Toolds/gdnc.m: Run as daemon under windoze.
	* Source/GSTcpPort.m: Fix to stop multiple servers trying to use
	the same port under windoze.
	* Source/WindowsFileHandle.m: Fix to stop multiple servers trying to use
	the same port under windoze.  Fix to return gdomap port even if
	getservbyname() doesn't.
	* Source/UnixFileHandle.m: Fix to return gdomap port even if
	getservbyname() doesn't.
	* Source/NSTask.m: Try appending .exe extension to paths under windoze.
	* Source/Unicode.m: GSFromUnicode() fix lossy conversion  for cases
	where output encoding can't handle the unicode.

2002-03-19  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSString.m: lossyCString_c() fix in line with recent
	changes ... cope with case where internal coding is not same as
	external coding.
	lossyCString_u() fix encoding used.

2002-03-18  Adam Fedor  <fedor@gnu.org>

	* Tools/gdomap.c (gdomap_log): Write to stdout if prio=LOG_INFO.

2002-03-18  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Unicode.m: Some boundary error fixes by Alexander Malmberg.
	Fixes to encoding table initialisation.
	* Source/NSString.m:Fix error in encoding type for initialising from
	data.  By Alexander Malmberg.
	* Source/GSString.m: Correct string length when transmuting an 8-bit
	string to a 16-bit string - by Alexander Malmberg.

2002-03-17  Pierre-Yves Rivaille <pyrivail@ens-lyon.fr>

	* Source/GSAttributedString.m 
	([GSMutableAttributedString -replaceCharactersInRange:withString:]): 
	Only keep attribute #0 when removing it would remove all attributes.
	(patch by Alexander Malmberg)

2002-03-16  Adam Fedor  <fedor@gnu.org>

	* configure.in: Also configure SSL.

2002-03-16  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/gnustep/base/Unicode.h: Add more options for character
	encoding conversion routines.
	* Source/GSPrivate.h: Add a couple of private functions for character
	encoding management.
	* Source/GSString.m: Convert throughoput to use new functions for
	converting from one string encoding to another.  Make changes to
	handle setting of default C string encoding to be an encoding which
	is incompatible with internal e-bit string objects.
	* Source/NSString.m: ditto
	* Source/Unicode.m: new string encoding conversion functions extended
	with a few new options.  Also fixed some memory allocation bugs to
	cure memory leaks.

	Rewritten low level support for different character encodings ...
	should provide more efficient and maintainable conversion between
	encodings and permit use of wide character encodings and encodings
	with multibyte sequences as the default C string encoding.
	Testing ... minimal ... we could do with decent tests for this stuff.
	So this version must be viewed as possibly very unstable!

2002-03-14  Adam Fedor  <fedor@gnu.org>

	* Version: 1.3.0
	* Documentation/install.texi, readme.texi, ...: Updated

2002-03-14  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSString.m; Bug report by Manuel Guesdon prompted me to
	rewrite string trimming extensions.  All the tail end trimming
	was wrong.
	* Source/Unicode.m: Added two new conversion functions ... untested.
	The intention is to replace other string conversion with these ones
	which should localise memory management issues.

2002-03-14  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/gdomap.c: Tidy a little ... fix non-static declarations.
	* Source/NSString.m: ([-initWithData:encoding:]) Correct the length
	of the string produced when unicode data is missing its 2 byte
	prefix. Simplification of code based on suggestion by Yen-Ju Chen
	* Source/GSString.m: Fixes for cString infor from unicode by
	Yen-Ju Chen.

Wed Mar 13 16:55:49 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/Additions/GSXML.m ([GSSAXHandler
	-externalSubset:externalID:ystemID:]): Fixed typo, 'ystemID:'
	instead of 'systemID:'.

2002-03-13  Adam Fedor  <fedor@gnu.org>

	* Tools/gdomap.c (log): Redefine to gdomap_log to avoid conflict
	with syslog function on Darwin.

	* Source/NSProcessInfo.m (main): Use STRINGIFY to get proper
	name of constant string class.

2002-03-13  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/gnustep/base/NSObjCRuntime.h: Remove bad markup in comments.
	* Headers/gnustep/base/NSString.h: Remove private class declaration
	and hide internals of NXConstantString behind dummy interface while
	improving comments.  Fix long overdue declaraction of methods in
	clsses rather than protocols.
	* Source/GSUserDefaults.h: removed
	* Source/GSPrivate.h: added
	* Source/GSCompatibility.m: fix for hidden private info.
	* Source/GSString.m: ditto
	* Source/NSArray.m: ditto
	* Source/NSCalendarDate.m: ditto
	* Source/NSDate.m: ditto
	* Source/NSDecimalNumber.m: ditto
	* Source/NSDictionary.m: ditto
	* Source/NSLog.m: ditto
	* Source/NSObjCRuntime.m: ditto
	* Source/NSScanner.m: ditto
	* Source/NSSerializer.m: ditto
	* Source/NSString.m: ditto
	* Source/NSUser.m: ditto
	* Source/NSUserDefaults.m: ditto
	General tidyups to hide some internal workings which should really
	not be exposed in public headers.

2002-03-12  Richard Frith-Macdonald <rfm@gnu.org>

	* NSTimeZones/NSTimeZones.tar: regenerated with latest data.

2002-03-12  Adam Fedor  <fedor@gnu.org>

	* Headers/gnustep/base/NSString.h: Add extra ivars needed by Darwin
	to NXConstantString.
	* Source/GSString.m: ([NXConstantString +initialize]): Remove constant
	string class reference setup for Darwin.
	* Source/NSProcessInfo.m (main): Put it here.
	
Tue Mar 12 11:13:51 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/Additions/GSXML.m ([-isEqualTo:]): Renamed everywhere to
	isEqual:

Tue Mar 12 09:21:20 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/NSAssertionHandler.m
	([-handleFailureInMethod:object:file:lineNumber:description:]): Log
	if the object is a class or an instance.

2002-03-12  Richard Frith-Macdonald <rfm@gnu.org>

	* SSL/configure.in: Check GNUstep directories for headers and
	libraries as well as standard system directories.

Tue Mar 12 07:37:44 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/Additions/GSXML.m ([GSXMLNode -properties]): Fixed return
	type.

2002-03-10  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/gnustep/base/NSInvocation.h:
	* Headers/gnustep/base/NSNumberFormatter.h:
	* Headers/gnustep/base/NSObject.h:
	Minor fixes to build with STRICT_OPENSTEP
	* Source/NSDistributedNotificationCentre.m: Attempt to start server
	automatically for other machines.  Improve log messages.

Sat Mar  9 15:21:04 2002  Adam Fedor  <fedor@yogi.doc.com>

	* Source/NSDistributedNotificationCenter.m (-_connect): Move check
	for alternative name so we can get registered.
 	
2002-03-09  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSDistributedNotificationCentre.m: Try alternative name for
	server if NSHost is specified ...in case it is running on another host.

Sat Mar  9 12:02:45 2002  Adam Fedor  <fedor@yogi.doc.com>

	* configure.in: Change constant string to FooConstantString
	* config/config.constant-string-class.m: Work with NeXT_RUNTIME
	(patch from Markus Hitter [mah@jump-ing.de]).

2002-03-09  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSFileManager.m: Change copy so that, if the source argument
	is a symbolic link, we copy the link rather than the thing it points
	to.
	* Tools/gdnc.m: Quick hack to register port with other names is NSHost
	is used.

2002-03-08  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Unicode.m: Added BIG5 encoding
	* Headers/Foundation/NSString.h: Added BIG5 encoding
	* Resources/Languages/Locale.aliases: added traditional chinese
	Extensions for traditional chinese requested by Yen-Ju Chen

2002-03-08  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GNUmakefile: Include ../../base.make
	* SSL/GNUmakefile: Include ../base.make
	from the makefiles directory for builting standalone.
	* Source/Unicode.m: Added some standard string handling for iconv.
	* Source/NSString.m: ([-initWithData:encoding:]) return nil on
	failure to handle encoding.
	* Source/NSMapTable.m: NSMapInsert() fixed to conform to spec.
	* Source/NSHashTable.m: NSHashInsert() fixed to conform to spec.
	Reports by Alexander Malmberg

2002-03-07  Pierre-Yves Rivaille <pyrivail@ens-lyon.fr>

	* Source/NSRunLoop.m ([NSRunLoop -acceptInputForMode:]): 
	added a _checkPerformes: call to solve minor issue.
	(performers would only be called after an event was received)
	(credits to Alexander Malmberg)

2002-03-07  Richard Frith-Macdonald <rfm@gnu.org>

	* SSL/Makefile.posramble: store config.h in system specific subdir.
	* SSL/Makefile.preamble: Include headers from Source directory
	so we pick up GSConfig.h

2002-03-06  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/autogsdoc.m: store and fetch dependency info in .igsdoc
	so we can parse the correct source files for each header when we
	need to.

2002-03-06  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GNUmakefile: build subproject.
	* Source/Additions/Makefile.preamble: set include flags.
	* Source/Additions/GSXML.m: moved implementation here.
	* Source/Additions/GSMime.m: moved implementation here.
	* Source/GNUmakefile: build subproject.

2002-03-06  Richard Frith-Macdonald <rfm@gnu.org>

	* GNUmakefile: build SSL aggregate project
	* config.mak.in: Remove SSL info
	* configure.in: Remove SSL configuration
	* configure: Regenerate
	* SSL/GNUmakefile: Build SSL bundle
	* SSL/GSUnixSSLHandle.m: SSL bundle source from Source directory
	* SSL/Makefile.postamble: Build SSL bundle
	* SSL/Makefile.preamble: Build SSL bundle
	* SSL/config.h.in: Trivial config for SSL bundle
	* SSL/config.mak.in: SSL info for building bundle.
	* SSL/configure.in: Configuration for SSKL bundle.
	* Source/GNUmakefile: Don't build SSL bundle.
	* Source/GSUnixSSLHandle.m: Moved to SSL directory.
	* Source/Makefile.postamble: Don't build SSL bundle.
	* Source/Makefile.preamble: Don't build SSL bundle.
	Alterations to make the SSL bundle capable of standalone
	building - for use on systems where the base package has
	only been installed in binary form.
	Initial attempt!

2002-03-06  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSAttributedString.m: Applied fix for left-over attributes
	at end of string.  Patch supplied by Alexander Malmberg
	<alexander@malmberg.org>.  Reformatting to conform to GNUstep
	standards, and optimisation by me.

2002-03-04  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/autogsdoc.m: Output gsdoc as UTF8 as we should.
	* Tools/AGSOutput.m: ditto.

2002-03-01  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUser.m: When reading .GNUsteprc, if a per user version is
	not available, use the one in the configured system root directory.

2002-02-28  Adam Fedor  <fedor@gnu.org>

	* Headers/gnustep/base/objc-gnu2next.h: Add objc-runtime.h
	* Source/Makefile.preamble: Add ..DEPEND_UPON for all darwin versions.

	* Source/NSPortCoder.m
	(-initWithReceivePort:sendPort:components:): Change cast to make
	MacOSX compiler happy.

2002-02-28  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUser.m: rewrite user and defaults root code to standardise
	and to use .GNUsteprc configuration.  Also permit forcing of fixed
	roots at compile time.

Thu Feb 28 16:46:31 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/NSUser.m (NSSearchPathForDirectoriesInDomains): Changed
	'Apps' to read 'Applications'.

2002-02-27  Pierre-Yves Rivaille <pyrivail@ens-lyon.fr>

	* Source/GSString.m ([GSMutableString -substringWithRange:]): 
	create a new string which size is the range length, not the original
	string's length.

2002-02-27  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/gdomap.c: Removed obsolete code for shrinking data structures.
	Added memmove() for overlapped memory moves (Alexander Malmberg) and
	removed a couple of obsolete functions.
	* Source/GSValue.m: attempt to correct encoding.
	* Source/NSKeyValueCoding.m: Fix termination of method names with nuls
	from report by Manuel Guesdon.
	* Source/NSDictionary.m: Implement MacOS-X compatible KVC behavior.
	Include webobjects/eof extension, with warnings.
	* Headers/Foundation/NSProtocolChecker.h: Change deprecated import to
	include.

2002-02-26  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/gdomap.c: Improve fetching interface info on mingw ...
	ignore non-internet interfaces.
	NB. The mingw winsock2.h header is buggy ... to work properly
	you need to change the size of a struct sockaddr field from
	sa_data[14] to sa_data[22]

Tue Feb 26 18:01:26 2002  Nicola Pero  <nicola@brainstorm.co.uk>

	* Source/NSBundle.m: Removed all _releasedBundles machinery.
	Removed custom implementation of -release.  Retain a bundle after
	we load it.  This fixes -bundleForClass: and simplifies
	considerably the code.

	* Source/NSBundle.m: Whenever possible, use [self method] rather
	than [NSBundle method] to invoke a class method, for efficiency.

	* Source/NSBundle.m (objc_executable_location): Compute directly
	from _executable_path - using mainBundle is unsafe.
	
Tue Feb 26 17:35:03 2002  Nicola Pero  <nicola@brainstorm.co.uk>

	* Source/NSBundle.m (_bundle_load_callback): Completely ignore
	categories.  (Suggestion by Gerrit Van Dyk
	<GerritVD@decillion.net>).

2002-02-26  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSTemplateValue.m: Implement initialize method to set the
	version of concrete classes to be that of the abstract class which
	actually performs encoding/decoding ... should correct archiving.
	Problem reported by Gerrit Van Dyk
	* Tools/GSIndex.m: tidied a little
	* Tools/GSParser.m: mark when things are implemented.
	* Tools/GSOutput.m: warn about unimplemented items.

2002-02-26  Pierre-Yves Rivaille <pyrivail@ens-lyon.fr>

	* Source/NSUnarchiver.m 
	([NSUnarchiver +classNameDecodedForArchiveClassName:]): 
	([NSUnarchiver -classNameDecodedForArchiveClassName:]): 
	return nil if the class name is not present.

2002-02-26  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSTcpPort.m: Fixes to work on mingw.
	* Source/NSHost.m: Update for current winsock on mingw.
	* Source/NSPortNameServer.m: Update for current winsock on mingw.
	* Source/WindowsFileHandle.m: Fix to work for basic socket I/O.
	* Tools/gdomap.c: many changes ... several fixes to work on mingw
	rewrite some clumsy inefficient code, make variables and functions
	local. etc.
	* Source/NSUnarchiver.m: ([versionForClassName:]) return NSNotFound
	if the class name was not present.

Mon Feb 25 15:26:38 2002  Nicola Pero  <nicola@brainstorm.co.uk>

	* Source/NSBundle.m ([-initWithPath:]): Return nil if the path
	can't be read.  Fixed memory leak in case of nil argument.
	* Headers/gnustep/base/NSBundle.h: Documented some methods.
	
2002-02-25  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GNUmakefile: Move xml and mime classes into an additional
	library, and make base library depend on it.  EXPERIMENTAL.
	* Tools/gdomap.c: Try to get output working again after last changes.
	Add first attempt at MINGW support for getting network interface info.
	library, and make base library depend on it.
	EXPERIMENTAL - activate using 'make add=yes'

2002-02-25  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSObject.m: Rewrote key-value coding key manipulation to use
	a char array for speed.  Moved functions for converting between object
	internals in scalar types and NSNumbers etc to NSObjCRuntime.m.
	Re-implemented path methods to fix incorrect implementation as pointed
	out by Manuel Guesdon.
	* Headers/Foundation/NSObjCRuntime.h: New functions from NSObject
	* Source/NSObjCRuntime.m: New functions from NSObject
	* Source/NSKeyValueCoding.m: Put key value coding methods here for
	clarity and ease of documentation.

2002-02-24  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSTask.m: Removed NSLogs() accidantally left in after
	debugging. Reported by Fred Kiefer.
	* Tools/gdomap.c: Use syslog for logging ... patch by Matthias Klose
	<doko@cs.tu-berlin.de> almost entirely rewritten to be portable.
	* configure.in: Minor additions for time header/functions
	* configure: regenerated

2002-02-23  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSObjCRuntime.h: Fix error in last change ...
	GSSelectorFromName() should not create a new selector while
	HSSelectorFromNameAndTypes() should.

2002-02-22  Alexander Malmberg <alexander@malmberg.org>

	* Headers/gnustep/base/NSArray.h: insertion position api update.
	* Source/NSArray.m: insertion position api update.
	* Source/GSArray.m: insertion position api update.
	Make insertion position api consistent with sorting api.

2002-02-21  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSValue.m: Fixed bug in archiving NSValue objects ... was
	creating faulty archives which would crash on unarchiving.
	* Headers/Foundation/NSObjCRuntime.h: Made GS... function names more
	consistent with NeXT/Apple ones.  Provide new ivar handling API.
	Don't crash when asked for a class which does not exist.
	* Source/NSObject.m: partial conversion to new runtime api.
	* Source/NSData.m: partial conversion to new runtime api.  Don't
	raise an exception if a class we are deserializing does not exist.
	Just warn and return a nul class.
	* Source/NSArchiver.m: better clasname handling. 
	* Source/NSUnarchiver.m: try to gracefully handle the case where an
	archive contains the name of a class we don't have linked in to our
	code.
	* Source/NSPortCoder.m: ditto.

2002-02-20  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUser.m: locking erro fixed by Stephen brandon

2002-02-20  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSInvocation.h: Remove _argframe ivar
	* Source/NSInvocation.m: Simplify by removing _argframe ivar and
	using _frame throughout to hold arguments. Fix checks for valid frame.
	* Source/callframe.m: Initialise newly created frame with zeros so
	that setting an object in an invocation should work when the
	invocation is retaining its contents.
	* configure.in: Disable ffi and warn about it.
	* configure: regenerated
	* Source/NSRunLoop.m: ([acceptInputForMode:beforeDate:]) block until
	limit date even if no I/O is possible.
	* Source/NSUserDefaults.m: Patch by Alexander Malmberg to try all
	listed locales rather than giving up at first failure.
	* Headers/gnustep/base/GSUnion.h: Enclose types bitmask in brackets
	to avoid *all* types being included in the union!  Should decrease
	memory footprint and increase speed of many classes.
	* Source/NSString.m: ([stringByStandardizingPath]) memory leak
	fixed and windows path check fixed ... patch by Michael Scheibler.
	Also commented/documented the method.

2002-02-13  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUserDefaults.m: Removed some code that was doing nothing,
	and tidied a little.

2002-02-13  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSPathUtilities.h: GSDefaultsRootForUser()
	function added.
	* Source/NSUser.m: Many alterations to do with correcting the
	file paths used to use GNUSTEP_USER_ROOT, and to get them to
	vary nicely when GSSetUserName() is called.  Added function
	GSDefaultsRootForUser() to get a defaults directory based on
	a new environment varibale, or use GNUSTEP_USER_ROOT.
	* Source/NSUserDefaults.m: Use GSDefaultsRootForUser()
	Fix a few bugs in setting up defaults database.
	Move defaults database to the Defaults subdirectory.
	* Source/Headers/GSIMap.h: Fix error in last commit.

2002-02-13  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSString.m: ([stringByExpandingTildeInPath]) fix bug in
	handling ~username/... format.
	* Headers/Foundation/GSIMap.h: GSIMapCleanMap() rewrote to empty
	the map efficiently.  Added an option to refrain from calling it
	when emptying a map that doesn't need keys and values releasing.
	* Source/GSAttributedString.m: don't clean maps on emptying.
	* Source/GSFFCallInvocation.m: ditto
	* Source/NSArchiver.m: ditto
	* Source/NSConnection.m: ditto
	* Source/NSObject.m: ditto
	* Source/NSPortCoder.m: ditto
	* Source/NSSerializer.m: ditto
	Changes inspired by Pierre-Tves Rivaille

2002-02-12  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/AGSHtml.m: support for merging types and functions etc.
	* Tools/AGSIndex.m: ditto
	* Tools/AGSOutput.h: ditto
	* Tools/AGSOutput.m: ditto
	* Tools/autogsdoc.m: ditto
	Put stuff in place for merging info
	revert key-value coding changes.
	* Source/NSString.m: Fix bug in datausingEncoding:allowLossyConversion:
	pointed out by Stephen Brandon.

Mon Feb 11 15:11:31 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/GSString.m (NSImmutableString): Implemented copy,
	copyWithZone:, mutableCopy, mutableCopyWithZone:, so that the
	string can be copied, and the copy no longer tracks the parent.

2002-02-10  Michael Hanni <mhanni@sprintmail.com>

        * Source/NSObjCRuntime.m: changed NSAssert() to NSCAssert() from
        last change. Also added NSException.h include to make compile
        correctly and quietly.

2002-02-10  Manuel Guesdon <mguesdon@orange-concept.com>

	* Source/NSObject.m: changes to enable derived object KeyValueCoding 
		process chnages (EOGenericRecord for example).
               o added:
                _infoForInstanceVariableNamed:retType:retSize:retOffset:
                _getValueForKey:selector:type:size:offset:
                _setValueForKey:object:selector:type:size:offset:
                _handleQueryWithUnboundKey:
                _handleTakeValue:forUnboundKey:
               o modified:
                storedValueForKey:
                takeStoredValue:forKey:
                valueForKey:
                takeValue:forKey:
                To use added method.
        * Source/NSObjCRuntime.m:
               o added NSAssert in GSGetInstanceVariable() and 
                 GSSetInstanceVariable()
	* Headers/gnustep/base/NSKeyValueCoding: 
               o added:
                _infoForInstanceVariableNamed:retType:retSize:retOffset:
                _getValueForKey:selector:type:size:offset:
                _setValueForKey:object:selector:type:size:offset:
                _handleQueryWithUnboundKey:
                _handleTakeValue:forUnboundKey:

Sat Feb  9 01:45:48 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/NSBundle.m ([+bundleForTool:]): Removed.  We switch to a
	better API, which is to have a tool use +mainBundle, in the same
	way as applications do, to retrieve the main resource bundle for
	itself.
	([+mainBundle]): Modified to support tools as well as
	applications.
	* Headers/gnustep/base/NSBundle.h ([+bundleForTool:]): Removed.
	
2002-02-08  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSTask.h: New method -validatedLaunchPath to
	check that an executable exists at the specified path or any
	alternative version corresponding to host, OS, and library-combo
	directories.  Returns the actual path to the binary.
	* Source/NSTask.m: Implemented new mathod and added autogsdoc
	comments.
	* Source/NSBundle.m: Cotrrected error in comments.

2002-02-06  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSString.m: Additioanl method -immutableProxy
	* Source/NSString.m: ditto
	* Source/GSString.m: New classes for immutable proxy, one generic
	version, and one efficient version for accessing the main GNUstep
	mutable striong objects.
	* Source/GSAttributedString: use immutable proxy.
	New code to provide a proxy for a mutable string which will provide
	read-only access to it.

2002-02-05  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSString.m: ([-rangeOfCharacterFromSet:options:range:])
	fix to return NSNotFound as location if character not present -
	bug reported by Nicola Pero.

2002-02-04  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/gsdoc.m: loader() if entity id is missing, try to load url as
	a file.
	* Tools/AGSParser.m: Fixes for handling typedefs, constants, varibales
	and functions.
	* Tools/AGSOutput.[hm]: ditto
	* Tools/AGSHtml.m: ditto
	Preliminary support for C language added.

2002-02-03  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GNUmakefile: use -WordMap flag with autogsdoc to cope with
	C-preprocessor constants that would otherwise confuse parsing.
	* Source/NSDictionary.m: Tidy to match interface.
	* Source/NSDistantObject.m: Tidy to match interface.
	* Source/NSPortCoder.m: Tidy to match interface.
	* Source/NSScanner.m: Tidy to match interface.  Remove some illegal
	semicolons after method names.
	* Source/NSTimer.m: Tidy to match interface.
	* Tools/AGSParser.h: Handle word mappings.
	* Tools/AGSParser.m: Handle word mappings and deal with function
	attributes.
	* Tools/autogsdoc.m: Handle word mappings and make default logging
	less verbose.

2002-02-02  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSObject.m: Fix some maptable problems when using non-local
	reference counts.
	* Source/NSMapTable.m: Improve warning logging for dodgy practices.
	* Source/NSHashTable.m: ditto
	* Tools/AGSHtml.m: A couple of minor fixes for systems where the xml
	parser does not discard whitespace as it should.

2002-02-01  Richard Frith-Macdonald <rfm@gnu.org>

	* Documentation/manual: New directory containing Objective-C and
	GNUstep-base programming manual/tutorial produced at Brainstorm.
	The intention was to produce a pretty complete manual and then
	release it, but we ran out of funding, so I'm releasing the work
	to date.
	* Source/NSObject.m: Go back to using local refcounts now that new
	map table code is thoroughly tested.

2002-02-01  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Makefile.preamble: remove old GSI api support
	* Headers/Foundation/NSHashTable.h: ditto
	* Headers/Foundation/NSMapTable.h: ditto

2002-02-01  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSAttributedString.m: Move to assuming new GSI api.
	* Source/NSHashTable.m: ditto
	* Source/NSMapTable.m: ditto
	* Source/GSCountedSet.m: ditto
	* Source/GSDictionary.m: ditto
	* Source/GSFFCallInvocation.m: ditto
	* Source/NSArchiver.m: ditto
	* Source/NSConnection.m: ditto
	* Source/NSFileManager.m: ditto
	* Source/NSNotificationCenter.m: ditto
	* Source/NSObject.m: ditto
	* Source/NSPortCoder.m: ditto
	* Source/NSRunLoop.m: ditto
	* Source/NSSerializer.m: ditto
	* Source/NSUnarchiver.m: ditto

2002-02-01  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSHashTable.m: Fixed bug intorduced by last change to add
	error checking!!
	* Source/GSAttributedString.m: Make new or old GSI stuff optional.
	* Source/GSCountedSet.m: ditto
	* Source/GSDictionary.m: ditto
	* Source/GSFFCallInvocation.m: ditto
	* Source/NSArchiver.m: ditto
	* Source/NSConnection.m: ditto
	* Source/NSFileManager.m: ditto
	* Source/NSNotificationCenter.m: ditto
	* Source/NSObject.m: ditto
	* Source/NSPortCoder.m: ditto
	* Source/NSRunLoop.m: ditto
	* Source/NSSerializer.m: ditto
	* Source/NSUnarchiver.m: ditto
	Interim phase ... version of source which should build with new or
	old GSIMap and GSIArray APIs at the defination of GSI_NEW

2002-01-31  Adam Fedor  <fedor@gnu.org>

	* Old/*: Removed (now at
	ftp://ftp.gnustep.org/pub/gnustep/old/gnustep-obsolete.tar.gz).

2002-01-31  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSMapTable.m:
	* Source/NSHashTable.m: Add checks for nul tables and either log
	warnings and be tolerant, or raise exceptions.

Thu Jan 31 15:35:21 2002  Nicola Pero  <nicola@brainstorm.co.uk>

	* Source/NSObject.m ([-doesNotRecognizeSelector:]): Modified
	exception message to print out if we are an instance or a class
	object.  For example, no longer 'IvarProxy does not recognize
	initWithClass:' but rather 'IvarProxy(class) does not recognize
	initWithClass:'.
	([-doesNotRecognize:]): Idem.
	([-subclassResponsibility:]): Similar change.
	([-shouldNotImplement:]): Similar change.
	([-notImplemented:]): Similar change.

2002-01-31  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/gnustep/base/GSIArray.h: Use array as parameter to macros.
	* Source/GSAttributedString.m: Update for GSIArray change.
	* Source/GSCountedSet.m: Update for GSIArray change.
	* Source/GSDictionary.m: Update for GSIArray change.
	* Source/GSFFCallInvocation.m: Update for GSIArray change.
	* Source/NSArchiver.m: Update for GSIArray change.
	* Source/NSConnection.m: Update for GSIArray change.
	* Source/NSFileManager.m: Update for GSIArray change.
	* Source/NSNotificationCenter.m: Update for GSIArray change.
	* Source/NSObject.m: Update for GSIArray change.
	* Source/NSPortCoder.m: Update for GSIArray change.
	* Source/NSRunLoop.m: Update for GSIArray change.
	* Source/NSSerializer.m: Update for GSIArray change.
	* Source/NSUnarchiver.m: Update for GSIArray change.

2002-01-30  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSRunLoop.h: Go back to new version.
	* Source/NSRunLoop.m: Back to new (hopefully bug-free) version ...
	fixed a fence-post error in examining descriptors.  Enabled poll()
	support if the O/S supports it.  Converted to use standard debug
	logging keyed on NSRunLoop.  Fixed poll code to call any available
	event handler when an error occurs on a descriptor.
	* configure.in: Improve check for sa_len

2002-01-30  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/gnustep/base/GSIMap.h: Fix bug cleaning table and add
	option to specify type of enumerator structure externally.
	* Headers/gnustep/base/NSHashTable.h: Modify to conform to MacOS-X
	documentation and to work with GSIMAP stuff.
	* Headers/gnustep/base/NSMapTable.h: ditto
	* Headers/gnustep/base/o_array.h: deleted
	* Headers/gnustep/base/o_cbs.h: deleted
	* Headers/gnustep/base/o_hash.h: deleted
	* Headers/gnustep/base/o_list.h: deleted
	* Headers/gnustep/base/o_map.h: deleted
	* Headers/gnustep/base/o_x_bas.h.in: deleted
	* Headers/gnustep/base/o_x_cbs.h.in: deleted
	* Source/GNUmakefile: Remove o_... rules
	* Source/GSTcpPort.m: Remove unused include file
	* Source/Makefile.postamble: remove o_... rules
	* Source/NSCallBacks.h: Remove o_... info
	* Source/NSCallBacks.m: remove o_... info
	* Source/NSHashTable.m: Rewrite to use GSIMAP
	* Source/NSMapTable.m: Rewrite to use GSIMAP
	* Source/NSObject.m: Use GSIMAP for reference counts.
	* Source/NSRunLoop.m: Fix function prototypes for map table callbacks.
	* Source/externs.m: Remove o_... stuff and tidy callbacks.
	* Source/o_array.m: deleted
	* Source/o_cbs.m: deleted
	* Source/o_cbs_char_p.m: deleted
	* Source/o_cbs_id.m: deleted
	* Source/o_cbs_int.m: deleted
	* Source/o_cbs_int_p.m: deleted
	* Source/o_cbs_void_p.m: deleted
	* Source/o_hash.m: deleted
	* Source/o_list.m: deleted
	* Source/o_map.m: deleted
	* Source/o_x_bas.m.in: deleted
	* Source/o_x_cbs.m.in: deleted
	Masses of changes to simplify codebase and standardise all maptable
	code.  Hopefully, the new NSMapTable code now conforms to the spec.

2002-01-30  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSRunLoop.h: revert
	* Source/NSRunLoop.m: revert
	Revert to earlier version temporarily, while I try to track down
	an obscure bug causing problems with some DO applications.

Tue Jan 29 13:49:23 2002  Nicola Pero  <nicola@brainstorm.co.uk>

	* configure.in: Removed garbage left over - doubled message
	for objc thread flags checking.
